$Title Sets Definition
$ontext
--------------------------------------------------------------------------------
------------------------------ General Header ----------------------------------
--------------------------------------------------------------------------------
         SAM disaggregation in load blocks
         Renato Rodrigues
         Instituto de Investigacin Tecnolgica
         Date: 22, jun, 2011
--------------------------------------------------------------------------------
--------------------------- End of General Header ------------------------------
--------------------------------------------------------------------------------
$offtext

*-------------------------------------------------------------------------------
*------------------------------------- Sets ------------------------------------
*-------------------------------------------------------------------------------
*Sets defined in sets.gms

*-------------------------------------------------------------------------------
*---------------------------------- Parameters ---------------------------------
*-------------------------------------------------------------------------------
*Exogenously parameters defined in exogenous_parameters.gms

*-------------------------------------------------------------------------------
*---------------------------------- Variables ----------------------------------
*-------------------------------------------------------------------------------
*set Calibrated_Variables / OEM_VOM_SAMDIS, OEM_FOM_LABOR_SAMDIS, OEM_FOM_SC_SAMDIS, OEM_FOM_EQUIP_SAMDIS, N_SAMDIS, OWN_CONS_SAMDIS, OVERN_COSTS_SAMDIS, LOSS_SAMDIS, CO2e_CONTENT_SAMDIS, EXP_PRICE_PCTG_SAMDIS, IMP_PRICE_PCTG_SAMDIS, PF_TDeO_PCTG_SAMDIS /
set Calibrated_Variables / OEM_VOM_SAMDIS, OEM_FOM_LABOR_SAMDIS, OEM_FOM_SC_SAMDIS, OEM_FOM_EQUIP_SAMDIS, N_SAMDIS, OWN_CONS_SAMDIS, OVERN_COSTS_SAMDIS, LOSS_SAMDIS, POLLUT_CONTENT_SAMDIS, EXP_PRICE_PCTG_SAMDIS, IMP_PRICE_PCTG_SAMDIS, PF_TDeO_PCTG_SAMDIS /
*
;

Variables
*Objective variable
MAX_PCTG_DEV_SAMDIS(y,Calibrated_Variables) Objective variable to minimize
*MAX_PCTG_DEV_SAMDIS2(y)
OBJECTIVE_SAMDIS
*Main calibrated variables
OEM_VOM_SAMDIS(y,t)                      :MWh
OEM_FOM_LABOR_SAMDIS(y,l,t)              :KW
OEM_FOM_SC_SAMDIS(y,l,t)                 :KW
OEM_FOM_EQUIP_SAMDIS(y,l,t)              :KW
N_SAMDIS(y,t,f)                          MWh:t
OWN_CONS_SAMDIS(y)                       %
OVERN_COSTS_SAMDIS(y,t)
LOSS_SAMDIS(y,l,p,b)                     %

*CO2e_CONTENT_SAMDIS(y,t,f)               p.u.
POLLUT_CONTENT_SAMDIS(y,t,f,pollut)      p.u.

EXP_PRICE_PCTG_SAMDIS(y)                 %
IMP_PRICE_PCTG_SAMDIS(y)                 %
PF_TDeO_PCTG_SAMDIS(y,pf)                %

MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS(y,l,p,b)  millions 

*Deviations
N_OEM_VOM_SAMDIS(y,t)
P_OEM_VOM_SAMDIS(y,t)
N_OEM_FOM_LABOR_SAMDIS(y,l,t)
P_OEM_FOM_LABOR_SAMDIS(y,l,t)
N_OEM_FOM_SC_SAMDIS(y,l,t)
P_OEM_FOM_SC_SAMDIS(y,l,t)
N_OEM_FOM_EQUIP_SAMDIS(y,l,t)
P_OEM_FOM_EQUIP_SAMDIS(y,l,t)
N_N_SAMDIS(y,t,f)
P_N_SAMDIS(y,t,f)
N_OWN_CONS_SAMDIS(y)
P_OWN_CONS_SAMDIS(y)
N_OVERN_COSTS_SAMDIS(y,t)
P_OVERN_COSTS_SAMDIS(y,t)
N_LOSS_SAMDIS(y,l,p,b)
P_LOSS_SAMDIS(y,l,p,b)
N_EXP_PRICE_PCTG_SAMDIS(y)
P_EXP_PRICE_PCTG_SAMDIS(y)
N_IMP_PRICE_PCTG_SAMDIS(y)
P_IMP_PRICE_PCTG_SAMDIS(y)
P_PF_TDeO_PCTG_SAMDIS(y,pf)
N_PF_TDeO_PCTG_SAMDIS(y,pf)

N_POLLUT_CONTENT_SAMDIS(y,t,f,pollut)
P_POLLUT_CONTENT_SAMDIS(y,t,f,pollut)
*N_CO2e_CONTENT_SAMDIS(y,t,f)
*P_CO2e_CONTENT_SAMDIS(y,t,f)

*Electricity extended SAM accounts
E_II_QE_GEN_SAMDIS(y,gne,l,gp,gb,t)      millions 
E_II_EE_GEN_SAMDIS(y,l,dp,db,gp,gb,t)    millions 
E_F_E_GEN_SAMDIS(y,pf,l,gp,gb,t)         millions 
E_TAX_E_GEN_SAMDIS(y,tx,l,gp,gb,t)       millions 
E_TAX_E_GEN_PER_BLOCK_SAMDIS(y,tx,l,gp,gb)      millions 
*E_PRODUCTION_TAX_E_GEN_SAMDIS(y,l,gp,gb) millions 
E_M_E_GEN_SAMDIS(y,l,gp,gb)              millions 
E_II_EQ_ENERGY_SAMDIS(y,sne,l,dp,db)     millions 
E_I_ENERGY_SAMDIS(y,i,l,dp,db)           millions 
E_EX_ENERGY_SAMDIS(y,l,dp,db)            millions 
E_II_QE_TDeO_SAMDIS(y,gne)               millions 
E_II_EE_TDeO_SAMDIS(y,l,dp,db)           millions 
E_F_E_TDeO_SAMDIS(y,pf)                  millions 
E_TAX_E_TDeO_SAMDIS(y,tx)                millions 
E_M_E_TDeO_SAMDIS(y)                     millions 
E_II_EQ_POWER_SAMDIS(y,sne)              millions 
E_I_POWER_SAMDIS(y,i)                    millions 
E_EX_POWER_SAMDIS(y)                     millions 
*Fixed and Variable generation expenditure
VAR_E_II_QE_GEN_SAMDIS(y,gne,l,gp,gb,t)  millions 
FIX_E_II_QE_GEN_SAMDIS(y,gne,l,t)        millions 
VAR_E_II_EE_GEN_SAMDIS(y,l,dp,db,gp,gb,t) millions 
FIX_E_F_E_GEN_SAMDIS(y,pf,l,t)           millions 
VAR_E_TAX_E_GEN_SAMDIS(y,tx,l,gp,gb,t)   millions 
FIX_E_TAX_E_GEN_SAMDIS(y,tx,l,t)         millions 
VAR_E_M_E_GEN_SAMDIS(y,l,gp,gb)          millions 
;

Positive Variables OEM_VOM_SAMDIS,OEM_FOM_LABOR_SAMDIS,OEM_FOM_SC_SAMDIS,OEM_FOM_EQUIP_SAMDIS,N_SAMDIS,
OWN_CONS_SAMDIS,OVERN_COSTS_SAMDIS,LOSS_SAMDIS,EXP_PRICE_PCTG_SAMDIS,IMP_PRICE_PCTG_SAMDIS,
PF_TDeO_PCTG_SAMDIS,N_OEM_VOM_SAMDIS,P_OEM_VOM_SAMDIS,
N_OEM_FOM_LABOR_SAMDIS,P_OEM_FOM_LABOR_SAMDIS,N_OEM_FOM_SC_SAMDIS,P_OEM_FOM_SC_SAMDIS,
N_OEM_FOM_EQUIP_SAMDIS,P_OEM_FOM_EQUIP_SAMDIS,N_N_SAMDIS,P_N_SAMDIS,N_OWN_CONS_SAMDIS,
P_OWN_CONS_SAMDIS,N_OVERN_COSTS_SAMDIS,P_OVERN_COSTS_SAMDIS,N_LOSS_SAMDIS,P_LOSS_SAMDIS,
N_EXP_PRICE_PCTG_SAMDIS,P_EXP_PRICE_PCTG_SAMDIS,N_IMP_PRICE_PCTG_SAMDIS,P_IMP_PRICE_PCTG_SAMDIS,
P_PF_TDeO_PCTG_SAMDIS,N_PF_TDeO_PCTG_SAMDIS,
N_POLLUT_CONTENT_SAMDIS,P_POLLUT_CONTENT_SAMDIS,
*N_CO2e_CONTENT_SAMDIS,P_CO2e_CONTENT_SAMDIS,
E_II_QE_GEN_SAMDIS,E_II_EE_GEN_SAMDIS,E_F_E_GEN_SAMDIS,E_M_E_GEN_SAMDIS,E_II_EQ_ENERGY_SAMDIS,
E_I_ENERGY_SAMDIS,E_EX_ENERGY_SAMDIS,E_II_QE_TDeO_SAMDIS,E_II_EE_TDeO_SAMDIS,E_F_E_TDeO_SAMDIS,
E_M_E_TDeO_SAMDIS,E_II_EQ_POWER_SAMDIS,E_I_POWER_SAMDIS,E_EX_POWER_SAMDIS,VAR_E_II_QE_GEN_SAMDIS,
FIX_E_II_QE_GEN_SAMDIS,VAR_E_II_EE_GEN_SAMDIS,FIX_E_F_E_GEN_SAMDIS,
VAR_E_M_E_GEN_SAMDIS;

*-------------------------------------------------------------------------------
*----------------------------- Defining Model Equations ------------------------
*-------------------------------------------------------------------------------
Equations
*Object function equation
eq_objective_function_SAMDIS
*Chebyschev deviation equations
eq_Deviation_OEM_VOM_SAMDIS(ey,t)
eq_Normalization_OEM_VOM_SAMDIS(ey,t)
eq_Deviation_OEM_FOM_LABOR_SAMDIS(ey,l,t)
eq_Normalization_OEM_FOM_LABOR_SAMDIS(ey,l,t)
eq_Deviation_OEM_FOM_SC_SAMDIS(ey,l,t)
eq_Normalization_OEM_FOM_SC_SAMDIS(ey,l,t)
eq_Deviation_OEM_FOM_EQUIP_SAMDIS(ey,l,t)
eq_Normalization_OEM_FOM_EQUIP_SAMDIS(ey,l,t)
eq_Deviation_N_SAMDIS(ey,t,f)
eq_Normalization_N_SAMDIS(ey,t,f)
eq_Deviation_OWN_CONS_SAMDIS(ey)
eq_Normalization_OWN_CONS_SAMDIS(ey)
eq_Deviation_OVERN_COSTS_SAMDIS(ey,t)
eq_Normalization_OVERN_COSTS_SAMDIS(ey,t)
eq_Deviation_LOSS_SAMDIS(ey,l,p,b)
eq_Normalization_LOSS_SAMDIS(ey,l,p,b)
eq_Deviation_EXP_PRICE_PCTG_SAMDIS(ey)
eq_Normalization_EXP_PRICE_PCTG_SAMDIS(ey)
eq_Deviation_IMP_PRICE_PCTG_SAMDIS(ey)
eq_Normalization_IMP_PRICE_PCTG_SAMDIS(ey)
eq_Deviation_PF_TDeO_PCTG_SAMDIS(ey,pf)
eq_Normalization_PF_TDeO_PCTG_SAMDIS(ey,pf)

eq_Deviation_POLLUT_CONTENT_SAMDIS(ey,t,f,pollut)
eq_Normalization_POLLUT_CONTENT_SAMDIS(ey,t,f,pollut)
*eq_Deviation_CO2e_CONTENT_SAMDIS(ey,t,f)
*eq_Normalization_CO2e_CONTENT_SAMDIS(ey,t,f)

*SAM 'Must follow' acountability equations
eq_e_II_non_electricity_goods(ey,gne)
eq_e_II_electricity_good(ey)
eq_e_F(ey,pf)
eq_e_tax(ey,tx)
eq_e_Imports(ey)
eq_e_II_elect_on_non_elect_sector(ey,sne)
eq_e_Institutions(ey,i)
eq_e_Exports(ey)
*Extended SAM accounts
eq_E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t)
eq_E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)
eq_E_F_E_GEN_SAMDIS(ey,pf,l,gp,gb,t)
eq_E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t)
eq_E_TAX_E_GEN_PER_BLOCK_SAMDIS(ey,tx,l,gp,gb)
*eq_E_PRODUCTION_TAX_E_GEN_SAMDIS(ey,l,gp,gb)
eq_E_M_E_GEN_SAMDIS(ey,l,gp,gb)
eq_E_II_EQ_ENERGY_SAMDIS(ey,sne,l,dp,db)
eq_E_I_ENERGY_SAMDIS(ey,i,l,dp,db)
eq_E_EX_ENERGY_SAMDIS(ey,l,dp,db)
*free variable eq_E_II_QE_TDeO_SAMDIS(ey,gne)
eq_E_II_EE_TDeO_SAMDIS(ey,l,dp,db)
eq_E_F_E_TDeO_SAMDIS(ey,pf)
eq_E_TAX_E_TDeO_SAMDIS(ey,tx)
*free variable eq_E_M_E_TDeO_SAMDIS(ey)
*free variable eq_E_II_EQ_POWER_SAMDIS(ey,sne)
*free variable eq_E_I_POWER_SAMDIS(ey,i)
*free variable eq_E_EX_POWER_SAMDIS(ey)
*Auxiliary equations to transform Bottom-up parameters in Top-down aggregates
eq_VAR_E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t)
eq_FIX_E_II_QE_GEN_SAMDIS(ey,gne,l,t)
eq_VAR_E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)
eq_FIX_E_F_E_GEN_SAMDIS(ey,pf,l,t)
eq_VAR_E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t)
eq_FIX_E_TAX_E_GEN_SAMDIS(ey,tx,l,t)
eq_VAR_E_M_E_GEN_SAMDIS(ey,l,gp,gb)
*Income-Expenditure equilibrium
eq_GEN_EQUILIBRIUM(ey,l,p,b)
eq_TDeO_EQUILIBRIUM(ey)
;

*-------------------------------------------------------------------------------
*------------- SAM disaggregation in load blocks and technologies --------------
*-------------------------------------------------------------------------------
*Objective function equation
eq_objective_function_SAMDIS..
OBJECTIVE_SAMDIS =e= sum(Calibrated_Variables, MAX_PCTG_DEV_SAMDIS("2005",Calibrated_Variables)) +
exec_MinMax_plus_lineal_term*(
         sum((t),N_OEM_VOM_SAMDIS("2005",t) + P_OEM_VOM_SAMDIS("2005",t))+
         sum((l,t),N_OEM_FOM_LABOR_SAMDIS("2005",l,t) + P_OEM_FOM_LABOR_SAMDIS("2005",l,t))+
         sum((l,t),N_OEM_FOM_SC_SAMDIS("2005",l,t) + P_OEM_FOM_SC_SAMDIS("2005",l,t))+
         sum((l,t),N_OEM_FOM_EQUIP_SAMDIS("2005",l,t) + P_OEM_FOM_EQUIP_SAMDIS("2005",l,t))+
         sum((t,f),N_N_SAMDIS("2005",t,f) + P_N_SAMDIS("2005",t,f))+
         N_OWN_CONS_SAMDIS("2005") + P_OWN_CONS_SAMDIS("2005")+
         sum((t),N_OVERN_COSTS_SAMDIS("2005",t) + P_OVERN_COSTS_SAMDIS("2005",t))+
         sum((l,p,b)$duration(l,p,b),N_LOSS_SAMDIS("2005",l,p,b) + P_LOSS_SAMDIS("2005",l,p,b))+
         N_EXP_PRICE_PCTG_SAMDIS("2005") + P_EXP_PRICE_PCTG_SAMDIS("2005")+
         N_IMP_PRICE_PCTG_SAMDIS("2005") + P_IMP_PRICE_PCTG_SAMDIS("2005")+
         sum((pf),N_PF_TDeO_PCTG_SAMDIS("2005",pf) + P_PF_TDeO_PCTG_SAMDIS("2005",pf)) +

*         sum((t,f)$emitting_t(t,f), N_CO2e_CONTENT_SAMDIS("2005",t,f) + P_CO2e_CONTENT_SAMDIS("2005",t,f))
         sum((t,f,pollut)$((emitting_t(t,f))and(pollutant_price("2005",pollut,"Electricity"))), N_POLLUT_CONTENT_SAMDIS("2005",t,f,pollut) + P_POLLUT_CONTENT_SAMDIS("2005",t,f,pollut))

         )/1e5
;


variable NON_LINEAL_OBJECTIVE_SAMDIS;
equation eq_NON_LINEAL_OBJECTIVE_SAMDIS;

eq_NON_LINEAL_OBJECTIVE_SAMDIS..
NON_LINEAL_OBJECTIVE_SAMDIS =e=
         sum((t)$init_oem_vom("2005",t),((N_OEM_VOM_SAMDIS("2005",t) + P_OEM_VOM_SAMDIS("2005",t))/init_oem_vom("2005",t))**2)+
         sum((l,t)$init_oem_fom_labor("2005",l,t),((N_OEM_FOM_LABOR_SAMDIS("2005",l,t) + P_OEM_FOM_LABOR_SAMDIS("2005",l,t))/init_oem_fom_labor("2005",l,t))**2)+
         sum((l,t)$init_oem_fom_social_contribution("2005",l,t),((N_OEM_FOM_SC_SAMDIS("2005",l,t) + P_OEM_FOM_SC_SAMDIS("2005",l,t))/init_oem_fom_social_contribution("2005",l,t))**2)+
         sum((l,t)$init_oem_fom_equipments("2005",l,t),((N_OEM_FOM_EQUIP_SAMDIS("2005",l,t) + P_OEM_FOM_EQUIP_SAMDIS("2005",l,t))/init_oem_fom_equipments("2005",l,t))**2)+
         sum((t,f)$thermodynamic_efficiency("2005",t,f),((N_N_SAMDIS("2005",t,f) + P_N_SAMDIS("2005",t,f))/thermodynamic_efficiency("2005",t,f))**2)+
         ((N_OWN_CONS_SAMDIS("2005") + P_OWN_CONS_SAMDIS("2005"))/init_own_cons_gen_pctg)**2+
         sum((t)$init_overnight_costs("2005",t),((N_OVERN_COSTS_SAMDIS("2005",t) + P_OVERN_COSTS_SAMDIS("2005",t))/init_overnight_costs("2005",t))**2)+
         sum((l,p,b)$(tdeo_losses_pctg(l,p,b) and duration(l,p,b)),((N_LOSS_SAMDIS("2005",l,p,b) + P_LOSS_SAMDIS("2005",l,p,b))/tdeo_losses_pctg(l,p,b))**2)+
         ((N_EXP_PRICE_PCTG_SAMDIS("2005") + P_EXP_PRICE_PCTG_SAMDIS("2005"))/initial_prop_export_energy_only_price)**2+
         ((N_IMP_PRICE_PCTG_SAMDIS("2005") + P_IMP_PRICE_PCTG_SAMDIS("2005"))/initial_prop_import_energy_only_price)**2+
         sum((pf),((N_PF_TDeO_PCTG_SAMDIS("2005",pf) + P_PF_TDeO_PCTG_SAMDIS("2005",pf))/initial_pf_pct_adj(pf))**2)+

*         sum((t,f)$emitting_t(t,f), ((N_CO2e_CONTENT_SAMDIS("2005",t,f) + P_CO2e_CONTENT_SAMDIS("2005",t,f))/co2e_content(f,t) )**2)

         sum((t,f,pollut)$((emitting_t(t,f))and(pollutant_price("2005",pollut,"Electricity"))), ((N_POLLUT_CONTENT_SAMDIS("2005",t,f,pollut) + P_POLLUT_CONTENT_SAMDIS("2005",t,f,pollut))/pollutant_content(t,f,pollut) )**2)

;

*Chebyschev deviation equations
eq_Deviation_OEM_VOM_SAMDIS(ey,t)..
OEM_VOM_SAMDIS(ey,t) - init_oem_vom(ey,t) + N_OEM_VOM_SAMDIS(ey,t) - P_OEM_VOM_SAMDIS(ey,t) =e= 0;
eq_Normalization_OEM_VOM_SAMDIS(ey,t)..
N_OEM_VOM_SAMDIS(ey,t) + P_OEM_VOM_SAMDIS(ey,t) =l= MAX_PCTG_DEV_SAMDIS(ey,"OEM_VOM_SAMDIS")*init_oem_vom(ey,t);
eq_Deviation_OEM_FOM_LABOR_SAMDIS(ey,l,t)..
OEM_FOM_LABOR_SAMDIS(ey,l,t) - init_oem_fom_labor(ey,l,t) + N_OEM_FOM_LABOR_SAMDIS(ey,l,t) - P_OEM_FOM_LABOR_SAMDIS(ey,l,t) =e= 0;
eq_Normalization_OEM_FOM_LABOR_SAMDIS(ey,l,t)..
N_OEM_FOM_LABOR_SAMDIS(ey,l,t) + P_OEM_FOM_LABOR_SAMDIS(ey,l,t) =l= MAX_PCTG_DEV_SAMDIS(ey,"OEM_FOM_LABOR_SAMDIS")*init_oem_fom_labor(ey,l,t);
eq_Deviation_OEM_FOM_SC_SAMDIS(ey,l,t)..
OEM_FOM_SC_SAMDIS(ey,l,t) - init_oem_fom_social_contribution(ey,l,t) + N_OEM_FOM_SC_SAMDIS(ey,l,t) - P_OEM_FOM_SC_SAMDIS(ey,l,t) =e= 0;
eq_Normalization_OEM_FOM_SC_SAMDIS(ey,l,t)..
N_OEM_FOM_SC_SAMDIS(ey,l,t) + P_OEM_FOM_SC_SAMDIS(ey,l,t) =l= MAX_PCTG_DEV_SAMDIS(ey,"OEM_FOM_SC_SAMDIS")*init_oem_fom_social_contribution(ey,l,t);
eq_Deviation_OEM_FOM_EQUIP_SAMDIS(ey,l,t)..
OEM_FOM_EQUIP_SAMDIS(ey,l,t) - init_oem_fom_equipments(ey,l,t) + N_OEM_FOM_EQUIP_SAMDIS(ey,l,t) - P_OEM_FOM_EQUIP_SAMDIS(ey,l,t) =e= 0;
eq_Normalization_OEM_FOM_EQUIP_SAMDIS(ey,l,t)..
N_OEM_FOM_EQUIP_SAMDIS(ey,l,t) + P_OEM_FOM_EQUIP_SAMDIS(ey,l,t) =l= MAX_PCTG_DEV_SAMDIS(ey,"OEM_FOM_EQUIP_SAMDIS")*init_oem_fom_equipments(ey,l,t);
eq_Deviation_N_SAMDIS(ey,t,f)..
N_SAMDIS(ey,t,f) - thermodynamic_efficiency(ey,t,f) + N_N_SAMDIS(ey,t,f) - P_N_SAMDIS(ey,t,f) =e= 0;
eq_Normalization_N_SAMDIS(ey,t,f)..
N_N_SAMDIS(ey,t,f) + P_N_SAMDIS(ey,t,f) =l= MAX_PCTG_DEV_SAMDIS(ey,"N_SAMDIS")*thermodynamic_efficiency(ey,t,f);
eq_Deviation_OWN_CONS_SAMDIS(ey)..
OWN_CONS_SAMDIS(ey) - init_own_cons_gen_pctg + N_OWN_CONS_SAMDIS(ey) - P_OWN_CONS_SAMDIS(ey) =e= 0;
eq_Normalization_OWN_CONS_SAMDIS(ey)..
N_OWN_CONS_SAMDIS(ey) + P_OWN_CONS_SAMDIS(ey) =l= MAX_PCTG_DEV_SAMDIS(ey,"OWN_CONS_SAMDIS")*init_own_cons_gen_pctg;
eq_Deviation_OVERN_COSTS_SAMDIS(ey,t)..
OVERN_COSTS_SAMDIS(ey,t) - init_overnight_costs(ey,t) + N_OVERN_COSTS_SAMDIS(ey,t) - P_OVERN_COSTS_SAMDIS(ey,t) =e= 0;
eq_Normalization_OVERN_COSTS_SAMDIS(ey,t)..
N_OVERN_COSTS_SAMDIS(ey,t) + P_OVERN_COSTS_SAMDIS(ey,t) =l= MAX_PCTG_DEV_SAMDIS(ey,"OVERN_COSTS_SAMDIS")*init_overnight_costs(ey,t);
eq_Deviation_LOSS_SAMDIS(ey,l,p,b)..
LOSS_SAMDIS(ey,l,p,b) - tdeo_losses_pctg(l,p,b) + N_LOSS_SAMDIS(ey,l,p,b) - P_LOSS_SAMDIS(ey,l,p,b) =e= 0;
eq_Normalization_LOSS_SAMDIS(ey,l,p,b)..
N_LOSS_SAMDIS(ey,l,p,b) + P_LOSS_SAMDIS(ey,l,p,b) =l= MAX_PCTG_DEV_SAMDIS(ey,"LOSS_SAMDIS")*tdeo_losses_pctg(l,p,b);
eq_Deviation_EXP_PRICE_PCTG_SAMDIS(ey)..
EXP_PRICE_PCTG_SAMDIS(ey) - initial_prop_export_energy_only_price + N_EXP_PRICE_PCTG_SAMDIS(ey) - P_EXP_PRICE_PCTG_SAMDIS(ey) =e= 0;
eq_Normalization_EXP_PRICE_PCTG_SAMDIS(ey)..
N_EXP_PRICE_PCTG_SAMDIS(ey) + P_EXP_PRICE_PCTG_SAMDIS(ey) =l= MAX_PCTG_DEV_SAMDIS(ey,"EXP_PRICE_PCTG_SAMDIS")*initial_prop_export_energy_only_price;
eq_Deviation_IMP_PRICE_PCTG_SAMDIS(ey)..
IMP_PRICE_PCTG_SAMDIS(ey) - initial_prop_import_energy_only_price + N_IMP_PRICE_PCTG_SAMDIS(ey) - P_IMP_PRICE_PCTG_SAMDIS(ey) =e= 0;
eq_Normalization_IMP_PRICE_PCTG_SAMDIS(ey)..
N_IMP_PRICE_PCTG_SAMDIS(ey) + P_IMP_PRICE_PCTG_SAMDIS(ey) =l= MAX_PCTG_DEV_SAMDIS(ey,"IMP_PRICE_PCTG_SAMDIS")*initial_prop_import_energy_only_price;
eq_Deviation_PF_TDeO_PCTG_SAMDIS(ey,pf)..
PF_TDeO_PCTG_SAMDIS(ey,pf) - initial_pf_pct_adj(pf) + N_PF_TDeO_PCTG_SAMDIS(ey,pf) - P_PF_TDeO_PCTG_SAMDIS(ey,pf) =e= 0;
eq_Normalization_PF_TDeO_PCTG_SAMDIS(ey,pf)..
N_PF_TDeO_PCTG_SAMDIS(ey,pf) + P_PF_TDeO_PCTG_SAMDIS(ey,pf) =l= MAX_PCTG_DEV_SAMDIS(ey,"PF_TDeO_PCTG_SAMDIS")*initial_pf_pct_adj(pf);



*eq_Deviation_CO2e_CONTENT_SAMDIS(ey,t,f,pollut)..

eq_Deviation_POLLUT_CONTENT_SAMDIS(ey,t,f,pollut)..
POLLUT_CONTENT_SAMDIS(ey,t,f,pollut) - pollutant_content(t,f,pollut) + N_POLLUT_CONTENT_SAMDIS(ey,t,f,pollut) - P_POLLUT_CONTENT_SAMDIS(ey,t,f,pollut) =e= 0;
*CO2e_CONTENT_SAMDIS(ey,t,f) - pollutant_content(t,f,"CO2e") + N_CO2e_CONTENT_SAMDIS(ey,t,f) - P_CO2e_CONTENT_SAMDIS(ey,t,f) =e= 0;

*eq_Normalization_CO2e_CONTENT_SAMDIS(ey,t,f,pollut)..
eq_Normalization_POLLUT_CONTENT_SAMDIS(ey,t,f,pollut)..
N_POLLUT_CONTENT_SAMDIS(ey,t,f,pollut) + P_POLLUT_CONTENT_SAMDIS(ey,t,f,pollut) =l= MAX_PCTG_DEV_SAMDIS(ey,"POLLUT_CONTENT_SAMDIS")*pollutant_content(t,f,pollut);
*N_CO2e_CONTENT_SAMDIS(ey,t,f) + P_CO2e_CONTENT_SAMDIS(ey,t,f) =l= MAX_PCTG_DEV_SAMDIS(ey,"CO2e_CONTENT_SAMDIS")*pollutant_content(t,f,"CO2e");

*SAM 'Must follow' acountability equations
eq_e_II_non_electricity_goods(ey,gne)..
e_ii_s(ey,gne,"Electricity") =e= sum((l,gp,gb,t), E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t)) + E_II_QE_TDeO_SAMDIS(ey,gne);
*The bellow equation (eq_e_II_electricity_good) is desconsidered in the model because there is no reason for the INE accountability consider the same level of detail on expenditures inside the electricity sector that we consider
eq_e_II_electricity_good(ey)..
e_ii_s(ey,"Electricity","Electricity") =e= sum((l,dp,db,gp,gb,t), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) + sum((l,dp,db),E_II_EE_TDeO_SAMDIS(ey,l,dp,db));
eq_e_F(ey,pf)..
e_pf_s(ey,pf,"Electricity") =e= sum((l,gp,gb,t),E_F_E_GEN_SAMDIS(ey,pf,l,gp,gb,t)) + E_F_E_TDeO_SAMDIS(ey,pf) + ( sum((l,gp,gb), MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS(ey,l,gp,gb)) )$sameas(pf,"Capital") ;
eq_e_tax(ey,tx)..
e_tx_sam(ey,tx,"Electricity") =e= sum((l,gp,gb,t),E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t)) + sum((l,gp,gb),E_TAX_E_GEN_PER_BLOCK_SAMDIS(ey,tx,l,gp,gb)) + E_TAX_E_TDeO_SAMDIS(ey,tx) ;
*+ sum((l,gp,gb),E_PRODUCTION_TAX_E_GEN_SAMDIS(ey,l,gp,gb))$(SAMEAS(tx,"Production_taxes")) +E_TAX_E_TDeO_SAMDIS(ey,tx);
eq_e_Imports(ey)..
e_m_s(ey,"Electricity") =e=  sum((l,gp,gb), E_M_E_GEN_SAMDIS(ey,l,gp,gb))+E_M_E_TDeO_SAMDIS(ey);
eq_e_II_elect_on_non_elect_sector(ey,sne)..
e_ii_s(ey,"Electricity",sne) =e=  sum((l,dp,db), E_II_EQ_ENERGY_SAMDIS(ey,sne,l,dp,db)) + E_II_EQ_POWER_SAMDIS(ey,sne);
eq_e_Institutions(ey,i)..
e_g_i(ey,"Electricity",i) =e= sum((l,dp,db), E_I_ENERGY_SAMDIS(ey,i,l,dp,db)) + E_I_POWER_SAMDIS(ey,i);
eq_e_Exports(ey)..
e_g_ex(ey,"Electricity") =e= sum((l,dp,db), E_EX_ENERGY_SAMDIS(ey,l,dp,db)) + E_EX_POWER_SAMDIS(ey);

*Extended SAM accounts
eq_E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t)..
E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t) =e= VAR_E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t) + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_II_QE_GEN_SAMDIS(ey,gne,l,t);
eq_E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)..
E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t) =e=  VAR_E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t);
eq_E_F_E_GEN_SAMDIS(ey,pf,l,gp,gb,t)..
E_F_E_GEN_SAMDIS(ey,pf,l,gp,gb,t) =e= BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_F_E_GEN_SAMDIS(ey,pf,l,t);
eq_E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t)..
E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t)=e= VAR_E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t) + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_TAX_E_GEN_SAMDIS(ey,tx,l,t);

eq_E_TAX_E_GEN_PER_BLOCK_SAMDIS(ey,tx,l,gp,gb)..
E_TAX_E_GEN_PER_BLOCK_SAMDIS(ey,tx,l,gp,gb) =e= ( BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*e_tx_sam(ey,tx,"Electricity") )$(SAMEAS(tx,"Production_taxes"));
*eq_E_PRODUCTION_TAX_E_GEN_SAMDIS(ey,l,gp,gb)..
*E_PRODUCTION_TAX_E_GEN_SAMDIS(ey,l,gp,gb) =e= BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*e_tx_sam(ey,"Production_Taxes","Electricity");

eq_E_M_E_GEN_SAMDIS(ey,l,gp,gb)..
E_M_E_GEN_SAMDIS(ey,l,gp,gb) =e= VAR_E_M_E_GEN_SAMDIS(ey,l,gp,gb);
eq_E_II_EQ_ENERGY_SAMDIS(ey,sne,l,dp,db)..
E_II_EQ_ENERGY_SAMDIS(ey,sne,l,dp,db) =e= demand(ey,sne,l,dp,db)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6;
eq_E_I_ENERGY_SAMDIS(ey,i,l,dp,db)..
E_I_ENERGY_SAMDIS(ey,i,l,dp,db) =e= demand(ey,i,l,dp,db)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6;
eq_E_EX_ENERGY_SAMDIS(ey,l,dp,db)..
E_EX_ENERGY_SAMDIS(ey,l,dp,db) =e= demand(ey,"Exports",l,dp,db)*duration(l,dp,db)*EXP_PRICE_PCTG_SAMDIS(ey)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 ;
*free variable eq_E_II_QE_TDeO_SAMDIS(ey,gne)..
eq_E_II_EE_TDeO_SAMDIS(ey,l,dp,db)..
E_II_EE_TDeO_SAMDIS(ey,l,dp,db) =e= (LOSS_SAMDIS(ey,l,dp,db)*( sum((t,f)$t_f(t,f),pgen_SAMDIS(ey,t,f,l,dp,db)) + pimported(ey,l,dp,db) - ppumped_SAMDIS(ey,l,dp,db) + demand(ey,"Exports",l,dp,db)  )*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db)) / 10**6 ;
eq_E_F_E_TDeO_SAMDIS(ey,pf)..
E_F_E_TDeO_SAMDIS(ey,pf) =e= ( PF_TDeO_PCTG_SAMDIS(ey,pf)*total_labor_expenditure(ey,"TDeO")*(1-social_contribution_aliquot)/ 10**6 )$ (SAMEAS(pf,"Labor") ) + ( PF_TDeO_PCTG_SAMDIS(ey,pf)*(tdeo_amortization_expenditure(ey)/10**6 + tdeo_new_investments(ey)/10**6) )$ (SAMEAS(pf,"Capital") );
eq_E_TAX_E_TDeO_SAMDIS(ey,tx)..
E_TAX_E_TDeO_SAMDIS(ey,tx)=e= ( e_tx_sam(ey,tx,"Electricity")-sum((l,gp,gb,t),E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t))  )$ (SAMEAS(tx,"Production_taxes") or SAMEAS(tx,"Product_tax")) +
                              ( 0 )$ (SAMEAS(tx,"CO2_Payments"))
                               + ( social_contribution_aliquot*PF_TDeO_PCTG_SAMDIS.l(ey,"Labor")*total_labor_expenditure(ey,"TDeO")  / 10**6 )$( SAMEAS(tx,"Social_Contributions") );
*free variable eq_E_M_E_TDeO_SAMDIS(ey)..
*free variable eq_E_II_EQ_POWER_SAMDIS(ey,sne)..
*free variable eq_E_I_POWER_SAMDIS(ey,i)..
*free variable eq_E_EX_POWER_SAMDIS(ey)..
*Auxiliary equations to transform Bottom-up parameters in Top-down aggregates
eq_VAR_E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t)..
VAR_E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t) =e=
         ( OEM_VOM_SAMDIS(ey,t)*sum(f,pgen_SAMDIS(ey,t,f,l,gp,gb))*duration(l,gp,gb) / 10**6 )$(SAMEAS(gne,"Manufactures")) +
         ( sum((f)$(s_f(gne,f) and t_f(t,f)), N_SAMDIS(ey,t,f)*fuel_price(ey,t,f)*pgen_SAMDIS(ey,t,f,l,gp,gb)*duration(l,gp,gb) / 10**6 ) )$((duration(l,gp,gb)<>0) and (t_s(t,gne)) and ((SAMEAS(gne,"Coal") OR SAMEAS(gne,"Oil-Nuclear") OR SAMEAS(gne,"Gas"))));
eq_FIX_E_II_QE_GEN_SAMDIS(ey,gne,l,t)..
FIX_E_II_QE_GEN_SAMDIS(ey,gne,l,t) =e=
         ( OEM_FOM_EQUIP_SAMDIS(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(gne,"Manufactures"));
eq_VAR_E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)..
VAR_E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t) =e=
         ( sum((f)$t_f(t,f), OWN_CONS_SAMDIS(ey)*pgen_SAMDIS(ey,t,f,l,gp,gb)*duration(l,gp,gb)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 ) )$((sameas(dp,gp)) and (sameas(db,gb))) +
         ( ppumped_SAMDIS(ey,l,gp,gb)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 )$(SAMEAS(t,"Pump") and SAMEAS(dp,gp) and SAMEAS(db,gb));
eq_FIX_E_F_E_GEN_SAMDIS(ey,pf,l,t)..
FIX_E_F_E_GEN_SAMDIS(ey,pf,l,t) =e=
         ( OEM_FOM_LABOR_SAMDIS(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(pf,"Labor") ) +
         ( OVERN_COSTS_SAMDIS(ey,t)*idc(t)*capital_recovery_factor(t)*existent_installed_capacity_to_be_amortized(ey,l,t)/ 10**3 )$ (SAMEAS(pf,"Capital") )
         ;
eq_VAR_E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t)..
VAR_E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t) =e=
         ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) ) )$(SAMEAS(tx,"Product_tax")) +
*** tax exports
*         ( sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*CO2e_CONTENT_SAMDIS(ey,t,f)/1e6*co2_price(ey)*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));
*         ( sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*CO2e_CONTENT_SAMDIS(ey,t,f)/1e6*pollutant_price(ey,"CO2e","Electricity")*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));

         ( sum((f,pollut)$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*POLLUT_CONTENT_SAMDIS(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity")*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));



$ontext
         ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) ) )$(SAMEAS(tx,"Product_tax")) +
         ( tx_rate(ey,"Electricity",tx)*(
                 sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))
                 +sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t))
                 + sum(pf, E_F_E_GEN_SAMDIS(ey,pf,l,gp,gb,t))
                 + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_TAX_E_GEN_SAMDIS(ey,"Social_Contributions",l,t)
                 + VAR_E_TAX_E_GEN_SAMDIS(ey,"Product_Tax",l,gp,gb,t)
                 + VAR_E_TAX_E_GEN_SAMDIS(ey,"CO2_Payments",l,gp,gb,t)
*- exec_emiss_rights*( co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)*sum(f,pgen_SAMDIS(ey,t,f,l,gp,gb)*duration(l,gp,gb)) )  ) )$(SAMEAS(tx,"Production_Taxes")) +
           ) )$(SAMEAS(tx,"Production_Taxes")) +
         ( sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*CO2e_CONTENT_SAMDIS(ey,t,f)/1e6*co2_price(ey)*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));
$offtext

eq_FIX_E_TAX_E_GEN_SAMDIS(ey,tx,l,t)..
FIX_E_TAX_E_GEN_SAMDIS(ey,tx,l,t) =e= ( OEM_FOM_SC_SAMDIS(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(tx,"Social_Contributions") ) ;

eq_VAR_E_M_E_GEN_SAMDIS(ey,l,gp,gb)..
VAR_E_M_E_GEN_SAMDIS(ey,l,gp,gb) =e=
         ( pimported(ey,l,gp,gb)*duration(l,gp,gb)*IMP_PRICE_PCTG_SAMDIS(ey)*energy_only_price_SAMDIS(ey,l,gp,gb) / 10**6);
*Income-Expenditure equilibrium
eq_GEN_EQUILIBRIUM(ey,l,p,b)$duration(l,p,b)..
E_II_EE_TDeO_SAMDIS(ey,l,p,b) +  sum(i,E_I_ENERGY_SAMDIS(ey,i,l,p,b)) + E_EX_ENERGY_SAMDIS(ey,l,p,b) + sum(sne, E_II_EQ_ENERGY_SAMDIS(ey,sne,l,p,b)) + sum((gp,gb,t), E_II_EE_GEN_SAMDIS(ey,l,p,b,gp,gb,t))
=e=
sum((gne,t), E_II_QE_GEN_SAMDIS(ey,gne,l,p,b,t)) + sum((pf,t), E_F_E_GEN_SAMDIS(ey,pf,l,p,b,t)) +
sum((tx,t),E_TAX_E_GEN_SAMDIS(ey,tx,l,p,b,t)) + sum((tx),E_TAX_E_GEN_PER_BLOCK_SAMDIS(ey,tx,l,p,b))
+ E_M_E_GEN_SAMDIS(ey,l,p,b) + sum((dp,db,t), E_II_EE_GEN_SAMDIS(ey,l,dp,db,p,b,t))
*- exec_emiss_rights*( sum(t$ ( NOT (sum((f,p_alias,b_alias)$emitting_t(t,f),pgen_SAMDIS(ey,t,f,l,p_alias,b_alias))=0) ),  co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)* ( sum(f, pgen_SAMDIS(ey,t,f,l,p,b)*duration(l,p,b))/sum((f,p_alias,b_alias), pgen_SAMDIS(ey,t,f,l,p_alias,b_alias)*duration(l,p_alias,b_alias)) ) ) +
*                      sum(t$       (sum((f,p_alias,b_alias)$emitting_t(t,f),pgen_SAMDIS(ey,t,f,l,p_alias,b_alias))=0),    co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)* ( duration(l,p,b))/sum((p_alias,b_alias), duration(l,p_alias,b_alias)) ) )

- exec_emiss_rights*( sum(t$ ( NOT (sum((f,p_alias,b_alias)$emitting_t(t,f),pgen_SAMDIS(ey,t,f,l,p_alias,b_alias))=0) ),  co2_emission_rights_assignment_GEN_technology(ey,t)*pollutant_price(ey,"CO2e_ETS","Electricity")* ( sum(f, pgen_SAMDIS(ey,t,f,l,p,b)*duration(l,p,b))/sum((f,p_alias,b_alias), pgen_SAMDIS(ey,t,f,l,p_alias,b_alias)*duration(l,p_alias,b_alias)) ) ) +
                      sum(t$       (sum((f,p_alias,b_alias)$emitting_t(t,f),pgen_SAMDIS(ey,t,f,l,p_alias,b_alias))=0),    co2_emission_rights_assignment_GEN_technology(ey,t)*pollutant_price(ey,"CO2e_ETS","Electricity")* ( duration(l,p,b))/sum((p_alias,b_alias), duration(l,p_alias,b_alias)) ) )
+ MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS(ey,l,p,b);

eq_TDeO_EQUILIBRIUM(ey)..
sum((gne),E_II_QE_TDeO_SAMDIS(ey,gne)) + sum((l,dp,db),E_II_EE_TDeO_SAMDIS(ey,l,dp,db)) + sum(pf,E_F_E_TDeO_SAMDIS(ey,pf)) + sum(tx,E_TAX_E_TDeO_SAMDIS(ey,tx)) + E_M_E_TDeO_SAMDIS(ey)
=e=
sum((sne), E_II_EQ_POWER_SAMDIS(ey,sne)) + sum(i,E_I_POWER_SAMDIS(ey,i)) + E_EX_POWER_SAMDIS(ey);

*-------------------------------------------------------------------------------
*------------------------------ Variables initial values -----------------------
*-------------------------------------------------------------------------------
*---------Initializing variables-------------------------
OEM_VOM_SAMDIS.l(ey,t)=init_oem_vom(ey,t);
OEM_FOM_LABOR_SAMDIS.l(ey,l,t)=init_oem_fom_labor(ey,l,t);
OEM_FOM_SC_SAMDIS.l(ey,l,t)=init_oem_fom_social_contribution(ey,l,t);
OEM_FOM_EQUIP_SAMDIS.l(ey,l,t)=init_oem_fom_equipments(ey,l,t);
N_SAMDIS.l(ey,t,f)=thermodynamic_efficiency(ey,t,f);
OWN_CONS_SAMDIS.l(ey)=init_own_cons_gen_pctg;
OVERN_COSTS_SAMDIS.l(ey,t)=init_overnight_costs(ey,t);
LOSS_SAMDIS.l(ey,l,p,b)=tdeo_losses_pctg(l,p,b);
EXP_PRICE_PCTG_SAMDIS.l(ey)=1;
IMP_PRICE_PCTG_SAMDIS.L(ey)=1;
PF_TDeO_PCTG_SAMDIS.l(y,pf)=1;
*CO2e_CONTENT_SAMDIS.l(ey,t,f)=co2e_content(f,t);
*CO2e_CONTENT_SAMDIS.l(ey,t,f)=pollutant_content(t,f,"CO2e");

POLLUT_CONTENT_SAMDIS.l(ey,t,f,pollut)=pollutant_content(t,f,pollut);

MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS.l(ey,l,p,b)=BU_market_failures_and_non_accounted_costs(ey,l,p,b);
VAR_E_II_QE_GEN_SAMDIS.l(ey,gne,l,gp,gb,t)=( OEM_VOM_SAMDIS.l(ey,t)*sum(f,pgen_SAMDIS(ey,t,f,l,gp,gb))*duration(l,gp,gb) / 10**6 )$(SAMEAS(gne,"Manufactures")) + ( sum((f)$(s_f(gne,f) and t_f(t,f)), N_SAMDIS.l(ey,t,f)*fuel_price(ey,t,f)*pgen_SAMDIS(ey,t,f,l,gp,gb)*duration(l,gp,gb) / 10**6 ) )$((duration(l,gp,gb)<>0) and (t_s(t,gne)) and ((SAMEAS(gne,"Coal") OR SAMEAS(gne,"Oil-Nuclear") OR SAMEAS(gne,"Gas"))));
FIX_E_II_QE_GEN_SAMDIS.l(ey,gne,l,t)=( OEM_FOM_EQUIP_SAMDIS.l(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(gne,"Manufactures"));
VAR_E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t)= ( sum((f)$t_f(t,f), OWN_CONS_SAMDIS.l(ey)*pgen_SAMDIS(ey,t,f,l,gp,gb)*duration(l,gp,gb)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 ) )$((sameas(dp,gp)) and (sameas(db,gb))) + ( ppumped_SAMDIS(ey,l,gp,gb)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 )$(SAMEAS(t,"Pump") and SAMEAS(dp,gp) and SAMEAS(db,gb));
FIX_E_F_E_GEN_SAMDIS.l(ey,pf,l,t)=( OEM_FOM_LABOR_SAMDIS.l(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(pf,"Labor") ) + ( OVERN_COSTS_SAMDIS.l(ey,t)*idc(t)*capital_recovery_factor(t)*existent_installed_capacity_to_be_amortized(ey,l,t)/ 10**3 )$ (SAMEAS(pf,"Capital") );
FIX_E_TAX_E_GEN_SAMDIS.l(ey,tx,l,t)= ( OEM_FOM_SC_SAMDIS.l(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(tx,"Social_Contributions") );
VAR_E_M_E_GEN_SAMDIS.l(ey,l,gp,gb)=( pimported(ey,l,gp,gb)*duration(l,gp,gb)*IMP_PRICE_PCTG_SAMDIS.L(ey)*energy_only_price_SAMDIS(ey,l,gp,gb) / 10**6);
E_II_EQ_ENERGY_SAMDIS.l(ey,sne,l,dp,db)=demand(ey,sne,l,dp,db)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6;
E_I_ENERGY_SAMDIS.l(ey,i,l,dp,db)= demand(ey,i,l,dp,db)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6;
E_EX_ENERGY_SAMDIS.l(ey,l,dp,db)= demand(ey,"Exports",l,dp,db)*duration(l,dp,db)*EXP_PRICE_PCTG_SAMDIS.l(ey)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 ;
E_II_EE_TDeO_SAMDIS.l(ey,l,dp,db)= (LOSS_SAMDIS.l(ey,l,dp,db)*( sum((t,f)$t_f(t,f),pgen_SAMDIS(ey,t,f,l,dp,db)) + pimported(ey,l,dp,db) - ppumped_SAMDIS(ey,l,dp,db) + demand(ey,"Exports",l,dp,db)  )*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db)) / 10**6;
E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t)=VAR_E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t);
E_II_QE_GEN_SAMDIS.l(ey,gne,l,gp,gb,t)= VAR_E_II_QE_GEN_SAMDIS.l(ey,gne,l,gp,gb,t) + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_II_QE_GEN_SAMDIS.l(ey,gne,l,t);
E_F_E_GEN_SAMDIS.l(ey,pf,l,gp,gb,t)= BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_F_E_GEN_SAMDIS.l(ey,pf,l,t);
VAR_E_TAX_E_GEN_SAMDIS.l(ey,tx,l,gp,gb,t) =
         ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS.l(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t)) ) )$(SAMEAS(tx,"Product_tax")) +
*         ( sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*CO2e_CONTENT_SAMDIS.l(ey,t,f)/1e6*co2_price(ey)*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));
*         ( sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*CO2e_CONTENT_SAMDIS.l(ey,t,f)/1e6*pollutant_price(ey,"CO2e","Electricity")*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));
         ( sum((f,pollut)$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*POLLUT_CONTENT_SAMDIS.l(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity")*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));
E_TAX_E_GEN_SAMDIS.l(ey,tx,l,gp,gb,t)= VAR_E_TAX_E_GEN_SAMDIS.l(ey,tx,l,gp,gb,t) + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_TAX_E_GEN_SAMDIS.l(ey,tx,l,t);
E_M_E_GEN_SAMDIS.l(ey,l,gp,gb)=VAR_E_M_E_GEN_SAMDIS.l(ey,l,gp,gb);
E_F_E_TDeO_SAMDIS.l(ey,pf) = ( PF_TDeO_PCTG_SAMDIS.l(ey,pf)*total_labor_expenditure(ey,"TDeO")*(1-social_contribution_aliquot)/ 10**6 )$ (SAMEAS(pf,"Labor") ) + ( PF_TDeO_PCTG_SAMDIS.l(ey,pf)*(tdeo_amortization_expenditure(ey)/10**6 + tdeo_new_investments(ey)/10**6) )$ (SAMEAS(pf,"Capital") );
E_TAX_E_TDeO_SAMDIS.l(ey,tx)= ( e_tx_sam(ey,tx,"Electricity")-sum((l,gp,gb,t),E_TAX_E_GEN_SAMDIS.l(ey,tx,l,gp,gb,t))  )$ (SAMEAS(tx,"Production_taxes") or SAMEAS(tx,"Product_tax")) +
                              ( 0 )$ (SAMEAS(tx,"CO2_Payments"))
                               + ( social_contribution_aliquot*PF_TDeO_PCTG_SAMDIS.l(ey,"Labor")*total_labor_expenditure(ey,"TDeO")  / 10**6 )$( SAMEAS(tx,"Social_Contributions") );
E_II_QE_TDeO_SAMDIS.l(ey,gne)=e_ii_s(ey,gne,"Electricity")-sum((l,gp,gb,t), E_II_QE_GEN_SAMDIS.l(ey,gne,l,gp,gb,t));
E_II_EQ_POWER_SAMDIS.l(ey,sne)=e_ii_s(ey,"Electricity",sne)-sum((l,dp,db), E_II_EQ_ENERGY_SAMDIS.l(ey,sne,l,dp,db));
E_I_POWER_SAMDIS.l(ey,i)=e_g_i(ey,"Electricity",i)-sum((l,dp,db), E_I_ENERGY_SAMDIS.l(ey,i,l,dp,db));

*---------Fixing non used load blocks--------------------
loop((l,p,b)$(not duration(l,p,b)),
E_II_QE_GEN_SAMDIS.fx(y,gne,l,p,b,t)=0;
E_II_EE_GEN_SAMDIS.fx(y,l,dp,db,p,b,t)=0;
E_II_EE_GEN_SAMDIS.fx(y,l,p,b,gp,gb,t)=0;
E_F_E_GEN_SAMDIS.fx(y,pf,l,p,b,t)=0;
E_TAX_E_GEN_SAMDIS.fx(y,tx,l,p,b,t)=0;
E_M_E_GEN_SAMDIS.fx(y,l,p,b)=0;
E_II_EQ_ENERGY_SAMDIS.fx(y,sne,l,p,b)=0;
E_I_ENERGY_SAMDIS.fx(y,i,l,p,b)=0;
E_EX_ENERGY_SAMDIS.fx(y,l,p,b)=0;
E_II_EE_TDeO_SAMDIS.fx(y,l,p,b)=0;
VAR_E_II_QE_GEN_SAMDIS.fx(y,gne,l,p,b,t)=0;
VAR_E_II_EE_GEN_SAMDIS.fx(y,l,dp,db,p,b,t)=0;
VAR_E_TAX_E_GEN_SAMDIS.fx(y,tx,l,p,b,t)=0;
VAR_E_M_E_GEN_SAMDIS.fx(y,l,p,b)=0;
);
loop ((t,f)$(not t_f(t,f)),
N_SAMDIS.fx(y,t,f)=0;
N_N_SAMDIS.fx(y,t,f)=0;
P_N_SAMDIS.fx(y,t,f)=0;
);
E_M_E_TDeO_SAMDIS.fx(ey)= 0;
E_EX_POWER_SAMDIS.fx(ey)=0;
E_TAX_E_TDeO_SAMDIS.fx(ey,"CO2_Payments")=0;


*$ontext





*$ontext
*---------Lower and Upper bounds--------------------
parameter variation_allowed max variation allowed from the initial values (useful in the quadractic solution) /.5/
         lower_bound_SAMDIS lower bound to avoid zero values at calibrated technological parameters /1e-3/;

OEM_VOM_SAMDIS.lo(y,t)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_init_oem_vom(y,t)))$(first_init_oem_vom(y,t)>lower_bound_SAMDIS);
OEM_VOM_SAMDIS.up(y,t)=((1+variation_allowed)*first_init_oem_vom(y,t))$first_init_oem_vom(y,t);
OEM_FOM_LABOR_SAMDIS.lo(y,l,t)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_init_oem_fom_labor(y,l,t)))$(first_init_oem_fom_labor(y,l,t)>lower_bound_SAMDIS);
OEM_FOM_LABOR_SAMDIS.up(y,l,t)=((1+variation_allowed)*first_init_oem_fom_labor(y,l,t))$first_init_oem_fom_labor(y,l,t);
OEM_FOM_SC_SAMDIS.lo(y,l,t)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_init_oem_fom_social_contribution(y,l,t)))$(first_init_oem_fom_social_contribution(y,l,t)>lower_bound_SAMDIS);
OEM_FOM_SC_SAMDIS.up(y,l,t)=((1+variation_allowed)*first_init_oem_fom_social_contribution(y,l,t))$first_init_oem_fom_social_contribution(y,l,t);
OEM_FOM_EQUIP_SAMDIS.lo(y,l,t)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_init_oem_fom_equipments(y,l,t)))$(first_init_oem_fom_equipments(y,l,t)>lower_bound_SAMDIS);
OEM_FOM_EQUIP_SAMDIS.up(y,l,t)=((1+variation_allowed)*first_init_oem_fom_equipments(y,l,t))$first_init_oem_fom_equipments(y,l,t);
N_SAMDIS.lo(y,t,f)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_thermodynamic_efficiency(y,t,f)))$(first_thermodynamic_efficiency(y,t,f)>lower_bound_SAMDIS);
N_SAMDIS.up(y,t,f)=((1+variation_allowed)*first_thermodynamic_efficiency(y,t,f))$first_thermodynamic_efficiency(y,t,f);
OWN_CONS_SAMDIS.lo(y)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_init_own_cons_gen_pctg))$(first_init_own_cons_gen_pctg>lower_bound_SAMDIS);
OWN_CONS_SAMDIS.up(y)=((1+variation_allowed)*first_init_own_cons_gen_pctg)$first_init_own_cons_gen_pctg;
OVERN_COSTS_SAMDIS.lo(y,t)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_init_overnight_costs(y,t)))$(first_init_overnight_costs(y,t)>lower_bound_SAMDIS);
OVERN_COSTS_SAMDIS.up(y,t)=((1+variation_allowed)*first_init_overnight_costs(y,t))$first_init_overnight_costs(y,t);
LOSS_SAMDIS.lo(y,l,p,b)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_tdeo_losses_pctg(l,p,b)))$(first_tdeo_losses_pctg(l,p,b)>lower_bound_SAMDIS);
LOSS_SAMDIS.up(y,l,p,b)=((1+variation_allowed)*first_tdeo_losses_pctg(l,p,b))$first_tdeo_losses_pctg(l,p,b);
EXP_PRICE_PCTG_SAMDIS.lo(y)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_exp_price_pctg))$(first_exp_price_pctg>lower_bound_SAMDIS);
EXP_PRICE_PCTG_SAMDIS.up(y)=((1+variation_allowed)*first_exp_price_pctg)$first_exp_price_pctg;
IMP_PRICE_PCTG_SAMDIS.lo(y)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_imp_price_pctg))$(first_imp_price_pctg>lower_bound_SAMDIS);
IMP_PRICE_PCTG_SAMDIS.up(y)=((1+variation_allowed)*first_imp_price_pctg)$first_imp_price_pctg;
PF_TDeO_PCTG_SAMDIS.lo(y,pf)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_tdeo_pf_pct_adj(pf)))$(first_tdeo_pf_pct_adj(pf)>lower_bound_SAMDIS);
PF_TDeO_PCTG_SAMDIS.up(y,pf)=((1+variation_allowed)*first_tdeo_pf_pct_adj(pf))$first_tdeo_pf_pct_adj(pf);
*CO2e_CONTENT_SAMDIS.lo(y,t,f)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_co2e_content(f,t)))$first_co2e_content(f,t);
*CO2e_CONTENT_SAMDIS.lo(y,t,f)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_pollutant_content(t,f,"CO2e")))$first_pollutant_content(t,f,"CO2e");


POLLUT_CONTENT_SAMDIS.lo(y,t,f,pollut)=(max(lower_bound_SAMDIS,(1-variation_allowed)*first_pollutant_content(t,f,pollut)))$(first_pollutant_content(t,f,pollut)>lower_bound_SAMDIS);

*CO2e_CONTENT_SAMDIS.up(y,t,f)=((1+variation_allowed)*first_co2e_content(f,t))$first_co2e_content(f,t);
*CO2e_CONTENT_SAMDIS.up(y,t,f)=((1+variation_allowed)*first_pollutant_content(t,f,"CO2e"))$first_pollutant_content(t,f,"CO2e");

POLLUT_CONTENT_SAMDIS.up(y,t,f,pollut)=((1+variation_allowed)*first_pollutant_content(t,f,pollut))$first_pollutant_content(t,f,pollut);

*$offtext


*-------------------------- Merit Order Constraint -----------------------------
parameter initial_technology_variable_cost(y,t,f);
*(f-g,gas) > (f-g,fuel-oil) > (NRSR,gas) > (ccgt,gas) > (ncoal,coal) > (icoal,coal) > (nuc,uranium) > (ORSR,NA) > (HydRes,na)=(Hyd_RoR,na)=(Pump,na) > (wind,NA)
initial_technology_variable_cost(ey,t,f)=
         exec_fc*(first_thermodynamic_efficiency(ey,t,f)*fuel_price(ey,t,f))$(thermal_t(t,f)) +
*         exec_co2*(first_co2e_content(f,t)*co2_price(ey))$(emitting_t(t,f)) +
*         (first_co2e_content(f,t)*pollutant_price(eys,"CO2e","Electricity"))$(emitting_t(t,f)) +
         (first_pollutant_content(t,f,"CO2e_ETS")*pollutant_price(ey,"CO2e_ETS","Electricity"))$(emitting_t(t,f)) +
         exec_vom*(first_init_oem_vom(ey,t))$(t_f(t,f)) -
         exec_renew_prem*(renewable_premium(ey,t))$(renewable_premium_t(t,f));

display initial_technology_variable_cost;
variable
TECH_VAR_COST(y,t,f);

equation
EQ_TECH_VAR_COST(y,t,f)
EQ_MERIT_ORDER_SAMDIS(y,t,f,t,f);

EQ_TECH_VAR_COST(ey,t,f)..
TECH_VAR_COST(ey,t,f)=e=
         exec_fc*(N_SAMDIS(ey,t,f)*fuel_price(ey,t,f))$(thermal_t(t,f)) +
*         exec_co2*(CO2e_CONTENT_SAMDIS(ey,t,f)*co2_price(ey))$(emitting_t(t,f)) +
*         exec_co2*(CO2e_CONTENT_SAMDIS(ey,t,f)*pollutant_price(ey,"CO2e","Electricity"))$(emitting_t(t,f)) +
         sum(pollut, (POLLUT_CONTENT_SAMDIS(ey,t,f,pollut)*pollutant_price(ey,pollut,"Electricity")))$(emitting_t(t,f)) +

         exec_vom*(OEM_VOM_SAMDIS(ey,t))$(t_f(t,f)) -
         exec_renew_prem*(renewable_premium(ey,t))$(renewable_premium_t(t,f));

EQ_MERIT_ORDER_SAMDIS(ey,t,f,t_alias,f_alias)$((t_f(t,f)) and (t_f(t_alias,f_alias)) and (initial_technology_variable_cost(ey,t,f)>initial_technology_variable_cost(ey,t_alias,f_alias)))..
TECH_VAR_COST(ey,t,f) =g= TECH_VAR_COST(ey,t_alias,f_alias);

*-------------------------------------------------------------------------------



*-------------------------------------------------------------------------------
*------------------------------ Defining Model ---------------------------------
*-------------------------------------------------------------------------------
Model SAMDIS
         /
*Object function equation
         eq_objective_function_SAMDIS,
*Chebyschev deviation equations
         eq_Deviation_OEM_VOM_SAMDIS,eq_Normalization_OEM_VOM_SAMDIS,
         eq_Deviation_OEM_FOM_LABOR_SAMDIS,eq_Normalization_OEM_FOM_LABOR_SAMDIS,
         eq_Deviation_OEM_FOM_SC_SAMDIS,eq_Normalization_OEM_FOM_SC_SAMDIS,
         eq_Deviation_OEM_FOM_EQUIP_SAMDIS,eq_Normalization_OEM_FOM_EQUIP_SAMDIS,
         eq_Deviation_N_SAMDIS,eq_Normalization_N_SAMDIS,
         eq_Deviation_OWN_CONS_SAMDIS,eq_Normalization_OWN_CONS_SAMDIS,
         eq_Deviation_OVERN_COSTS_SAMDIS,eq_Normalization_OVERN_COSTS_SAMDIS,
         eq_Deviation_LOSS_SAMDIS,eq_Normalization_LOSS_SAMDIS,
         eq_Deviation_EXP_PRICE_PCTG_SAMDIS,eq_Normalization_EXP_PRICE_PCTG_SAMDIS,
         eq_Deviation_IMP_PRICE_PCTG_SAMDIS,eq_Normalization_IMP_PRICE_PCTG_SAMDIS,
         eq_Deviation_PF_TDeO_PCTG_SAMDIS,eq_Normalization_PF_TDeO_PCTG_SAMDIS,
*         eq_Deviation_CO2e_CONTENT_SAMDIS,eq_Normalization_CO2e_CONTENT_SAMDIS,
         eq_Deviation_POLLUT_CONTENT_SAMDIS,eq_Normalization_POLLUT_CONTENT_SAMDIS,

*SAM 'Must follow' acountability equations
         eq_e_II_non_electricity_goods,
*Taken out         eq_e_II_electricity_good,
         eq_e_F,
         eq_e_tax,
         eq_e_Imports,
         eq_e_II_elect_on_non_elect_sector,
         eq_e_Institutions,
         eq_e_Exports,
*Extended SAM accounts
         eq_E_II_QE_GEN_SAMDIS,
         eq_E_II_EE_GEN_SAMDIS,
         eq_E_F_E_GEN_SAMDIS,
         eq_E_TAX_E_GEN_SAMDIS,
         eq_E_TAX_E_GEN_PER_BLOCK_SAMDIS,
         eq_E_M_E_GEN_SAMDIS,
         eq_E_II_EQ_ENERGY_SAMDIS,
         eq_E_I_ENERGY_SAMDIS,
         eq_E_EX_ENERGY_SAMDIS,
*free variable eq_E_II_QE_TDeO_SAMDIS(ey,gne)
         eq_E_II_EE_TDeO_SAMDIS,
*Taken out beacause limited to much the convergence on iterative approach eq_E_F_E_TDeO_SAMDIS,
*Taken out - Unfeasible - turned free variable         eq_E_TAX_E_TDeO_SAMDIS,
*free variable eq_E_M_E_TDeO_SAMDIS(ey)
*free variable eq_E_II_EQ_POWER_SAMDIS(ey,sne)
*free variable eq_E_I_POWER_SAMDIS(ey,i)
*free variable eq_E_EX_POWER_SAMDIS(ey)
*Auxiliary equations to transform Bottom-up parameters in Top-down aggregates
         eq_VAR_E_II_QE_GEN_SAMDIS,
         eq_FIX_E_II_QE_GEN_SAMDIS,
         eq_VAR_E_II_EE_GEN_SAMDIS,
         eq_FIX_E_F_E_GEN_SAMDIS,
         eq_VAR_E_TAX_E_GEN_SAMDIS,
         eq_FIX_E_TAX_E_GEN_SAMDIS,
         eq_VAR_E_M_E_GEN_SAMDIS,
*Income-Expenditure equilibrium
         eq_GEN_EQUILIBRIUM,
         eq_TDeO_EQUILIBRIUM,
         EQ_TECH_VAR_COST,
*         EQ_MERIT_ORDER_SAMDIS
         /;
*-------------------------------------------------

Model NON_LINEAL_SAMDIS
         /
         eq_NON_LINEAL_OBJECTIVE_SAMDIS,
         eq_Deviation_OEM_VOM_SAMDIS,
         eq_Deviation_OEM_FOM_LABOR_SAMDIS,
         eq_Deviation_OEM_FOM_SC_SAMDIS,
         eq_Deviation_OEM_FOM_EQUIP_SAMDIS,
         eq_Deviation_N_SAMDIS,
         eq_Deviation_OWN_CONS_SAMDIS,
         eq_Deviation_OVERN_COSTS_SAMDIS,
         eq_Deviation_LOSS_SAMDIS,
         eq_Deviation_EXP_PRICE_PCTG_SAMDIS,
         eq_Deviation_IMP_PRICE_PCTG_SAMDIS,
         eq_Deviation_PF_TDeO_PCTG_SAMDIS,
         eq_Deviation_POLLUT_CONTENT_SAMDIS
*         eq_Deviation_CO2e_CONTENT_SAMDIS
         eq_e_II_non_electricity_goods,
         eq_e_F, eq_e_tax, eq_e_Imports, eq_e_II_elect_on_non_elect_sector,
         eq_e_Institutions, eq_e_Exports, eq_E_II_QE_GEN_SAMDIS, eq_E_II_EE_GEN_SAMDIS,
         eq_E_F_E_GEN_SAMDIS, eq_E_TAX_E_GEN_SAMDIS, eq_E_TAX_E_GEN_PER_BLOCK_SAMDIS
*eq_E_PRODUCTION_TAX_E_GEN_SAMDIS
         eq_E_M_E_GEN_SAMDIS,
         eq_E_II_EQ_ENERGY_SAMDIS, eq_E_I_ENERGY_SAMDIS, eq_E_EX_ENERGY_SAMDIS,
         eq_E_II_EE_TDeO_SAMDIS, eq_VAR_E_II_QE_GEN_SAMDIS, eq_FIX_E_II_QE_GEN_SAMDIS,
         eq_VAR_E_II_EE_GEN_SAMDIS, eq_FIX_E_F_E_GEN_SAMDIS, eq_VAR_E_TAX_E_GEN_SAMDIS,
         eq_FIX_E_TAX_E_GEN_SAMDIS,
*****************         eq_E_CO2_TAX_GEN_SAMDIS,
         eq_VAR_E_M_E_GEN_SAMDIS,
*Taken out beacause limited to much the convergence on iterative approach eq_E_F_E_TDeO_SAMDIS,
         eq_TDeO_EQUILIBRIUM,eq_GEN_EQUILIBRIUM,
         EQ_TECH_VAR_COST,
*         EQ_MERIT_ORDER_SAMDIS
         /;
*-------------------------------------------------

*SAMDIS.tolinfeas = 1e-20;
*NON_LINEAL_SAMDIS.tolinfeas = 1e-20;
SAMDIS.HOLDFIXED   = 1;
NON_LINEAL_SAMDIS.HOLDFIXED   = 1;
*OPTION ITERLIM = 0;
option limcol = 1000;
option limrow = 1000;










