$Title Sets Definition
$ontext
--------------------------------------------------------------------------------
------------------------------ General Header ----------------------------------
--------------------------------------------------------------------------------
         HGEMED - Hybrid CGE Top-down and Electricity Generation Operation and Investment Bottom-up Model
         Renato Rodrigues
         Instituto de Investigacin Tecnolgica
         Date: 17, sept, 2013
--------------------------------------------------------------------------------
--------------------------- End of General Header ------------------------------
--------------------------------------------------------------------------------
$offtext


*-------------------------------------------------------------------------------
*---------------------------------- Parameters ---------------------------------
*-------------------------------------------------------------------------------


*Remaining parameters exclusive to this model
Parameters
         production_tax_TDeO(ey)
         production_tax_GEN(ey,l,p,b)

         q_m_GEN_HGEMED(y,l,p,b)
         q_ex_GEN_HGEMED(y,l,p,b)
         p_m_GEN_HGEMED(ey,l,p,b)
         p_ex_GEN_HGEMED(ey,l,p,b)
         dist_factor_HGEMED(y,l,p,b)
*         mkt_surplus_HGEMED(y,l,p,b)
         init_oem_vom_HGEMED(y,t)
         init_oem_fom_labor_HGEMED(y,l,t)
         init_oem_fom_social_contribution_HGEMED(y,l,t)
         init_oem_fom_equipments_HGEMED(y,l,t)
         thermodynamic_efficiency_HGEMED(y,t,f)
         init_own_cons_gen_pctg_HGEMED
         init_overnight_costs_HGEMED(y,t)
         tdeo_losses_pctg_HGEMED(l,p,b)
         initial_prop_export_energy_only_price_HGEMED
         initial_prop_import_energy_only_price_HGEMED
         initial_pf_pct_adj_HGEMED(pf)
*         co2e_content_HGEMED(f,t)
         pollut_content_HGEMED(y,t,f,pollut)
         emissions_allowance(ey,l,p,b,t) distributing emissions allowances by each load block according to the technology use (or total PGEN of the load block if the BU model disconsider one technology)

         c_h(ey,gne)              %       Representative household marginal propensity to consume domestic non-electricity good gne
         c_h_GEN(ey,l,p,b)        %
         c_h_TDeO(ey)             %
         q_i_pf(ey,i,pf)                  Quantity of production factor pf owned by institution i (households or government)
         s_propensity_h(ey)               Representative Household marginal propensity to save
         tx_rate_sc_tech(ey,pf,l,p,b,t)   Social contribution tax rate
         tx_rate_sc_TDeO(ey,pf)           Social contribution tax rate
         tx_rate_TDeO(ey,tx)              Tax rate (production and product taxes)
         tx_rate_tech(ey,l,p,b,t,tx)      Product tax rate
*         tx_rate_GEN(ey,l,p,b,tx)         Production tax rate
         psc_h(ey)                        Proportion of annual social contribution payments reverted directly to households
         transf_g_h(ey)                   Net transfers from the government to the households
         transf_ext_g(ey)                 Net transfers from the exterior to the government
         transf_ext_h(ey)                 Net transfers from the exterior to the households
         transf_ext_k(ey)                 Net capital transfers from the exterior
         a_va_pf(ey,pf,sne)               Share parameter of product factor on value added composite non-electricity good production function
         alpha_va(ey,sne)                 Productivity parameter of non-electricity sector value added composite good production function
         c_ii_share(ey,gne,sne)           Share parameter of non-electricity intermediate composite inputs gne used on on-electricity sector sne production function
         c_ii_share_GEN(ey,l,p,b,sne)
         c_ii_share_TDeO(ey,sne)
         c_va_share(ey,sne)               Share parameter of value added composite input used on non-electricity sector sne production function
         a_d_q(ey,gne)                    Share parameter of domestic produced supply on non-electricity sector Armington aggregate
         a_d_m(ey,gne)                    Share parameter of imports supply on non-electricity sector Armington aggregate
         alpha_d(ey,gne)                  Productivity parameter of Armington aggregated imported and domestic produced supply of non-electricity good gne
         b_q_q(ey,gne)                    Share parameter of CET domestically destined non-electricity good gne
         b_q_ex(ey,gne)                   Share parameter of CET exportation destined non-electricity good gne
         beta_q(ey,gne)                   Productivity parameter of CET export and domestically destined non-electricity good gne
         c_pf_TDeO_share(ey,pf)
         c_ii_gne_TDeO(ey,gne)
         c_ii_elec_TDeO(ey,l,dp,db)
         c_ii_TDeO_TDeO(ey)
         c_va_TDeO_share(ey)
         q_gov_initial(ey,gne)            Government initial demand for non-electricity good gne
         q_gov_GEN_initial(ey,l,p,b)
         q_gov_TDeO_initial(ey)
         Theta(ey,gne)                    Share parameter of demand for investment non-electricity good gne
         mu_cpi_GEN(ey,l,p,b)
         mu_cpi_TDeO(ey)
*Initial Variable Values
       initial_Q_H_D_HGEMED(ey,gne)
       initial_Q_H_D_GEN_HGEMED(ey,l,p,b)
       initial_Q_H_D_TDeO_HGEMED(ey)
       initial_P_PF_LABOR_HGEMED(ey)
       initial_P_PF_CAPITAL_HGEMED(ey)
       initial_Y_H_HGEMED(ey)
       initial_Q_PF_SNE_LABOR_HGEMED(ey,sne)
       initial_Q_PF_SNE_CAPITAL_HGEMED(ey,sne)
       initial_Q_VA_HGEMED(ey,sne)
       initial_P_VA_HGEMED(ey,sne)
       initial_Q_II_HGEMED(ey,gne,sne)
       initial_Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne)
       initial_Q_II_TDeO_SNE_HGEMED(ey,sne)
       initial_Q_S_HGEMED(ey,sne)
       initial_P_S_HGEMED(ey,gne)
       initial_Q_M_HGEMED(ey,gne)
       initial_Q_D_HGEMED(ey,gne)
       initial_P_D_HGEMED(ey,gne)
       initial_Q_EX_HGEMED(ey,gne)
       initial_Q_Q_HGEMED(ey,gne)
       initial_P_Q_HGEMED(ey,gne)
       initial_Q_PF_LABOR_TDeO_HGEMED(ey)
       initial_Q_PF_CAPITAL_TDeO_HGEMED(ey)
       initial_Q_VA_TDeO_HGEMED(ey)
       initial_P_VA_TDeO_HGEMED(ey)
       initial_Q_II_GNE_TDeO_HGEMED(ey,gne)
       initial_Q_II_GEN_TDeO_HGEMED(ey,l,dp,db)
       initial_Q_II_TDeO_TDeO_HGEMED(ey)
       initial_Q_S_TDeO_HGEMED(ey)
       initial_P_S_TDeO_HGEMED(ey)
       initial_Q_D_TDeO_HGEMED(ey)
       initial_P_D_TDeO_HGEMED(ey)
       initial_Q_Q_TDeO_HGEMED(ey)
       initial_P_Q_TDeO_HGEMED(ey)
       initial_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)
       initial_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t)
       initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)
       initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t)
       initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t)
       initial_Q_S_TECH_HGEMED(ey,l,p,b,t)
       initial_Q_S_GEN_HGEMED(ey,l,p,b)
       initial_P_S_GEN_HGEMED(ey,l,p,b)
       initial_Q_Q_GEN_HGEMED(ey,l,p,b)
       initial_P_Q_GEN_HGEMED(ey,l,p,b)
       initial_Y_G_HGEMED(ey)
       initial_E_G_HGEMED(ey)
       initial_Y_TAX_HGEMED(ey)
       initial_S_TOTAL_HGEMED(ey)
       initial_S_TOTAL_H_HGEMED(ey)
       initial_S_TOTAL_G_HGEMED(ey)
       initial_S_TOTAL_EXT_HGEMED(ey)
       initial_I_TOTAL_HGEMED(ey)
       initial_Q_I_D_HGEMED(ey,gne)
       initial_CPI_HGEMED(ey)
       initial_WALRAS_HGEMED(ey)
       initial_PGEN_HGEMED(y,t,f,l,p,b)
       initial_PPUMPED_HGEMED(y,l,p,b)
       initial_RES_HGEMED(y,l,p)
       initial_PINS_HGEMED(y,l,t)
       initial_INSTALLED_CAPACITY_HGEMED(y,l,t)
       initial_INCREASED_DR_LOAD_HGEMED(y,l,p,b)
       initial_DECREASED_DR_LOAD_HGEMED(y,l,p,b)
       initial_CONSERVED_DR_LOAD_HGEMED(y,l,p,b)
       initial_FUEL_PRICE_HGEMED(y,t,f)
       initial_LAMBDA_DEM_HGEMED(y,l,p,b)
       initial_LAMBDA_RES_HGEMED(y,l,p)
       initial_LAMBDA_PUMP_EFF_HGEMED(y,l,p)
       initial_LAMBDA_PUMP_MAX_HGEMED(y,l,p)
       initial_LAMBDA_DISPATCHABLE_RESERVES_HGEMED(y,l)
       initial_LAMBDA_RoR_HGEMED(y,l,p,b)
       initial_LAMBDA_FG_FUEL_OIL_USE_HGEMED(y,l,p,b)
       initial_LAMBDA_FG_NATURAL_GAS_USE_HGEMED(y,l,p,b)
       initial_LAMBDA_WIND_HGEMED(y,l,p,b)
       initial_LAMBDA_ORSR_HGEMED(y,l,p,b)
       initial_LAMBDA_PINS_CAPACITY_HGEMED(y,l,t)
       initial_LAMBDA_PINS_AVAILABILITY_HGEMED(y,t,f,l,p,b)
       initial_LAMBDA_MAX_DISPL_HGEMED(y,l,p,b)
       initial_LAMBDA_DISPL_BAL_HGEMED(y,l,p)
       initial_LAMBDA_CONSERV_LIMIT_HGEMED(y,l,p,b)
       initial_LAMBDA_REQ_SAVINGS_HGEMED(y,l,p)

       initial_mkt_surplus_HGEMED(y,l,p,b)
;

production_tax_TDeO(ey)=E_TAX_E_TDeO_SAMDIS.l(ey,"Production_Taxes");
production_tax_GEN(ey,l,p,b)=E_TAX_E_GEN_PER_BLOCK_SAMDIS.l(ey,"Production_Taxes",l,p,b);
tx_rate_tech(ey,l,p,b,t,"Product_Tax")$duration(l,p,b)=( E_TAX_E_GEN_SAMDIS.l(ey,"Product_Tax",l,p,b,t) / ( sum(gne, E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)) + sum((dp,db), E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t)) ))$(( sum(gne, E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)) + sum((dp,db), E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t)) )<>0);

q_m_GEN_HGEMED(eys,l,p,b)=pimported(eys,l,p,b)*duration(l,p,b)/1e6;
q_ex_GEN_HGEMED(eys,l,p,b)=demand(eys,"Exports",l,p,b)*duration(l,p,b)/1e6;
p_m_GEN_HGEMED(ey,l,p,b)$duration(l,p,b)=E_M_E_GEN_SAMDIS.l(ey,l,p,b)/q_m_GEN_HGEMED(ey,l,p,b);
p_ex_GEN_HGEMED(ey,l,p,b)$duration(l,p,b)=E_EX_ENERGY_SAMDIS.l(ey,l,p,b)/q_ex_GEN_HGEMED(ey,l,p,b);

initial_mkt_surplus_HGEMED(ey,l,p,b) = MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS.l(ey,l,p,b);
*mkt_surplus_HGEMED(ey,l,p,b)$duration(l,p,b) = MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS.l(ey,l,p,b);
*dist_factor_HGEMED(ey,l,p,b)$duration(l,p,b)= (mkt_surplus_HGEMED(ey,l,p,b)) / sum((gp_alias,gb_alias)$duration(l,gp_alias,gb_alias), mkt_surplus_HGEMED(ey,l,gp_alias,gb_alias)*duration(l,gp_alias,gb_alias));


*mkt_surplus_HGEMED(ey,l,p,b)$duration(l,p,b) = MARKET_FAILURES_AND_NON_ACCOUNTED_COSTS_SAMDIS.l(ey,l,p,b);


dist_factor_HGEMED(ey,l,p,b)$duration(l,p,b) = BU_dist_factor(ey,l,p,b);

init_oem_vom_HGEMED(y,t)=sum(ey,OEM_VOM_SAMDIS.l(ey,t));
init_oem_fom_labor_HGEMED(y,l,t)=OEM_FOM_LABOR_SAMDIS.l("2005",l,t);
init_oem_fom_social_contribution_HGEMED(y,l,t)=sum(ey,OEM_FOM_SC_SAMDIS.l(ey,l,t));
init_oem_fom_equipments_HGEMED(y,l,t)=sum(ey,OEM_FOM_EQUIP_SAMDIS.l(ey,l,t));
thermodynamic_efficiency_HGEMED(y,t,f)=sum(ey,N_SAMDIS.l(ey,t,f));
init_own_cons_gen_pctg_HGEMED=sum(ey,OWN_CONS_SAMDIS.l(ey));
init_overnight_costs_HGEMED(y,t)=sum(ey,OVERN_COSTS_SAMDIS.l(ey,t));
tdeo_losses_pctg_HGEMED(l,p,b)=sum(ey,LOSS_SAMDIS.l(ey,l,p,b));
initial_prop_export_energy_only_price_HGEMED=sum(ey,EXP_PRICE_PCTG_SAMDIS.l(ey));
initial_prop_import_energy_only_price_HGEMED=sum(ey,IMP_PRICE_PCTG_SAMDIS.l(ey));
initial_pf_pct_adj_HGEMED(pf)=sum(ey,PF_TDeO_PCTG_SAMDIS.l(ey,pf));

*co2e_content_HGEMED(f,t)=sum(ey,CO2e_CONTENT_SAMDIS.l(ey,t,f));
pollut_content_HGEMED(eys,t,f,pollut)=sum(ey,POLLUT_CONTENT_SAMDIS.l(ey,t,f,pollut));

psc_h(ey)=e_i_tx(ey,"Households","Social_Contributions")/sum(i,e_i_tx(ey,i,"Social_Contributions"));

tx_rate_sc_tech(ey,"Labor",l,p,b,t)$E_TAX_E_GEN_SAMDIS.l(ey,"Social_Contributions",l,p,b,t)=( E_TAX_E_GEN_SAMDIS.l(ey,"Social_Contributions",l,p,b,t)/E_F_E_GEN_SAMDIS.l(ey,"Labor",l,p,b,t) );
tx_rate_sc_TDeO(ey,"Labor")$E_F_E_TDeO_SAMDIS.l(ey,"Labor")=E_TAX_E_TDeO_SAMDIS.l(ey,"Social_Contributions")/E_F_E_TDeO_SAMDIS.l(ey,"Labor");
transf_g_h(ey)=e_transf_i(ey,"Households","Government")-e_transf_i(ey,"Government","Households");
transf_ext_g(ey)=e_transf_k_ext_i(ey,"Government")-e_transf_k_i_ext(ey,"Government");
transf_ext_h(ey)=e_transf_k_ext_i(ey,"Households")-e_transf_k_i_ext(ey,"Households");
transf_ext_k(ey)=e_transf_k_ext_spain(ey);


initial_LAMBDA_DEM_HGEMED(eys,l,p,b)=LAMBDA_DEM.l(eys,l,p,b);
initial_LAMBDA_RES_HGEMED(eys,l,p)=LAMBDA_RES.l(eys,l,p);
initial_LAMBDA_PUMP_EFF_HGEMED(eys,l,p)=LAMBDA_PUMP_EFF.l(eys,l,p);
initial_LAMBDA_PUMP_MAX_HGEMED(eys,l,p)=LAMBDA_PUMP_MAX.l(eys,l,p);
initial_LAMBDA_DISPATCHABLE_RESERVES_HGEMED(eys,l)=LAMBDA_DISPATCHABLE_RESERVES.l(eys,l);
initial_LAMBDA_RoR_HGEMED(eys,l,p,b)=LAMBDA_RoR.l(eys,l,p,b);
initial_LAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b)=LAMBDA_FG_FUEL_OIL_USE.l(eys,l,p,b);
initial_LAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b)=LAMBDA_FG_NATURAL_GAS_USE.l(eys,l,p,b);
initial_LAMBDA_WIND_HGEMED(eys,l,p,b)=LAMBDA_WIND.l(eys,l,p,b);
initial_LAMBDA_ORSR_HGEMED(eys,l,p,b)=LAMBDA_ORSR.l(eys,l,p,b);
initial_LAMBDA_PINS_CAPACITY_HGEMED(eys,l,t)=LAMBDA_PINS_CAPACITY.l(eys,l,t);
initial_LAMBDA_PINS_AVAILABILITY_HGEMED(eys,t,f,l,p,b)=LAMBDA_PINS_AVAILABILITY.l(eys,t,f,l,p,b);


*initial_LAMBDA_MAX_DISPL_HGEMED(eys,l,p,b)=LAMBDA_MAX_DISPL.l(eys,l,p,b);
*initial_LAMBDA_DISPL_BAL_HGEMED(eys,l,p)=LAMBDA_DISPL_BAL.l(eys,l,p);
*initial_LAMBDA_CONSERV_LIMIT_HGEMED(eys,l,p,b)=LAMBDA_CONSERV_LIMIT.l(eys,l,p,b);
*initial_LAMBDA_REQ_SAVINGS_HGEMED(eys,l,p)=LAMBDA_REQ_SAVINGS.l(eys,l,p);

initial_P_PF_LABOR_HGEMED(ey)=p_pf_initial(ey,"Labor");
initial_P_PF_CAPITAL_HGEMED(ey)=p_pf_initial(ey,"Capital");
initial_P_VA_HGEMED(ey,sne)=p_va_initial(ey,sne);
initial_P_D_HGEMED(ey,gne)=p_d_initial(ey,gne);

initial_P_S_HGEMED(ey,gne)=p_s_initial(ey,gne);

*initial_P_Q_HGEMED(ey,gne) = e_g_i(ey,gne,"Households")/ (demand(eys,"households",l,p,b)*duration(l,p,b)/1e6);
initial_P_Q_HGEMED(ey,gne)=p_q_initial(ey,gne);

initial_P_VA_TDeO_HGEMED(ey)=1;
initial_P_S_TDeO_HGEMED(ey)=1;
initial_FUEL_PRICE_HGEMED(y,t,f)=fuel_price(y,t,f);
initial_PGEN_HGEMED(y,t,f,l,p,b)=PGEN_LEGEN.l(y,t,f,l,p,b);
initial_PPUMPED_HGEMED(y,l,p,b)=PPUMPED_LEGEN.l(y,l,p,b);
initial_RES_HGEMED(y,l,p)=RES_LEGEN.l(y,l,p);
initial_PINS_HGEMED(y,l,t)=PINS_LEGEN.l(y,l,t);

initial_INSTALLED_CAPACITY_HGEMED(eys,l,t)=existent_installed_capacity(eys,l,t) + sum((eys_alias)$((ord(eys_alias) le ord(eys)) and (ord(eys_alias) gt (ord(eys)-power_plant_time_life(t)))),PINS_LEGEN.l(eys_alias,l,t));
*initial_INSTALLED_CAPACITY_HGEMED(eys,l,t)=INSTALLED_CAPACITY_LEGEN.l(eys,l,t);

initial_INCREASED_DR_LOAD_HGEMED(y,l,p,b)=INCREASED_DR_LOAD.l(y,l,p,b);
initial_DECREASED_DR_LOAD_HGEMED(y,l,p,b)=DECREASED_DR_LOAD.l(y,l,p,b);
initial_CONSERVED_DR_LOAD_HGEMED(y,l,p,b)=CONSERVED_DR_LOAD.l(y,l,p,b);

emissions_allowance(ey,l,p,b,t) = ( co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)* ( sum(f, initial_PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b))/sum((f,p_alias,b_alias), initial_PGEN_HGEMED(ey,t,f,l,p_alias,b_alias)*duration(l,p_alias,b_alias)) ) )$ ( NOT (sum((f,p_alias,b_alias)$emitting_t(t,f),initial_PGEN_HGEMED(ey,t,f,l,p_alias,b_alias))=0) ) + ( co2_emission_rights_assignment_GEN_technology(ey,t)*co2_price(ey)* ( sum((t_alias,f), initial_PGEN_HGEMED(ey,t_alias,f,l,p,b)*duration(l,p,b))/sum((t_alias,f,p_alias,b_alias), pgen_SAMDIS(ey,t_alias,f,l,p_alias,b_alias)*duration(l,p_alias,b_alias)) ) ) $ ( sum((f,p_alias,b_alias)$emitting_t(t,f),initial_PGEN_HGEMED(ey,t,f,l,p_alias,b_alias))=0 );

initial_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)$(initial_INSTALLED_CAPACITY_HGEMED(ey,l,t) and duration(l,p,b)) = E_F_E_GEN_SAMDIS.l(ey,"Labor",l,p,b,t)/initial_P_PF_LABOR_HGEMED(ey);
initial_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t)$(initial_INSTALLED_CAPACITY_HGEMED(ey,l,t) and duration(l,p,b)) = E_F_E_GEN_SAMDIS.l(ey,"Capital",l,p,b,t)/initial_P_PF_CAPITAL_HGEMED(ey);
initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t)$duration(l,p,b)=0;

initial_Q_S_TECH_HGEMED(ey,l,p,b,t)$duration(l,p,b) = duration(l,p,b)*sum((f)$t_f(t,f), initial_PGEN_HGEMED(ey,t,f,l,p,b) / 1e6 );

initial_Q_S_GEN_HGEMED(ey,l,p,b)$duration(l,p,b) = sum((t), initial_Q_S_TECH_HGEMED(ey,l,p,b,t));


***alternative initial_LAMBDA_DEM_HGEMED(ey,l,p,b)$initial_Q_S_GEN_HGEMED(ey,l,p,b) = - (energy_only_price_SAMDIS(ey,l,p,b)*duration(l,p,b))/1e6;

initial_P_S_GEN_HGEMED(ey,l,p,b)$initial_Q_S_GEN_HGEMED(ey,l,p,b) = - ( initial_LAMBDA_DEM_HGEMED(ey,l,p,b)*1e6 ) / duration(l,p,b);
***alternative initial_P_S_GEN_HGEMED(ey,l,p,b)$initial_Q_S_GEN_HGEMED(ey,l,p,b) = energy_only_price_SAMDIS(ey,l,p,b);
*initial_P_S_GEN_HGEMED(ey,l,p,b)$duration(l,p,b) = energy_only_price_SAMDIS(ey,l,p,b);


initial_Q_Q_GEN_HGEMED(ey,l,p,b)$duration(l,p,b) = initial_Q_S_GEN_HGEMED(ey,l,p,b) + q_m_GEN_HGEMED(ey,l,p,b) - q_ex_GEN_HGEMED(ey,l,p,b);
*initial_Q_Q_GEN_HGEMED(ey,l,p,b)$duration(l,p,b) = ( ( initial_Q_S_GEN_HGEMED(ey,l,p,b)*initial_P_S_GEN_HGEMED(ey,l,p,b)) + (q_m_GEN_HGEMED(ey,l,p,b)*p_m_GEN_HGEMED(ey,l,p,b)) - (q_ex_GEN_HGEMED(ey,l,p,b)*p_ex_GEN_HGEMED(ey,l,p,b)) ) / initial_P_Q_GEN_HGEMED(ey,l,p,b);

*initial_Q_Q_GEN_HGEMED(ey,l,p,b)$duration(l,p,b) = E_I_ENERGY_SAMDIS.l(ey,"Households",l,p,b)/initial_P_Q_GEN_HGEMED(ey,l,p,b) + q_gov_initial(ey,gne) + sum(sne,e_ii_s(ey,gne,sne)/initial_P_Q_HGEMED(ey,gne)) + sum((l,p,b,t),E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)/initial_P_Q_HGEMED(ey,gne)) + E_II_QE_TDeO_SAMDIS.l(ey,gne)/initial_P_Q_HGEMED(ey,gne) + e_inv(ey,gne) / initial_P_Q_HGEMED(ey,gne);



$ontext
initial_P_Q_GEN_HGEMED(ey,l,p,b)$initial_Q_Q_GEN_HGEMED(ey,l,p,b) = ( initial_P_S_GEN_HGEMED(ey,l,p,b)*initial_Q_S_GEN_HGEMED(ey,l,p,b) + p_m_GEN_HGEMED(ey,l,p,b)*q_m_GEN_HGEMED(ey,l,p,b) - p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b) + mkt_surplus_HGEMED(ey,l,p,b)
                                                                    - sum((t), emissions_allowance(ey,l,p,b,t))
                                                                    + sum((tx,t),E_TAX_E_GEN_SAMDIS.l(ey,tx,l,p,b,t))
                                                                    ) / initial_Q_Q_GEN_HGEMED(ey,l,p,b);
$offtext



initial_P_Q_GEN_HGEMED(ey,l,p,b)$initial_Q_Q_GEN_HGEMED(ey,l,p,b) =  ( - (1+tx_rate(ey,"Exports","Product_Tax"))*p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b)

                                                                       + sum((t), sum(gne, (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)) )
                                                                         + 0
*                                                                       + sum((t), (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_TDeO_HGEMED(ey)*initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t))
*                                                                       + sum((tx,t),E_TAX_E_GEN_SAMDIS.l(ey,"Product_Tax",l,p,b,t))
                                                                       + sum((t),sum((dp,db), (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t)))


                                                                       + sum((t), (1+tx_rate_sc_tech(ey,"Labor",l,p,b,t))*initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t))

                                                                       + sum((t), initial_P_PF_CAPITAL_HGEMED(ey)*initial_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t))

*                                                                       + sum((t),( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*initial_INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) )
                                                                       + sum((t,f,pollut)$emitting_t(t,f), initial_PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b)*pollut_content_HGEMED(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity"))
                                                                       + production_tax_GEN(ey,l,p,b)
                                                                       + p_m_GEN_HGEMED(ey,l,p,b)*q_m_GEN_HGEMED(ey,l,p,b)
                                                                       - sum(t, emissions_allowance(ey,l,p,b,t))
                                                                       + initial_mkt_surplus_HGEMED(ey,l,p,b)
                                                                    )/initial_Q_Q_GEN_HGEMED(ey,l,p,b);
                                                                    ;
*??? CO2Taxes????


$ontext
initial_P_Q_GEN_HGEMED(ey,l,p,b)$initial_Q_Q_GEN_HGEMED(ey,l,p,b) = (  - (1+tx_rate(ey,"Exports","Product_Tax"))*p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b)
                                                                       + sum((tx,t),E_TAX_E_GEN_SAMDIS.l(ey,"Product_Tax",l,p,b,t))
                                                                       + sum((t), initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t))
                                                                       + sum((t), initial_P_PF_CAPITAL_HGEMED(ey)*initial_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t))
                                                                       + sum((t),( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*initial_INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) )
                                                                       + production_tax_GEN(ey,l,p,b)
                                                                       + p_m_GEN_HGEMED(ey,l,p,b)*q_m_GEN_HGEMED(ey,l,p,b)
                                                                       + sum((t),sum((dp,db),E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,p,b,t)))
                                                                       - sum(t, emissions_allowance(ey,l,p,b,t))
                                                                       + initial_mkt_surplus_HGEMED(ey,l,p,b)
                                                                    )/initial_Q_Q_GEN_HGEMED(ey,l,p,b);

$offtext

$ontext
initial_P_Q_GEN_HGEMED(ey,l,p,b)$initial_Q_Q_GEN_HGEMED(ey,l,p,b) = ( initial_P_S_GEN_HGEMED(ey,l,p,b)*initial_Q_S_GEN_HGEMED(ey,l,p,b) + p_m_GEN_HGEMED(ey,l,p,b)*q_m_GEN_HGEMED(ey,l,p,b) - p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b) + mkt_surplus_HGEMED(ey,l,p,b)
                                                                    - sum((t), emissions_allowance(ey,l,p,b,t))
                                                                    + sum((t),( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*initial_INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) )
                                                                    + sum((t),( tx_rate_tech(ey,l,p,b,t,"Product_Tax")*( sum(gne, initial_P_Q_HGEMED(ey,gne)*initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), initial_P_Q_GEN_HGEMED(ey,l,p,b)*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  initial_P_Q_TDeO_HGEMED(ey)*initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) ) ) )
                                                                    + sum((t),( tx_rate_GEN(ey,l,p,b,"Production_taxes")*( sum(gne, initial_P_Q_HGEMED(ey,gne)*initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), initial_P_Q_GEN_HGEMED(ey,l,p,b)*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  initial_P_Q_TDeO_HGEMED(ey)*initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) + initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t) +  initial_P_PF_CAPITAL_HGEMED(ey)*initial_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t) + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*initial_INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) + ( tx_rate(ey,"Electricity","Product_tax")*( sum(gne, initial_P_Q_HGEMED(ey,gne)*initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), initial_P_Q_GEN_HGEMED(ey,l,p,b)*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  initial_P_Q_TDeO_HGEMED(ey)*initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) ) ) ) ) )
                                                                    + sum((t,f)$emitting_t(t,f), initial_PGEN_HGEMED(ey,t,f,l,p,b)*co2e_content_HGEMED(f,t)/1e6*co2_price(ey)*duration(l,p,b))
*                                                                     + sum((tx,t),E_TAX_E_GEN_SAMDIS.l(ey,tx,l,p,b,t)))
                                                                    ) / initial_Q_Q_GEN_HGEMED(ey,l,p,b);


          + sum((t),( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*initial_INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) )
         + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*( OEM_FOM_SC_SAMDIS(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(tx,"Social_Contributions") );


          + sum((t),( tx_rate_tech(ey,l,p,b,t,"Product_Tax")*( sum(gne, initial_P_Q_HGEMED(ey,gne)*initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), initial_P_Q_GEN_HGEMED(ey,l,p,b)*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  initial_P_Q_TDeO_HGEMED(ey)*initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) ) ) )
         ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) ) )$(SAMEAS(tx,"Product_tax")) +

          + sum((t),( tx_rate_GEN(ey,l,p,b,"Production_taxes")*( sum(gne, initial_P_Q_HGEMED(ey,gne)*initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), initial_P_Q_GEN_HGEMED(ey,l,p,b)*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  initial_P_Q_TDeO_HGEMED(ey)*initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) + initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t) +  initial_P_PF_CAPITAL_HGEMED(ey)*initial_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t) + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*initial_INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) + ( tx_rate(ey,"Electricity","Product_tax")*( sum(gne, initial_P_Q_HGEMED(ey,gne)*initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), initial_P_Q_GEN_HGEMED(ey,l,p,b)*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  initial_P_Q_TDeO_HGEMED(ey)*initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) ) ) ) ) )
         ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) + sum(pf, E_F_E_GEN_SAMDIS(ey,pf,l,gp,gb,t)) + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_TAX_E_GEN_SAMDIS(ey,"Social_Contributions",l,t) + VAR_E_TAX_E_GEN_SAMDIS(ey,"Product_Tax",l,gp,gb,t) + VAR_E_TAX_E_GEN_SAMDIS(ey,"CO2_Payments",l,gp,gb,t) ) )$(SAMEAS(tx,"Production_Taxes")) +

          + sum((t,f)$emitting_t(t,f), initial_PGEN_HGEMED(ey,t,f,l,p,b)*co2e_content_HGEMED(f,t)/1e6*co2_price(ey)*duration(l,p,b))
         ( sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*CO2e_CONTENT_SAMDIS(ey,t,f)/1e6*co2_price(ey)*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));


         E_II_QE_GEN_SAMDIS =
         ( OEM_VOM_SAMDIS(ey,t)*sum(f,pgen_SAMDIS(ey,t,f,l,gp,gb))*duration(l,gp,gb) / 10**6 )$(SAMEAS(gne,"Manufactures")) +
         ( sum((f)$(s_f(gne,f) and t_f(t,f)), N_SAMDIS(ey,t,f)*fuel_price(ey,t,f)*pgen_SAMDIS(ey,t,f,l,gp,gb)*duration(l,gp,gb) / 10**6 ) )$((duration(l,gp,gb)<>0) and (t_s(t,gne)) and ((SAMEAS(gne,"Coal") OR SAMEAS(gne,"Oil-Nuclear") OR SAMEAS(gne,"Gas"))));
         +  BU_dist_factor(ey,l,gp,gb)*( OEM_FOM_EQUIP_SAMDIS(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(gne,"Manufactures"));

         E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t) =e=
         ( sum((f)$t_f(t,f), OWN_CONS_SAMDIS(ey)*pgen_SAMDIS(ey,t,f,l,gp,gb)*duration(l,gp,gb)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 ) )$((sameas(dp,gp)) and (sameas(db,gb))) +
         ( ppumped_SAMDIS(ey,l,gp,gb)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 )$(SAMEAS(t,"Pump") and SAMEAS(dp,gp) and SAMEAS(db,gb));


         eq_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)..
Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t) =e= ( ( init_oem_vom_HGEMED(ey,t)*Q_S_TECH_HGEMED(ey,l,p,b,t) )$(SAMEAS(gne,"Manufactures"))
                                             + ( sum((f)$(s_f(gne,f) and t_f(t,f)), thermodynamic_efficiency_HGEMED(ey,t,f)*FUEL_PRICE_HGEMED(ey,t,f)*Q_S_TECH_HGEMED(ey,l,p,b,t) ) )$((duration(l,p,b)<>0) and (t_s(t,gne)) and ((SAMEAS(gne,"Coal") OR SAMEAS(gne,"Oil-Nuclear") OR SAMEAS(gne,"Gas"))))
                                             + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_equipments_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 1e3 )$ (SAMEAS(gne,"Manufactures")) ) / P_Q_HGEMED(ey,gne);

eq_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t)..
Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t) =e= ( ( init_own_cons_gen_pctg*Q_S_TECH_HGEMED(ey,l,gp,gb,t)*P_S_GEN_HGEMED(ey,l,dp,db) )$((sameas(dp,gp)) and (sameas(db,gb)))
                                                 + ( PPUMPED_HGEMED(ey,l,gp,gb)*duration(l,dp,db)*P_S_GEN_HGEMED(ey,l,dp,db) / 1e6 )$(SAMEAS(t,"Pump") and SAMEAS(dp,gp) and SAMEAS(db,gb)) ) / P_Q_GEN_HGEMED(ey,l,dp,db);

eq_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t)..
Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) =e= 0;

Q_S_TECH_HGEMED(ey,l,p,b,t) =e= duration(l,p,b)*sum((f)$t_f(t,f), PGEN_HGEMED(ey,t,f,l,p,b) / 1e6 );

eq_Q_S_GEN_HGEMED(ey,l,p,b)..
Q_S_GEN_HGEMED(ey,l,p,b) =e= sum((t), Q_S_TECH_HGEMED(ey,l,p,b,t));

$offtext
$ontext
E_TAX_E_GEN_SAMDIS(ey,tx,l,gp,gb,t)=e=
         ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) ) )$(SAMEAS(tx,"Product_tax")) +
         ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) + sum(pf, E_F_E_GEN_SAMDIS(ey,pf,l,gp,gb,t)) + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_TAX_E_GEN_SAMDIS(ey,"Social_Contributions",l,t) + VAR_E_TAX_E_GEN_SAMDIS(ey,"Product_Tax",l,gp,gb,t) + VAR_E_TAX_E_GEN_SAMDIS(ey,"CO2_Payments",l,gp,gb,t) ) )$(SAMEAS(tx,"Production_Taxes")) +
         ( sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*CO2e_CONTENT_SAMDIS(ey,t,f)/1e6*co2_price(ey)*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));
         + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*( OEM_FOM_SC_SAMDIS(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(tx,"Social_Contributions") );

*

           VAR_E_TAX_E_GEN_SAMDIS(ey,tx,l,t) =e= ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) ) )$(SAMEAS(tx,"Product_tax")) +
         ( tx_rate(ey,"Electricity",tx)*( sum(gne, E_II_QE_GEN_SAMDIS(ey,gne,l,gp,gb,t))+sum((dp,db), E_II_EE_GEN_SAMDIS(ey,l,dp,db,gp,gb,t)) + sum(pf, E_F_E_GEN_SAMDIS(ey,pf,l,gp,gb,t)) + BU_dist_factor(ey,l,gp,gb)*duration(l,gp,gb)*FIX_E_TAX_E_GEN_SAMDIS(ey,"Social_Contributions",l,t) + VAR_E_TAX_E_GEN_SAMDIS(ey,"Product_Tax",l,gp,gb,t) + VAR_E_TAX_E_GEN_SAMDIS(ey,"CO2_Payments",l,gp,gb,t) ) )$(SAMEAS(tx,"Production_Taxes")) +
         ( sum(f$emitting_t(t,f), pgen_SAMDIS(ey,t,f,l,gp,gb)*CO2e_CONTENT_SAMDIS(ey,t,f)/1e6*co2_price(ey)*duration(l,gp,gb)) )$(SAMEAS(tx,"CO2_Payments"));
FIX_E_TAX_E_GEN_SAMDIS(ey,tx,l,t) =e=       ( OEM_FOM_SC_SAMDIS(ey,l,t)*existent_installed_capacity(ey,l,t) / 10**3 )$ (SAMEAS(tx,"Social_Contributions") );


P_Q_GEN_HGEMED(ey,l,p,b)*Q_Q_GEN_HGEMED(ey,l,p,b) =e= P_S_GEN_HGEMED(ey,l,p,b)*Q_S_GEN_HGEMED(ey,l,p,b) + p_m_GEN_HGEMED(ey,l,p,b)*q_m_GEN_HGEMED(ey,l,p,b) - p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b) + mkt_surplus_HGEMED(ey,l,p,b)
                                                      - sum((t), emissions_allowance(ey,l,p,b,t))
                                                      + sum((t),( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) )
                                                      + sum((t),( tx_rate_tech(ey,l,p,b,t,"Product_Tax")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) ) ) )
                                                      + sum((t),( tx_rate_GEN(ey,l,p,b,"Production_taxes")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) + P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t) +  P_PF_CAPITAL_HGEMED(ey)*Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t) + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) + ( tx_rate(ey,"Electricity","Product_tax")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) ) ) ) ) )
                                                      + sum((t,f)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*co2e_content_HGEMED(f,t)/1e6*co2_price(ey)*duration(l,p,b))
                                                      ;

$offtext

initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)$initial_P_Q_HGEMED(ey,gne)=E_II_QE_GEN_SAMDIS.l(ey,gne,l,p,b,t)/initial_P_Q_HGEMED(ey,gne);

initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t)$initial_P_Q_GEN_HGEMED(ey,l,dp,db)=E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t)/initial_P_Q_GEN_HGEMED(ey,l,dp,db);


*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t)$initial_P_S_GEN_HGEMED(ey,l,dp,db)=E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t)/initial_P_S_GEN_HGEMED(ey,l,dp,db);



*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t)$initial_P_Q_GEN_HGEMED(ey,l,dp,db)=E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t)/initial_P_Q_GEN_HGEMED(ey,l,dp,db);

*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t) = ( sum((f)$t_f(t,f), OWN_CONS_SAMDIS(ey)*pgen_SAMDIS(ey,t,f,l,gp,gb)*duration(l,gp,gb)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 ) )$((sameas(dp,gp)) and (sameas(db,gb))) +
*         ( ppumped_SAMDIS(ey,l,gp,gb)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6 )$(SAMEAS(t,"Pump") and SAMEAS(dp,gp) and SAMEAS(db,gb));
*initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t) = E_II_EE_GEN_SAMDIS.l(ey,l,dp,db,gp,gb,t)/initial_P_Q_GEN_HGEMED(ey,l,dp,db);


initial_Q_PF_SNE_LABOR_HGEMED(ey,sne)=e_pf_s(ey,"Labor",sne)/p_pf_initial(ey,"Labor");
initial_Q_PF_SNE_CAPITAL_HGEMED(ey,sne)=e_pf_s(ey,"Capital",sne)/p_pf_initial(ey,"Capital");
initial_Q_VA_HGEMED(ey,sne)=( initial_Q_PF_SNE_LABOR_HGEMED(ey,sne)*initial_P_PF_LABOR_HGEMED(ey) + initial_Q_PF_SNE_CAPITAL_HGEMED(ey,sne)*initial_P_PF_CAPITAL_HGEMED(ey) + e_tx_sam(ey,"Social_Contributions",sne) ) / initial_P_VA_HGEMED(ey,sne);
initial_Q_II_HGEMED(ey,gne,sne)= e_ii_s(ey,gne,sne)/initial_P_Q_HGEMED(ey,gne);

initial_Q_S_HGEMED(ey,sne)= (    initial_Q_VA_HGEMED(ey,sne)*initial_P_VA_HGEMED(ey,sne)
                                 + sum(gne, e_ii_s(ey,gne,sne))
                                 + sum((l,p,b), E_II_EQ_ENERGY_SAMDIS.l(ey,sne,l,p,b))
                                 + E_II_EQ_POWER_SAMDIS.l(ey,sne)
                                 + e_tx_sam(ey,"Product_Tax",sne)
                                 + sum(pollut,top_down_pollutant_content(ey,pollut,sne)*pollutant_price(ey,pollut,sne))
                                 - sum(i, e_transf_i_s(ey,i,sne))
                                 + e_tx_sam(ey,"Production_Taxes",sne)
                            ) / ( initial_P_S_HGEMED(ey,sne) );



initial_Q_M_HGEMED(ey,gne)= e_m_s(ey,gne) / p_m_initial(ey,gne);
initial_Q_D_HGEMED(ey,gne)=( initial_Q_S_HGEMED(ey,gne)*initial_P_S_HGEMED(ey,gne) + initial_Q_M_HGEMED(ey,gne)*p_m_initial(ey,gne) ) / initial_P_D_HGEMED(ey,gne);
initial_Q_EX_HGEMED(ey,gne)=e_g_ex(ey,gne)/p_ex_initial(ey,gne);
initial_Q_Q_HGEMED(ey,gne)=( initial_Q_D_HGEMED(ey,gne)*initial_P_D_HGEMED(ey,gne) - initial_Q_EX_HGEMED(ey,gne)*p_ex_initial(ey,gne) ) / initial_P_Q_HGEMED(ey,gne);

initial_Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne)$initial_P_Q_GEN_HGEMED(ey,l,p,b)=E_II_EQ_ENERGY_SAMDIS.l(ey,sne,l,p,b)/initial_P_Q_GEN_HGEMED(ey,l,p,b);

initial_Q_PF_LABOR_TDeO_HGEMED(ey)=E_F_E_TDeO_SAMDIS.l(ey,"Labor")/p_pf_initial(ey,"Labor");
initial_Q_PF_CAPITAL_TDeO_HGEMED(ey)=E_F_E_TDeO_SAMDIS.l(ey,"Capital")/p_pf_initial(ey,"Capital");
initial_Q_VA_TDeO_HGEMED(ey)=( initial_Q_PF_LABOR_TDeO_HGEMED(ey)*initial_P_PF_LABOR_HGEMED(ey) + initial_Q_PF_CAPITAL_TDeO_HGEMED(ey)*initial_P_PF_CAPITAL_HGEMED(ey) + E_TAX_E_TDeO_SAMDIS.l(ey,"Social_Contributions") ) / initial_P_VA_TDeO_HGEMED(ey);
initial_Q_II_GNE_TDeO_HGEMED(ey,gne)=E_II_QE_TDeO_SAMDIS.l(ey,gne)/initial_P_Q_HGEMED(ey,gne);
initial_Q_II_GEN_TDeO_HGEMED(ey,l,p,b)$initial_P_Q_GEN_HGEMED(ey,l,p,b)=E_II_EE_TDeO_SAMDIS.l(ey,l,p,b)/initial_P_Q_GEN_HGEMED(ey,l,p,b);
initial_Q_II_TDeO_TDeO_HGEMED(ey)=0;
initial_Q_S_TDeO_HGEMED(ey)=( initial_Q_VA_TDeO_HGEMED(ey)*initial_P_VA_TDeO_HGEMED(ey) + sum(gne, E_II_QE_TDeO_SAMDIS.l(ey,gne)) + sum((l,p,b), E_II_EE_TDeO_SAMDIS.l(ey,l,p,b)) + 0 + E_TAX_E_TDeO_SAMDIS.l(ey,"Product_Tax") ) / initial_P_S_TDeO_HGEMED(ey);
initial_Q_D_TDeO_HGEMED(ey)=initial_Q_S_TDeO_HGEMED(ey);
initial_P_D_TDeO_HGEMED(ey)=( initial_Q_S_TDeO_HGEMED(ey)*initial_P_S_TDeO_HGEMED(ey) + E_TAX_E_TDeO_SAMDIS.l(ey,"Production_Taxes") ) / initial_Q_D_TDeO_HGEMED(ey);
initial_Q_Q_TDeO_HGEMED(ey)=initial_Q_D_TDeO_HGEMED(ey);
initial_P_Q_TDeO_HGEMED(ey)=( initial_Q_D_TDeO_HGEMED(ey)*initial_P_D_TDeO_HGEMED(ey) ) / initial_Q_Q_TDeO_HGEMED(ey);
initial_Q_II_TDeO_SNE_HGEMED(ey,sne)=E_II_EQ_POWER_SAMDIS.l(ey,sne)/initial_P_Q_TDeO_HGEMED(ey);

initial_Q_H_D_HGEMED(ey,gne)=e_g_i(ey,gne,"Households")/initial_P_Q_HGEMED(ey,gne);

*initial_Q_H_D_GEN_HGEMED(ey,l,p,b)=demand(eys,"households",l,p,b)*duration(l,p,b)/1e6;
initial_Q_H_D_GEN_HGEMED(ey,l,p,b)$initial_P_Q_GEN_HGEMED(ey,l,p,b)=E_I_ENERGY_SAMDIS.l(ey,"Households",l,p,b)/initial_P_Q_GEN_HGEMED(ey,l,p,b);

initial_Q_H_D_TDeO_HGEMED(ey)=E_I_POWER_SAMDIS.l(ey,"Households")/initial_P_Q_TDeO_HGEMED(ey);
initial_Y_H_HGEMED(ey)= sum(pf,e_i_pf(ey,"Households",pf))+transf_g_h(ey)
                        + psc_h(ey)*( sum((sne),(tx_rate_sc(ey,"Labor",sne))*initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_SNE_LABOR_HGEMED(ey,sne))
                        + tx_rate_sc_TDeO(ey,"Labor")*initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_LABOR_TDeO_HGEMED(ey)
                        + sum((l,p,b,t),E_TAX_E_GEN_SAMDIS.l(ey,"Social_Contributions",l,p,b,t)))
                        + transf_ext_h(ey);
initial_E_G_HGEMED(ey)=sum(gne,e_g_i(ey,gne,"Government"))+ sum((l,p,b), E_I_ENERGY_SAMDIS.l(ey,"Government",l,p,b)) + E_I_POWER_SAMDIS.l(ey,"Government") + sum(tx,e_tx_sam(ey,tx,"Government"))+e_i_tx(ey,"Households","Social_Contributions")+e_transf_i(ey,"Households","Government")-e_transf_i(ey,"Government","Households") + sum(sne, sum(i, e_transf_i_s(ey,i,sne))) + sum((l,p,b,t), emissions_allowance(ey,l,p,b,t)) ;


initial_Y_TAX_HGEMED(ey)=
         sum((tx,sne),e_tx_sam(ey,tx,sne))

*        + sum((tx),e_tx_sam(ey,tx,"Electricity"))
         + sum((tx),sum((l,gp,gb,t),E_TAX_E_GEN_SAMDIS.l(ey,tx,l,gp,gb,t)))
         + sum((tx),sum((l,gp,gb),E_TAX_E_GEN_PER_BLOCK_SAMDIS.l(ey,tx,l,gp,gb)))
         + sum((tx),E_TAX_E_TDeO_SAMDIS.l(ey,tx))
*         + sum((l,p,b), (sum((t,f,pollut)$emitting_t(t,f), initial_PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b)*pollut_content_HGEMED(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity"))))

         + sum((tx,i),e_tx_sam(ey,tx,i))
         + sum(tx, e_tx_sam(ey,tx,"Saves-Investments"))
         +  sum(tx, e_tx_sam(ey,tx,"Exports"))

*         + sum((sne,pollut)$ets_sne(sne), top_down_pollutant_content(ey,pollut,sne)*(initial_P_S_HGEMED(ey,sne)/(initial_Q_S_HGEMED(ey,sne)*initial_P_S_HGEMED(ey,sne)))*Q_S_HGEMED(ey,sne)*pollutant_price(ey,pollut,sne) )
*         + sum(pollut, top_down_pollutant_content(ey,pollut,"Households")*( sum(gne, (initial_P_Q_HGEMED(ey,gne)/(initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)))*Q_H_D_HGEMED(ey,gne)) + (initial_P_Q_TDeO_HGEMED(ey)/(initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey)))*Q_H_D_TDeO_HGEMED(ey) + sum((l,p,b), (initial_P_Q_GEN_HGEMED(ey,l,p,b)/(initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b)))*Q_H_D_GEN_HGEMED(ey,l,p,b)) )*pollutant_price(ey,pollut,"Households"))
;




$ontext
eq_7_3_47(ey)..
Y_TAX_HGEMED(ey)=e=
* Social Contributions
         sum((sne),(tx_rate_sc(ey,"Labor",sne))*P_PF_LABOR_HGEMED(ey)*Q_PF_SNE_LABOR_HGEMED(ey,sne))
         + tx_rate_sc_TDeO(ey,"Labor")*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_TDeO_HGEMED(ey)
         + sum((l,p,b,t),( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ))
*sum((l,p,b,t),(tx_rate_sc_tech(ey,"Labor",l,p,b,t))*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t))+
* Product Tax
         + sum(sne, sum(gne, tx_rate(ey,sne,"Product_tax")*P_Q_HGEMED(ey,gne)*Q_II_HGEMED(ey,gne,sne)))
         + sum(sne, tx_rate(ey,sne,"Product_tax")*P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_SNE_HGEMED(ey,sne))
         + sum(sne, sum((l,p,b), tx_rate(ey,sne,"Product_tax")*P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne)))

         + sum(gne, tx_rate_TDeO(ey,"Product_tax")*P_Q_HGEMED(ey,gne)*Q_II_GNE_TDeO_HGEMED(ey,gne))
         + tx_rate_TDeO(ey,"Product_tax")*P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_TDeO_HGEMED(ey)
         + sum((l,p,b), tx_rate_TDeO(ey,"Product_tax")*P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_TDeO_HGEMED(ey,l,p,b))

         + sum((l,p,b,t), sum(gne, tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) )
         + sum((l,p,b,t), tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t))
         + sum((l,p,b,t), sum((dp,db), tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_GEN_HGEMED(ey,l,dp,db)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) )

         + sum(gne,tx_rate(ey,"Exports","Product_Tax")*p_ex_initial(ey,gne)*Q_EX_HGEMED(ey,gne))
         + sum((l,p,b),tx_rate(ey,"Exports","Product_Tax")*p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b))
         + sum(gne, tx_rate(ey,"Households","Product_Tax")*P_Q_HGEMED(ey,gne)*Q_H_D_HGEMED(ey,gne))
         + sum((l,p,b), tx_rate(ey,"Households","Product_Tax")*P_Q_GEN_HGEMED(ey,l,p,b)*Q_H_D_GEN_HGEMED(ey,l,p,b))
         + tx_rate(ey,"Households","Product_Tax")*P_Q_TDeO_HGEMED(ey)*Q_H_D_TDeO_HGEMED(ey)
         + sum(gne,tx_rate(ey,"Government","Product_Tax")*P_Q_HGEMED(ey,gne)*q_gov_initial(ey,gne))
         + sum((l,p,b),tx_rate(ey,"Government","Product_Tax")*P_Q_GEN_HGEMED(ey,l,p,b)*q_gov_GEN_initial(ey,l,p,b))
         + tx_rate(ey,"Government","Product_Tax")*P_Q_TDeO_HGEMED(ey)*q_gov_TDeO_initial(ey)
         + sum(gne,tx_rate(ey,"Saves-Investments","Product_Tax")*P_Q_HGEMED(ey,gne)*Q_I_D_HGEMED(ey,gne))
* Production Tax
         + sum(sne, e_tx_sam(ey,"Production_Taxes",sne))
         + production_tax_TDeO(ey)
         + sum((l,p,b), production_tax_GEN(ey,l,p,b))

*         + sum(sne,tx_rate(ey,sne,"Production_taxes")*P_S_HGEMED(ey,sne)*Q_S_HGEMED(ey,sne))
*         + tx_rate_TDeO(ey,"Production_taxes")*P_S_TDeO_HGEMED(ey)*Q_S_TDeO_HGEMED(ey)
*         + sum((l,p,b,t), ( tx_rate(ey,"Electricity","Production_Taxes")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) + P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t) +  P_PF_CAPITAL_HGEMED(ey)*Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t) + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) + ( tx_rate(ey,"Electricity","Product_tax")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) - emissions_allowance(ey,l,p,b,t) ) ) ) ) )

*old***sum((l,p,b),tx_rate_GEN(ey,l,p,b,"Production_taxes")*P_S_GEN_GEMED(ey,l,p,b)*Q_S_GEN_GEMED(ey,l,p,b)) +

* Emission taxes
*         + sum(sne$ets_sne(sne), emission_rate(ey,sne)*Q_S_HGEMED(ey,sne)*co2_price(ey))
*        + sum((l,p,b), sum((t,f)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*co2e_content_HGEMED(f,t)/1e6*co2_price(ey)*duration(l,p,b)) )
         + sum((l,p,b), (sum((t,f,pollut)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b)*pollut_content_HGEMED(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity"))))
         + sum((sne,pollut)$ets_sne(sne), top_down_pollutant_content(ey,pollut,sne)*(initial_P_S_HGEMED(ey,sne)/(initial_Q_S_HGEMED(ey,sne)*initial_P_S_HGEMED(ey,sne)))*Q_S_HGEMED(ey,sne)*pollutant_price(ey,pollut,sne) )
         + sum(pollut, top_down_pollutant_content(ey,pollut,"Households")*( sum(gne, (initial_P_Q_HGEMED(ey,gne)/(initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)))*Q_H_D_HGEMED(ey,gne)) + (initial_P_Q_TDeO_HGEMED(ey)/(initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey)))*Q_H_D_TDeO_HGEMED(ey) + sum((l,p,b), (initial_P_Q_GEN_HGEMED(ey,l,p,b)/(initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b)))*Q_H_D_GEN_HGEMED(ey,l,p,b)) )*pollutant_price(ey,pollut,"Households"))
;
$offtext

initial_Y_G_HGEMED(ey)=sum(pf,e_i_pf(ey,"Government",pf))+e_transf_k_ext_i(ey,"Government")-e_transf_k_i_ext(ey,"Government")+initial_Y_TAX_HGEMED(ey);
initial_S_TOTAL_H_HGEMED(ey)=e_i_sav(ey,"Households");
initial_S_TOTAL_G_HGEMED(ey)=e_i_sav(ey,"Government");
initial_S_TOTAL_EXT_HGEMED(ey)=e_sav(ey);
initial_S_TOTAL_HGEMED(ey)=initial_S_TOTAL_H_HGEMED(ey)+initial_S_TOTAL_G_HGEMED(ey)+initial_S_TOTAL_EXT_HGEMED(ey)+e_transf_k_ext_spain(ey);
initial_Q_I_D_HGEMED(ey,gne)=e_inv(ey,gne) / initial_P_Q_HGEMED(ey,gne);
initial_I_TOTAL_HGEMED(ey)=sum(gne,initial_Q_I_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)) + e_tx_sam(ey,"Product_Tax","Saves-Investments");
initial_CPI_HGEMED(ey)=0;
initial_WALRAS_HGEMED(ey)=0;
s_propensity_h(ey)=initial_S_TOTAL_H_HGEMED(ey)/initial_Y_H_HGEMED(ey);
c_h(ey,gne)=initial_Q_H_D_HGEMED(ey,gne)*( (1+tx_rate(ey,"Households","Product_Tax"))*initial_P_Q_HGEMED(ey,gne) ) / ((1-s_propensity_h(ey))*initial_Y_H_HGEMED(ey) );
c_h_GEN(ey,l,p,b)$duration(l,p,b)=initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*( (1+tx_rate(ey,"Households","Product_Tax"))*initial_P_Q_GEN_HGEMED(ey,l,p,b) ) / ( (1-s_propensity_h(ey))*initial_Y_H_HGEMED(ey) );
c_h_TDeO(ey)=initial_Q_H_D_TDeO_HGEMED(ey)*( (1+tx_rate(ey,"Households","Product_Tax"))*initial_P_Q_TDeO_HGEMED(ey) ) / ( (1-s_propensity_h(ey))*initial_Y_H_HGEMED(ey) );
q_i_pf(ey,i,"Labor")=e_i_pf(ey,i,"Labor")/initial_P_PF_LABOR_HGEMED(ey);
q_i_pf(ey,i,"Capital")=e_i_pf(ey,i,"Capital")/initial_P_PF_CAPITAL_HGEMED(ey);
tx_rate_TDeO(ey,"Product_Tax")=E_TAX_E_TDeO_SAMDIS.l(ey,"Product_Tax")/ ( sum(gne, E_II_QE_TDeO_SAMDIS.l(ey,gne)) + sum((l,p,b), E_II_EE_TDeO_SAMDIS.l(ey,l,p,b)) );
tx_rate_TDeO(ey,"Production_Taxes")=E_TAX_E_TDeO_SAMDIS.l(ey,"Production_Taxes")/ ( initial_Q_S_TDeO_HGEMED(ey)*initial_P_S_TDeO_HGEMED(ey) );
*tx_rate_GEN(ey,l,p,b,"Production_Taxes")$(initial_Q_S_GEN_HGEMED(ey,l,p,b) and initial_P_S_GEN_HGEMED(ey,l,p,b))=( sum(t, E_TAX_E_GEN_SAMDIS.l(ey,"Production_Taxes",l,p,b,t)) ) /  ( initial_Q_S_GEN_HGEMED(ey,l,p,b)*initial_P_S_GEN_HGEMED(ey,l,p,b) );
a_va_pf(ey,"Labor",sne)= ( (1+tx_rate_sc(ey,"Labor",sne))*initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_SNE_LABOR_HGEMED(ey,sne)**(1/elasticity_VA(sne)) ) / ( (1+tx_rate_sc(ey,"Labor",sne))*initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_SNE_LABOR_HGEMED(ey,sne)**(1/elasticity_VA(sne)) + ( (1+tx_rate_sc(ey,"Capital",sne))*initial_P_PF_CAPITAL_HGEMED(ey)*initial_Q_PF_SNE_CAPITAL_HGEMED(ey,sne)**(1/elasticity_VA(sne) )));
a_va_pf(ey,"Capital",sne)= ( (1+tx_rate_sc(ey,"Capital",sne))*initial_P_PF_CAPITAL_HGEMED(ey)*initial_Q_PF_SNE_CAPITAL_HGEMED(ey,sne)**(1/elasticity_VA(sne) )) / ( (1+tx_rate_sc(ey,"Labor",sne))*initial_P_PF_LABOR_HGEMED(ey)*initial_Q_PF_SNE_LABOR_HGEMED(ey,sne)**(1/elasticity_VA(sne)) + ( (1+tx_rate_sc(ey,"Capital",sne))*initial_P_PF_CAPITAL_HGEMED(ey)*initial_Q_PF_SNE_CAPITAL_HGEMED(ey,sne)**(1/elasticity_VA(sne) )));
alpha_va(ey,sne)=initial_Q_VA_HGEMED(ey,sne)*[ ( a_va_pf(ey,"Labor",sne)*(initial_Q_PF_SNE_LABOR_HGEMED(ey,sne)**((elasticity_va(sne)-1)/elasticity_va(sne))) + a_va_pf(ey,"cAPITAL",sne)*(initial_Q_PF_SNE_CAPITAL_HGEMED(ey,sne)**((elasticity_va(sne)-1)/elasticity_va(sne))) )** ( elasticity_va(sne)/(1-elasticity_va(sne)) ) ];
c_ii_share(ey,gne,sne)=initial_Q_II_HGEMED(ey,gne,sne)/initial_Q_S_HGEMED(ey,sne);
c_ii_share_GEN(ey,l,p,b,sne)$duration(l,p,b)= initial_Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne)/initial_Q_S_HGEMED(ey,sne);
c_ii_share_TDeO(ey,sne)= initial_Q_II_TDeO_SNE_HGEMED(ey,sne)/initial_Q_S_HGEMED(ey,sne);
c_va_share(ey,sne)=initial_Q_VA_HGEMED(ey,sne)/initial_Q_S_HGEMED(ey,sne);
a_d_q(ey,gne)= ( (initial_P_S_HGEMED(ey,gne)* initial_Q_S_HGEMED(ey,gne)**(1/elasticity_D(gne))) ) / ( ((initial_P_S_HGEMED(ey,gne)* initial_Q_S_HGEMED(ey,gne)**(1/elasticity_D(gne))))+((p_m_initial(ey,gne)* initial_Q_M_HGEMED(ey,gne)**(1/elasticity_D(gne)))) );
a_d_m(ey,gne)= ( (p_m_initial(ey,gne)* initial_Q_M_HGEMED(ey,gne)**(1/elasticity_D(gne))) ) / ( ((initial_P_S_HGEMED(ey,gne)* initial_Q_S_HGEMED(ey,gne)**(1/elasticity_D(gne))))+((p_m_initial(ey,gne)* initial_Q_M_HGEMED(ey,gne)**(1/elasticity_D(gne)))) );

alpha_d(ey,gne)= initial_Q_D_HGEMED(ey,gne)* { { (a_d_q(ey,gne)*(initial_Q_S_HGEMED(ey,gne)**[(elasticity_D(gne)-1)/elasticity_D(gne)])) + (a_d_m(ey,gne)*(initial_Q_M_HGEMED(ey,gne)**[(elasticity_D(gne)-1)/elasticity_D(gne)])) }**[elasticity_D(gne)/(1-elasticity_D(gne))] };
b_q_q(ey,gne)=( initial_Q_EX_HGEMED(ey,gne)**(1/elasticity_q(gne))*initial_P_Q_HGEMED(ey,gne) ) / ( ( initial_Q_EX_HGEMED(ey,gne)**(1/elasticity_q(gne))*initial_P_Q_HGEMED(ey,gne) ) +  ( initial_Q_Q_HGEMED(ey,gne)**(1/elasticity_q(gne))*(1+tx_rate(ey,"Exports","Product_Tax"))*p_ex_initial(ey,gne) ) );
b_q_ex(ey,gne)=1-b_q_q(ey,gne);
beta_q(ey,gne)=initial_Q_D_HGEMED(ey,gne)*{ { (b_q_q(ey,gne)*(initial_Q_Q_HGEMED(ey,gne)**[(elasticity_q(gne)+1)/elasticity_q(gne)])) + (b_q_ex(ey,gne)*(initial_Q_EX_HGEMED(ey,gne)**[(elasticity_q(gne)+1)/elasticity_q(gne)])) }**[(-elasticity_q(gne))/(elasticity_q(gne)+1)] };
c_pf_TDeO_share(ey,"Labor")=initial_Q_PF_LABOR_TDeO_HGEMED(ey)/initial_Q_VA_TDeO_HGEMED(ey);
c_pf_TDeO_share(ey,"Capital")=initial_Q_PF_CAPITAL_TDeO_HGEMED(ey)/initial_Q_VA_TDeO_HGEMED(ey);
c_ii_gne_TDeO(ey,gne)=initial_Q_II_GNE_TDeO_HGEMED(ey,gne)/initial_Q_S_TDeO_HGEMED(ey);
c_ii_elec_TDeO(ey,l,p,b)$duration(l,p,b)=initial_Q_II_GEN_TDeO_HGEMED(ey,l,p,b)/initial_Q_S_TDeO_HGEMED(ey);
c_ii_TDeO_TDeO(ey)=initial_Q_II_TDeO_TDeO_HGEMED(ey)/initial_Q_S_TDeO_HGEMED(ey);
c_va_TDeO_share(ey)=initial_Q_VA_TDeO_HGEMED(ey)/initial_Q_S_TDeO_HGEMED(ey);
q_gov_initial(ey,gne)=e_g_i(ey,gne,"Government")/initial_P_Q_HGEMED(ey,gne);
q_gov_GEN_initial(ey,l,p,b)$duration(l,p,b)=E_I_ENERGY_SAMDIS.l(ey,"Government",l,p,b);
q_gov_TDeO_initial(ey)=E_I_POWER_SAMDIS.l(ey,"Government");
Theta(ey,gne)=(initial_Q_I_D_HGEMED(ey,gne)*(1+tx_rate(ey,"Saves-Investments","Product_Tax"))*initial_P_Q_HGEMED(ey,gne))/initial_I_TOTAL_HGEMED(ey);


parameter propensity_scale;
propensity_scale=1;
c_h(ey,gne)=c_h(ey,gne)*propensity_scale;
c_h_GEN(ey,l,p,b)=c_h_GEN(ey,l,p,b)*propensity_scale;
c_h_TDeO(ey)=c_h_TDeO(ey)*propensity_scale;


*Using only household expenditure to define consumer price index
mu_cpi(ey,gne)= initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne) / ( sum(gne_alias, initial_Q_H_D_HGEMED(ey,gne_alias)*initial_P_Q_HGEMED(ey,gne_alias)) + sum((l,p,b), initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b)) + initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey) );
mu_cpi_GEN(ey,l,p,b)= initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b) / ( sum(gne, initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)) + sum((dp,db), initial_Q_H_D_GEN_HGEMED(ey,l,dp,db)*initial_P_Q_GEN_HGEMED(ey,l,dp,db)) + initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey) );
mu_cpi_TDeO(ey)= initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey) / ( sum(gne, initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)) + sum((l,p,b), initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b)) + initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey) );
initial_CPI_HGEMED(ey)=sum(gne, initial_P_Q_HGEMED(ey,gne)*mu_cpi(ey,gne)) + sum((l,p,b), initial_P_Q_GEN_HGEMED(ey,l,p,b)*mu_cpi_GEN(ey,l,p,b)) + initial_P_Q_TDeO_HGEMED(ey)*mu_cpi_TDeO(ey);


display
         production_tax_TDeO
         production_tax_GEN
         q_m_GEN_HGEMED
         q_ex_GEN_HGEMED
         p_m_GEN_HGEMED
         p_ex_GEN_HGEMED
         dist_factor_HGEMED
*         mkt_surplus_HGEMED
         init_oem_vom_HGEMED
         init_oem_fom_labor_HGEMED
         init_oem_fom_social_contribution_HGEMED
         init_oem_fom_equipments_HGEMED
         thermodynamic_efficiency_HGEMED
         init_own_cons_gen_pctg_HGEMED
         init_overnight_costs_HGEMED
         tdeo_losses_pctg_HGEMED
         initial_prop_export_energy_only_price_HGEMED
         initial_prop_import_energy_only_price_HGEMED
         initial_pf_pct_adj_HGEMED

*         co2e_content_HGEMED
         pollut_content_HGEMED
         emissions_allowance
         c_h
         c_h_GEN
         c_h_TDeO
         q_i_pf
         s_propensity_h
         tx_rate_sc
         tx_rate_sc_TDeO
         tx_rate_TDeO
         tx_rate_tech
*         tx_rate_GEN
         psc_h
         transf_g_h
         transf_ext_g
         transf_ext_h
         transf_ext_k
         a_va_pf
         alpha_va
         c_ii_share
         c_ii_share_GEN
         c_ii_share_TDeO
         c_va_share
         a_d_q
         a_d_m
         alpha_d
         b_q_q
         b_q_ex
         beta_q
         c_pf_TDeO_share
         c_ii_gne_TDeO
         c_ii_elec_TDeO
         c_ii_TDeO_TDeO
         c_va_TDeO_share
         q_gov_initial
         q_gov_GEN_initial
         q_gov_TDeO_initial
         Theta
         mu_cpi_GEN
         mu_cpi_TDeO

*Initial Variable Values
       initial_Q_H_D_HGEMED
       initial_Q_H_D_GEN_HGEMED
       initial_Q_H_D_TDeO_HGEMED
       initial_P_PF_LABOR_HGEMED
       initial_P_PF_CAPITAL_HGEMED
       initial_Y_H_HGEMED
       initial_Q_PF_SNE_LABOR_HGEMED
       initial_Q_PF_SNE_CAPITAL_HGEMED
       initial_Q_VA_HGEMED
       initial_P_VA_HGEMED
       initial_Q_II_HGEMED
       initial_Q_II_GEN_SNE_HGEMED
       initial_Q_II_TDeO_SNE_HGEMED
       initial_Q_S_HGEMED
       initial_P_S_HGEMED
       initial_Q_M_HGEMED
       initial_Q_D_HGEMED
       initial_P_D_HGEMED
       initial_Q_EX_HGEMED
       initial_Q_Q_HGEMED
       initial_P_Q_HGEMED
       initial_Q_PF_LABOR_TDeO_HGEMED
       initial_Q_PF_CAPITAL_TDeO_HGEMED
       initial_Q_VA_TDeO_HGEMED
       initial_P_VA_TDeO_HGEMED
       initial_Q_II_GNE_TDeO_HGEMED
       initial_Q_II_GEN_TDeO_HGEMED
       initial_Q_II_TDeO_TDeO_HGEMED
       initial_Q_S_TDeO_HGEMED
       initial_P_S_TDeO_HGEMED
       initial_Q_D_TDeO_HGEMED
       initial_P_D_TDeO_HGEMED
       initial_Q_Q_TDeO_HGEMED
       initial_P_Q_TDeO_HGEMED
       initial_Q_PF_LABOR_GEN_tech_HGEMED
       initial_Q_PF_CAPITAL_GEN_tech_HGEMED
       initial_Q_II_GNE_GEN_tech_HGEMED
       initial_Q_II_GEN_GEN_tech_HGEMED
       initial_Q_II_TDeO_GEN_tech_HGEMED
       initial_Q_S_TECH_HGEMED
       initial_Q_S_GEN_HGEMED
       initial_P_S_GEN_HGEMED
       initial_Q_Q_GEN_HGEMED
       initial_P_Q_GEN_HGEMED
       initial_Y_G_HGEMED
       initial_E_G_HGEMED
       initial_Y_TAX_HGEMED
       initial_S_TOTAL_HGEMED
       initial_S_TOTAL_H_HGEMED
       initial_S_TOTAL_G_HGEMED
       initial_S_TOTAL_EXT_HGEMED
       initial_I_TOTAL_HGEMED
       initial_Q_I_D_HGEMED
       initial_CPI_HGEMED
       initial_WALRAS_HGEMED
       initial_PGEN_HGEMED
       initial_PPUMPED_HGEMED
       initial_RES_HGEMED
       initial_PINS_HGEMED
       initial_INSTALLED_CAPACITY_HGEMED
       initial_INCREASED_DR_LOAD_HGEMED
       initial_DECREASED_DR_LOAD_HGEMED
       initial_CONSERVED_DR_LOAD_HGEMED
       initial_FUEL_PRICE_HGEMED
       initial_LAMBDA_DEM_HGEMED
       initial_LAMBDA_RES_HGEMED
       initial_LAMBDA_PUMP_EFF_HGEMED
       initial_LAMBDA_PUMP_MAX_HGEMED
       initial_LAMBDA_DISPATCHABLE_RESERVES_HGEMED
       initial_LAMBDA_RoR_HGEMED
       initial_LAMBDA_FG_FUEL_OIL_USE_HGEMED
       initial_LAMBDA_FG_NATURAL_GAS_USE_HGEMED
       initial_LAMBDA_WIND_HGEMED
       initial_LAMBDA_ORSR_HGEMED
       initial_LAMBDA_PINS_CAPACITY_HGEMED
       initial_LAMBDA_PINS_AVAILABILITY_HGEMED
*       initial_LAMBDA_MAX_DISPL_HGEMED
*       initial_LAMBDA_DISPL_BAL_HGEMED
*       initial_LAMBDA_CONSERV_LIMIT_HGEMED
*       initial_LAMBDA_REQ_SAVINGS_HGEMED
       ;

$ontext
parameter aaa(eys,l,p,b),bbb(eys,l,p,b),ccc(eys,l,p,b);

aaa(eys,l,p,b) = ( initial_Q_H_D_GEN_HGEMED("2005",l,p,b)*((1 + demand_growth)**(eys.val - 2005)));
bbb(eys,l,p,b) = sum(sne, initial_Q_II_GEN_SNE_HGEMED("2005",l,p,b,sne)*((1 + demand_growth)**(eys.val - 2005)));
ccc(eys,l,p,b) = ( q_ex_GEN_HGEMED("2005",l,p,b) *((1 + demand_growth)**(eys.val - 2005)));

*aaa(eys,l,p,b) = ( demand("2005","households",l,p,b) *((1 + demand_growth)**(eys.val - 2005)));
*bbb(eys,l,p,b) = sum(sne, demand("2005",sne,l,p,b)*((1 + demand_growth)**(eys.val - 2005)));
*ccc(eys,l,p,b) = ( demand("2005","Exports",l,p,b) *((1 + demand_growth)**(eys.val - 2005)));

*E_I_ENERGY_SAMDIS(ey,i,l,dp,db) =e= demand(ey,i,l,dp,db)*duration(l,dp,db)*energy_only_price_SAMDIS(ey,l,dp,db) / 10**6;
*initial_Q_H_D_GEN_HGEMED(ey,l,p,b)$initial_P_Q_GEN_HGEMED(ey,l,p,b)=E_I_ENERGY_SAMDIS.l(ey,"Households",l,p,b)/initial_P_Q_GEN_HGEMED(ey,l,p,b);

display aaa, bbb, ccc, demand;
$offtext


*---------scaling parameters---------------
parameter scale_factor    /1/;
scale_factor=1e5;
HGEMED_scale_parameters(/)
*---------end of scaling parameters---------------

display  initial_Q_M_HGEMED, p_m_initial, initial_Q_S_HGEMED, initial_P_S_HGEMED;

*---------Scalling CES Parameters---------------
*Scalling CES Parameters to avoid exagerated dimension calculations
parameters
         scaleparameter_a_VA(ey,sne)
         scaleparameter_a_D(ey,gne)
         scaleparameter_b_EX(ey,gne);

         scaleparameter_a_VA(ey,sne)=1;
         scaleparameter_a_D(ey,gne)=1;
         scaleparameter_b_EX(ey,gne)=1;

         scaleparameter_a_VA(ey,sne)$((a_va_pf(ey,"Labor",sne)*a_va_pf(ey,"Capital",sne)) lt 1e-3) = min(a_va_pf(ey,"Labor",sne),a_va_pf(ey,"Capital",sne))*1e3;
         a_va_pf(ey,"Labor",sne)=a_va_pf(ey,"Labor",sne)/scaleparameter_a_VA(ey,sne);
         a_va_pf(ey,"Capital",sne)=a_va_pf(ey,"Capital",sne)/scaleparameter_a_VA(ey,sne);
         alpha_va(ey,sne)=alpha_va(ey,sne)*scaleparameter_a_VA(ey,sne)**[elasticity_va(sne)/(elasticity_va(sne)-1)];

         scaleparameter_a_D(ey,gne)$((a_d_q(ey,gne)*a_d_m(ey,gne)) lt 1e-3) = min(a_d_q(ey,gne),a_d_m(ey,gne))*1e3;
         a_d_q(ey,gne)=a_d_q(ey,gne)/scaleparameter_a_D(ey,gne);
         a_d_m(ey,gne)=a_d_m(ey,gne)/scaleparameter_a_D(ey,gne);
         alpha_d(ey,gne)=alpha_d(ey,gne)*scaleparameter_a_D(ey,gne)**[elasticity_d(gne)/(elasticity_d(gne)-1)];

         scaleparameter_b_EX(ey,gne) $((b_q_q(ey,gne)*b_q_ex(ey,gne)) lt 1e-3) = min(b_q_q(ey,gne),b_q_ex(ey,gne))*1e3;
         b_q_q(ey,gne)=b_q_q(ey,gne)/scaleparameter_b_EX(ey,gne);
         b_q_ex(ey,gne)=b_q_ex(ey,gne)/scaleparameter_b_EX(ey,gne);
         beta_q(ey,gne)=beta_q(ey,gne)*scaleparameter_b_EX(ey,gne)**[elasticity_q(gne)/(elasticity_q(gne)+1)];
*---------------------------------------------------

*-------------------------------------------------------------------------------
*------------------------------------- Variables -------------------------------
*-------------------------------------------------------------------------------
Variables
         Q_H_D_HGEMED(y,gne)       Household domestic non electricity goods demand
         Q_H_D_GEN_HGEMED(y,l,p,b) Household domestic electricity goods demand at location l - season p and load block b
         Q_H_D_TDeO_HGEMED(y)      Household domestic electricity goods demand of transmission distribution and other electricity services
         P_PF_LABOR_HGEMED(y)      Price of production factor labor
         P_PF_CAPITAL_HGEMED(y)    Price of production factor capital
         Y_H_HGEMED(y)             Total household income
         Q_PF_SNE_LABOR_HGEMED(y,sne) Quantity of production factor labor
         Q_PF_SNE_CAPITAL_HGEMED(y,sne) Quantity of production factor capital
         Q_VA_HGEMED(y,sne)        Quantity of value added composite good produced by non electricity sector sne
         P_VA_HGEMED(y,sne)        Price of value added composite good of a specific non electricity sector sne
         Q_II_HGEMED(y,gne,sne)    Quantity of non electricity intermediary input gne utilized by a specific non electricity sector sne
         Q_II_GEN_SNE_HGEMED(y,l,p,b,sne)  Quantity of electricity good intermediary input at location l - season p and load block b utilized by a specific non electricity sector sne
         Q_II_TDeO_SNE_HGEMED(y,sne)  Quantity of transmission distribution and other electricity services intermediary input utilized by a specific non electricity sector sne
         Q_S_HGEMED(y,sne)         Quantity of the commodity produced by a specific non electricity sector sne
         P_S_HGEMED(y,gne)         Price of commodity produced by a specific non electricity sector sne (without foreign aggregations and production taxes)
         Q_M_HGEMED(y,gne)         Quantity of non electricity good gne imported from the exterior
         Q_D_HGEMED(y,gne)         Quantity of aggregated imported and domestic produced supply of non electricity good gne
         P_D_HGEMED(y,gne)         Price of Armington aggregated price of the non electricity good gne
         Q_EX_HGEMED(y,gne)        Quantity of non electricity goods gne exported to the exterior
         Q_Q_HGEMED(y,gne)         Quantity of final domestic market supply of non electricity good gne
         P_Q_HGEMED(y,gne)         Price of final domestic non electricity good gne
         Q_PF_LABOR_TDeO_HGEMED(y) Quantity of production factor labor used in the transmission distribution and other electricity services
         Q_PF_CAPITAL_TDeO_HGEMED(y) Quantity of production factor capital used in the transmission distribution and other electricity services
         Q_VA_TDeO_HGEMED(y)       Quantity of value added composite good produced by the transmission distribution and other electricity services
         P_VA_TDeO_HGEMED(y)       Price of value added composite good of the transmission distribution and other electricity services
         Q_II_GNE_TDeO_HGEMED(y,gne) Quantity of non electricity intermediary input gne utilized by the transmission distribution and other electricity services
         Q_II_GEN_TDeO_HGEMED(y,l,dp,db) Quantity of electricity good intermediary input at location l - season dp and load block db utilized by the transmission distribution and other electricity services
         Q_II_TDeO_TDeO_HGEMED(y)  Quantity of transmission distribution and other electricity services good intermediary input utilized by the electricity transmission distribution and other electricity services
         Q_S_TDeO_HGEMED(y)        Quantity of the commodity produced by the transmission distribution and other electricity services
         P_S_TDeO_HGEMED(y)        Price of commodity produced by the transmission distribution and other electricity services (without foreign aggregations and production taxes)
         Q_D_TDeO_HGEMED(y)        Quantity of aggregated imported and domestic produced supply of transmission distribution and other electricity services
         P_D_TDeO_HGEMED(y)        Price of aggregated transmission distribution and other electricity services
         Q_Q_TDeO_HGEMED(y)        Quantity of final domestic market supply of transmission distribution and other electricity services
         P_Q_TDeO_HGEMED(y)        Price of final domestic transmission distribution and other electricity services
         Q_PF_LABOR_GEN_tech_HGEMED(y,l,p,b,t) Quantity of production factor labor used in the electricity sector at location l - season p and load block b
         Q_PF_CAPITAL_GEN_tech_HGEMED(y,l,p,b,t) Quantity of production factor capital used in the electricity sector at location l - season p and load block b
         Q_II_GNE_GEN_tech_HGEMED(y,gne,l,p,b,t) Quantity of non electricity intermediary input gne utilized by the electricity sector at location l - season p and load block b
         Q_II_GEN_GEN_tech_HGEMED(y,l,dp,db,gp,gb,t) Quantity of electricity good intermediary input at location l - season dp and load block db utilized by the electricity sector at season gp and load block gb
         Q_II_TDeO_GEN_tech_HGEMED(y,l,p,b,t) Quantity of electricity transmission distribution and other electricity services good intermediary input utilized by the electricity sector at season gp and load block gb
         Q_S_TECH_HGEMED(y,l,p,b,t)  Quantity of the commodity produced by the electricity technology t at location l - season p and load block b
         Q_S_GEN_HGEMED(y,l,p,b)   Quantity of the commodity produced by the electricity sector at location l - season p and load block b
         P_S_GEN_HGEMED(y,l,p,b)   Price of commodity produced by the electricity sector at location l - season p and load block b (without foreign aggregations and production taxes)
         Q_Q_GEN_HGEMED(y,l,p,b)   Quantity of final domestic market supply of electricity good at location l - season p and load block b
         P_Q_GEN_HGEMED(y,l,p,b)   Price of final domestic electricity good at location l - season p and load block b
         Y_G_HGEMED(y)             Total government income
         E_G_HGEMED(y)             Total government expenditure
         Y_TAX_HGEMED(y)           Total government taxes income
         S_TOTAL_HGEMED(y)         Total economy savings
         S_TOTAL_H_HGEMED(y)       Households savings
         S_TOTAL_G_HGEMED(y)       Government savings
         S_TOTAL_EXT_HGEMED(y)     Foreign total savings
         I_TOTAL_HGEMED(y)         Total investment
         Q_I_D_HGEMED(y,gne)       Quantity of non electricity good gne demanded as investment good (electricity cannot be a investment good because it is not storable)
         CPI_HGEMED(y)             Numeraire
         DUMMY_HGEMED              Dummy variable used on NLP solution
         WALRAS_HGEMED(y)          Walras check variable applied to savings investments equality
*Bottom-up Electricity model
         PGEN_HGEMED(y,t,f,l,p,b)          MWh              Electricity power generation by each technology
         PPUMPED_HGEMED(y,l,p,b)           MWh              Pumping consumed electricity power
         RES_HGEMED(y,l,p)                 MWh              Hydro technology reservoir level
         PINS_HGEMED(y,l,t)                MW              New capacity instaled potency
         INSTALLED_CAPACITY_HGEMED(y,l,t)  MW              Total capacity instaled potency
*DR Case study variables
         INCREASED_DR_LOAD_HGEMED(y,l,p,b)
         DECREASED_DR_LOAD_HGEMED(y,l,p,b)
         CONSERVED_DR_LOAD_HGEMED(y,l,p,b)
*Tax Case study variables
         Y_ENV_TAX_HGEMED(ey,pollut)
         SC_ENV_SUBSIDY_RATE_HGEMED(ey)
         LUMP_SUM_ENV_SUBSIDY_HGEMED(ey)
         RENEWABLE_PREMIUM_TAX_RATE_HGEMED(ey,s)
         Y_FUEL_TAX_HGEMED(ey)
*additional variable for fuel sector correspondence
         FUEL_PRICE_HGEMED(y,t,f)

         mkt_surplus_HGEMED(ey,l,p,b)
;

*Additional Dual Variables:
Negative Variables
*Bottom-up Electricity model
         LAMBDA_DEM_HGEMED(y,l,p,b), LAMBDA_RES_HGEMED(y,l,p), LAMBDA_PUMP_EFF_HGEMED(y,l,p), LAMBDA_PUMP_MAX_HGEMED(y,l,p), LAMBDA_DISPATCHABLE_RESERVES_HGEMED(y,l),
         LAMBDA_RoR_HGEMED(y,l,p,b), LAMBDA_FG_FUEL_OIL_USE_HGEMED(y,l,p,b), LAMBDA_FG_NATURAL_GAS_USE_HGEMED(y,l,p,b)
         LAMBDA_WIND_HGEMED(y,l,p,b), LAMBDA_ORSR_HGEMED(y,l,p,b), LAMBDA_PINS_CAPACITY_HGEMED(y,l,t),
         LAMBDA_PINS_AVAILABILITY_HGEMED(y,t,f,l,p,b),
*Case study variables
         LAMBDA_MAX_DISPL_HGEMED(y,l,p,b), LAMBDA_DISPL_BAL_HGEMED(y,l,p), LAMBDA_CONSERV_LIMIT_HGEMED(y,l,p,b), LAMBDA_REQ_SAVINGS_HGEMED(y,l,p)
;


Positive Variables
         Q_H_D_HGEMED, Q_H_D_GEN_HGEMED, Q_H_D_TDeO_HGEMED, P_PF_LABOR_HGEMED, P_PF_CAPITAL_HGEMED,
         Y_H_HGEMED, Q_PF_SNE_LABOR_HGEMED, Q_PF_SNE_CAPITAL_HGEMED, Q_VA_HGEMED, P_VA_HGEMED,
         Q_II_HGEMED, Q_II_GEN_SNE_HGEMED, Q_II_TDeO_SNE_HGEMED, Q_S_HGEMED, P_S_HGEMED, Q_M_HGEMED,
         Q_D_HGEMED, P_D_HGEMED, Q_Q_HGEMED, P_Q_HGEMED, Q_PF_LABOR_TDeO_HGEMED, Q_PF_CAPITAL_TDeO_HGEMED,
         Q_VA_TDeO_HGEMED, P_VA_TDeO_HGEMED, Q_II_GNE_TDeO_HGEMED,Q_II_GEN_TDeO_HGEMED,Q_II_TDeO_TDeO_HGEMED,
         Q_S_TDeO_HGEMED,P_S_TDeO_HGEMED,Q_D_TDeO_HGEMED,P_D_TDeO_HGEMED,Q_Q_TDeO_HGEMED,P_Q_TDeO_HGEMED,
         Q_PF_LABOR_GEN_tech_HGEMED,Q_PF_CAPITAL_GEN_tech_HGEMED,
         Q_II_GNE_GEN_tech_HGEMED,Q_II_GEN_GEN_tech_HGEMED,
         Q_II_TDeO_GEN_tech_HGEMED, Q_S_TECH_HGEMED,
         Q_S_GEN_HGEMED, P_S_GEN_HGEMED,
         Q_Q_GEN_HGEMED, P_Q_GEN_HGEMED, Y_G_HGEMED,E_G_HGEMED,
         Y_TAX_HGEMED,S_TOTAL_HGEMED,S_TOTAL_H_HGEMED,S_TOTAL_G_HGEMED, S_TOTAL_EXT_HGEMED,I_TOTAL_HGEMED,Q_I_D_HGEMED
         PGEN_HGEMED, PPUMPED_HGEMED, RES_HGEMED, PINS_HGEMED, INSTALLED_CAPACITY_HGEMED
         INCREASED_DR_LOAD_HGEMED,DECREASED_DR_LOAD_HGEMED,CONSERVED_DR_LOAD_HGEMED
         FUEL_PRICE_HGEMED
         Y_ENV_TAX_HGEMED, SC_ENV_SUBSIDY_RATE_HGEMED, LUMP_SUM_ENV_SUBSIDY_HGEMED, RENEWABLE_PREMIUM_TAX_RATE_HGEMED, Y_FUEL_TAX_HGEMED
;



display pollutant_price;

*Reservoir Intra year management
RES_HGEMED.fx(eys,l,p1) = res_init(eys,l,"Hyd_Res");
RES_HGEMED.up(eys,l,p) = res_max(eys,l,"Hyd_Res");

*-------------------------------------------------------------------------------
*----------------------------- Defining Model Equations ------------------------
*-------------------------------------------------------------------------------
Equations
         eq_7_3_1(ey,gne)
         eq_7_3_2(ey,l,p,b)
         eq_7_3_3(ey)
         eq_7_3_4(ey)
         eq_7_3_5(ey)
         eq_7_3_6(ey,sne)
         eq_7_3_7(ey,sne)
         eq_7_3_8(ey,sne)
         eq_7_3_9(ey,gne,sne)
         eq_7_3_10(ey,l,p,b,sne)
         eq_7_3_11(ey,sne)
         eq_7_3_12(ey,sne)
         eq_7_3_13(ey,sne)
         eq_7_3_14(ey,gne)
         eq_7_3_15(ey,gne)
         eq_7_3_16(ey,gne)
         eq_7_3_17(ey,gne)
         eq_7_3_18(ey,gne)
         eq_7_3_19(ey,gne)
         eq_7_3_20_a(ey)
         eq_7_3_20_b(ey)
         eq_7_3_21(ey)
         eq_7_3_22(ey,gne)
         eq_7_3_23(ey,l,dp,db)
         eq_7_3_24(ey)
         eq_7_3_25(ey)
         eq_7_3_26(ey)
         eq_7_3_27(ey)
         eq_7_3_28(ey)
         eq_7_3_29(ey)
         eq_7_3_30(ey)
         eq_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)
         eq_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t)
         eq_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)
         eq_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t)
         eq_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t)
         eq_Q_S_TECH_HGEMED(ey,l,p,b,t)
         eq_Q_S_GEN_HGEMED(ey,l,p,b)
         eq_P_S_GEN_HGEMED(ey,l,p,b)
         eq_Q_Q_GEN_HGEMED(ey,l,p,b)
         eq_P_Q_GEN_HGEMED(ey,l,p,b)
         eq_FUEL_PRICE_HGEMED(ey,t,f)
         eq_dL_dPGEN_HGEMED(eys,t,f,l,p,b)
         eq_dL_dPPUMPED_HGEMED(eys,l,p,b)
         eq_dL_RES_HGEMED(eys,l,p)
         eq_dL_PINS_HGEMED(eys,l,t)
         eq_dL_dINSTALLED_CAPACITY_HGEMED(eys,l,t)
         eq_dL_dLAMBDA_DEM_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_DR_DEM_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_RES_HGEMED(eys,l,p)
         eq_dL_dLAMBDA_PUMP_EFF_HGEMED(eys,l,p)
         eq_dL_dLAMBDA_PUMP_MAX_HGEMED(eys,l,p)
         eq_dL_dLAMBDA_DISPATCHABLE_RESERVES_HGEMED(eys,l)
         eq_dL_dLAMBDA_RoR_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_WIND_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_ORSR_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_PINS_CAPACITY_HGEMED(eys,l,t)
         eq_dL_dLAMBDA_PINS_AVAILABILITY_HGEMED(eys,t,f,l,p,b)
         eq_7_3_44(ey)
         eq_7_3_45(ey)
         eq_7_3_46(ey)
         eq_7_3_47(ey)
         eq_7_3_48(ey)
         eq_7_3_49(ey)
         eq_7_3_50(ey,gne)
         eq_7_3_51_a(ey)
         eq_7_3_51_b(ey)
         eq_7_3_52(ey,gne)
         eq_7_3_53(ey,l,p,b)
         eq_7_3_54(ey)
         eq_7_3_55(ey)
         eq_CPI(ey)
         eq_object_function_HGEMED
*case study equations
************eq_7_3_42_case_study(ey,l,p,b)
         eq_dL_dLAMBDA_DR_DEM_HGEMED(eys,l,p,b)
         eq_dL_dINCREASED_DR_LOAD_HGEMED(eys,l,p,b)
         eq_dL_dDECREASED_DR_LOAD_HGEMED(eys,l,p,b)
         eq_dL_dCONSERVED_DR_LOAD_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_MAX_DISPL_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_DISPL_BAL_HGEMED(eys,l,p)
         eq_dL_dLAMBDA_CONSERV_LIMIT_HGEMED(eys,l,p,b)
         eq_dL_dLAMBDA_REQ_SAVINGS_HGEMED(eys,l,p)


*case study equations
         eq_extra_1_HGEMED(ey,pollut)
         eq_extra_2_HGEMED(ey)
         eq_extra_3_HGEMED(ey)
         eq_extra_4_HGEMED(ey,s)
*         eq_extra_5_HGEMED(ey)
;

******* HOUSEHOLDS **************************************
eq_7_3_1(ey,gne)..
Q_H_D_HGEMED(ey,gne)=e= ( c_h(ey,gne)/propensity_scale*(1-s_propensity_h(ey))*Y_H_HGEMED(ey) ) / ( (1+tx_rate(ey,"Households","Product_Tax"))*P_Q_HGEMED(ey,gne) );

eq_7_3_2(ey,l,p,b)..
Q_H_D_GEN_HGEMED(ey,l,p,b) * ( (1+tx_rate(ey,"Households","Product_Tax"))*P_Q_GEN_HGEMED(ey,l,p,b) ) =e= ( c_h_GEN(ey,l,p,b)/propensity_scale*(1-s_propensity_h(ey))*Y_H_HGEMED(ey) );

eq_7_3_3(ey)..
Q_H_D_TDeO_HGEMED(ey) =e= ( c_h_TDeO(ey)/propensity_scale*(1-s_propensity_h(ey))*Y_H_HGEMED(ey) ) / ( (1+tx_rate(ey,"Households","Product_Tax"))*P_Q_TDeO_HGEMED(ey) );

eq_7_3_4(ey)..
Y_H_HGEMED(ey)=e=q_i_pf(ey,"Households","Labor")*P_PF_LABOR_HGEMED(ey) + q_i_pf(ey,"Households","Capital")*P_PF_CAPITAL_HGEMED(ey)+transf_g_h(ey)
                 + psc_h(ey)*( sum((sne),(tx_rate_sc(ey,"Labor",sne)-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc(ey,"Labor",sne)*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)*Q_PF_SNE_LABOR_HGEMED(ey,sne))
                               + (tx_rate_sc_TDeO(ey,"Labor")-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc_TDeO(ey,"Labor")*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_TDeO_HGEMED(ey)
                               + sum((l,p,b,t),(tx_rate_sc_tech(ey,"Labor",l,p,b,t)-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc_tech(ey,"Labor",l,p,b,t)*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*( P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)  ))
                             )
                 +transf_ext_h(ey)
*                 - sum(pollut, top_down_pollutant_content(ey,pollut,"Households")*( sum(gne, (initial_P_Q_HGEMED(ey,gne)/(initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)))*Q_H_D_HGEMED(ey,gne)) + (initial_P_Q_TDeO_HGEMED(ey)/(initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey)))*Q_H_D_TDeO_HGEMED(ey) + sum((l,p,b), (initial_P_Q_GEN_HGEMED(ey,l,p,b)/(initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b)))*Q_H_D_GEN_HGEMED(ey,l,p,b)) )*pollutant_price(ey,pollut,"Households"))
                 - sum(pollut, top_down_pollutant_content(ey,pollut,"Households")*( (Y_H_HGEMED(ey)/initial_Y_H_HGEMED(ey)) )*pollutant_price(ey,pollut,"Households"))
;

eq_7_3_5(ey)..
S_TOTAL_H_HGEMED(ey)=e=s_propensity_h(ey)*Y_H_HGEMED(ey);

******** NON ELECTRICITY SECTORS ************************
eq_7_3_6(ey,sne)..
(Q_PF_SNE_LABOR_HGEMED(ey,sne)**(1/elasticity_va(sne)))*a_va_pf(ey,"Capital",sne)*(1+tx_rate_sc(ey,"Labor",sne))*(1-SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)=e=(Q_PF_SNE_CAPITAL_HGEMED(ey,sne)**(1/elasticity_va(sne)))*a_va_pf(ey,"Labor",sne)*P_PF_CAPITAL_HGEMED(ey);

eq_7_3_7(ey,sne)..
Q_VA_HGEMED(ey,sne)=e=alpha_va(ey,sne)*[ ( (a_va_pf(ey,"Labor",sne)*(Q_PF_SNE_LABOR_HGEMED(ey,sne)**((elasticity_va(sne)-1)/elasticity_va(sne)))) + (a_va_pf(ey,"Capital",sne)*(Q_PF_SNE_CAPITAL_HGEMED(ey,sne)**((elasticity_va(sne)-1)/elasticity_va(sne)))) )** ( elasticity_va(sne)/(elasticity_va(sne)-1) ) ];

eq_7_3_8(ey,sne)..
Q_VA_HGEMED(ey,sne)*P_VA_HGEMED(ey,sne)=e= (1+tx_rate_sc(ey,"Labor",sne))*(1-SC_ENV_SUBSIDY_RATE_HGEMED(ey))*Q_PF_SNE_LABOR_HGEMED(ey,sne)*P_PF_LABOR_HGEMED(ey) + Q_PF_SNE_CAPITAL_HGEMED(ey,sne)*P_PF_CAPITAL_HGEMED(ey);

eq_7_3_9(ey,gne,sne)..
Q_II_HGEMED(ey,gne,sne)=e=c_ii_share(ey,gne,sne)*Q_S_HGEMED(ey,sne);

eq_7_3_10(ey,l,p,b,sne)..
Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne) =e= c_ii_share_GEN(ey,l,p,b,sne)*Q_S_HGEMED(ey,sne);

eq_7_3_11(ey,sne)..
Q_II_TDeO_SNE_HGEMED(ey,sne) =e= c_ii_share_TDeO(ey,sne)*Q_S_HGEMED(ey,sne);

eq_7_3_12(ey,sne)..
Q_VA_HGEMED(ey,sne)=e=c_va_share(ey,sne)*Q_S_HGEMED(ey,sne);

eq_7_3_13(ey,sne)..
Q_S_HGEMED(ey,sne)*P_S_HGEMED(ey,sne)+sum(i,e_transf_i_s(ey,i,sne))=e= Q_VA_HGEMED(ey,sne)*P_VA_HGEMED(ey,sne) + sum(gne, Q_II_HGEMED(ey,gne,sne)*(1+tx_rate(ey,sne,"Product_tax"))*P_Q_HGEMED(ey,gne)) + sum((l,p,b), Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne)*(1+tx_rate(ey,sne,"Product_tax"))*P_Q_GEN_HGEMED(ey,l,p,b)) + Q_II_TDeO_SNE_HGEMED(ey,sne)*(1+tx_rate(ey,sne,"Product_tax"))*P_Q_TDeO_HGEMED(ey) + sum(pollut,top_down_pollutant_content(ey,pollut,sne)*(initial_P_S_HGEMED(ey,sne)/(initial_Q_S_HGEMED(ey,sne)*initial_P_S_HGEMED(ey,sne)))*Q_S_HGEMED(ey,sne)*pollutant_price(ey,pollut,sne))+ e_tx_sam(ey,"Production_Taxes",sne);

eq_7_3_14(ey,gne)..
(Q_S_HGEMED(ey,gne)**(1/elasticity_d(gne)))*a_d_m(ey,gne)*P_S_HGEMED(ey,gne)=e=(Q_M_HGEMED(ey,gne)**(1/elasticity_d(gne)))*a_d_q(ey,gne)*p_m_initial(ey,gne);

eq_7_3_15(ey,gne)..
Q_D_HGEMED(ey,gne)=e=  alpha_d(ey,gne)*[ ( a_d_q(ey,gne)*(Q_S_HGEMED(ey,gne)**((elasticity_d(gne)-1)/elasticity_d(gne))) +  a_d_m(ey,gne)*(Q_M_HGEMED(ey,gne)**((elasticity_d(gne)-1)/elasticity_d(gne))) )** ( elasticity_d(gne)/(elasticity_d(gne)-1) ) ];

eq_7_3_16(ey,gne)..
Q_D_HGEMED(ey,gne)*P_D_HGEMED(ey,gne)=e=P_S_HGEMED(ey,gne)*Q_S_HGEMED(ey,gne) + p_m_initial(ey,gne)*Q_M_HGEMED(ey,gne);

eq_7_3_17(ey,gne)..
Q_Q_HGEMED(ey,gne)*(b_q_q(ey,gne)**elasticity_q(gne))*(((1+tx_rate(ey,"Exports","Product_Tax"))*p_ex_initial(ey,gne))**elasticity_q(gne))=e=Q_EX_HGEMED(ey,gne)*(b_q_ex(ey,gne)**elasticity_q(gne))*(P_Q_HGEMED(ey,gne)**elasticity_q(gne));

eq_7_3_18(ey,gne)..
Q_D_HGEMED(ey,gne)=e= beta_q(ey,gne)*[ ( b_q_q(ey,gne)*(Q_Q_HGEMED(ey,gne)**((elasticity_q(gne)+1)/elasticity_q(gne))) + b_q_ex(ey,gne)*(Q_EX_HGEMED(ey,gne)**((elasticity_q(gne)+1)/elasticity_q(gne))) )** ( elasticity_q(gne)/(elasticity_q(gne)+1) ) ];

eq_7_3_19(ey,gne)..
Q_D_HGEMED(ey,gne)*P_D_HGEMED(ey,gne)=e=Q_Q_HGEMED(ey,gne)*P_Q_HGEMED(ey,gne)
*- RENEWABLE_PREMIUM_TAX_RATE_HGEMED(ey,gne)*Q_Q_HGEMED(ey,gne)*P_Q_HGEMED(ey,gne)
+ (LUMP_SUM_ENV_SUBSIDY_HGEMED(ey))*Q_Q_HGEMED(ey,gne)*P_Q_HGEMED(ey,gne) + p_ex_initial(ey,gne)*Q_EX_HGEMED(ey,gne);

******** TRANSMISSION, DISTRIBUTION AND OTHERS **********
eq_7_3_20_a(ey)..
Q_PF_LABOR_TDeO_HGEMED(ey)=e=Q_VA_TDeO_HGEMED(ey)*c_pf_TDeO_share(ey,"Labor");

eq_7_3_20_b(ey)..
Q_PF_CAPITAL_TDeO_HGEMED(ey)=e=Q_VA_TDeO_HGEMED(ey)*c_pf_TDeO_share(ey,"Capital");

eq_7_3_21(ey)..
Q_VA_TDeO_HGEMED(ey)*P_VA_TDeO_HGEMED(ey)=e=(1+tx_rate_sc_TDeO(ey,"Labor"))*(1-SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_TDeO_HGEMED(ey) +  P_PF_CAPITAL_HGEMED(ey)*Q_PF_CAPITAL_TDeO_HGEMED(ey);

eq_7_3_22(ey,gne)..
Q_S_TDeO_HGEMED(ey)*c_ii_gne_TDeO(ey,gne)=e=Q_II_GNE_TDeO_HGEMED(ey,gne);

eq_7_3_23(ey,l,dp,db)..
Q_S_TDeO_HGEMED(ey)*c_ii_elec_TDeO(ey,l,dp,db)=e=Q_II_GEN_TDeO_HGEMED(ey,l,dp,db);

eq_7_3_24(ey)..
Q_S_TDeO_HGEMED(ey)*c_ii_TDeO_TDeO(ey)=e=Q_II_TDeO_TDeO_HGEMED(ey);

eq_7_3_25(ey)..
Q_S_TDeO_HGEMED(ey)*c_va_TDeO_share(ey)=e=Q_VA_TDeO_HGEMED(ey);

eq_7_3_26(ey)..
P_S_TDeO_HGEMED(ey)*Q_S_TDeO_HGEMED(ey)=e=P_VA_TDeO_HGEMED(ey)*Q_VA_TDeO_HGEMED(ey)+sum(gne, (1+tx_rate_TDeO(ey,"Product_tax"))*P_Q_HGEMED(ey,gne)*Q_II_GNE_TDeO_HGEMED(ey,gne))+ sum((l,dp,db), (1+tx_rate_TDeO(ey,"Product_tax"))*P_Q_GEN_HGEMED(ey,l,dp,db)*Q_II_GEN_TDeO_HGEMED(ey,l,dp,db))  + Q_II_TDeO_TDeO_HGEMED(ey)*(1+tx_rate_TDeO(ey,"Product_tax"))*P_Q_TDeO_HGEMED(ey)+production_tax_TDeO(ey);

eq_7_3_27(ey)..
Q_D_TDeO_HGEMED(ey) =e= Q_S_TDeO_HGEMED(ey);

eq_7_3_28(ey)..
P_D_TDeO_HGEMED(ey)*Q_D_TDeO_HGEMED(ey) =e= P_S_TDeO_HGEMED(ey)*Q_S_TDeO_HGEMED(ey);

eq_7_3_29(ey)..
Q_Q_TDeO_HGEMED(ey) =e= Q_D_TDeO_HGEMED(ey);

eq_7_3_30(ey)..
P_Q_TDeO_HGEMED(ey)*Q_Q_TDeO_HGEMED(ey)+ (LUMP_SUM_ENV_SUBSIDY_HGEMED(ey))*P_Q_TDeO_HGEMED(ey)*Q_Q_TDeO_HGEMED(ey)=e= P_D_TDeO_HGEMED(ey)*Q_D_TDeO_HGEMED(ey);

******** GENERATION *************************************

eq_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)..
Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)*((1+tx_rate_sc_tech(ey,"Labor",l,p,b,t))*(1-SC_ENV_SUBSIDY_RATE_HGEMED(ey)))*P_PF_LABOR_HGEMED(ey) =e= dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*(init_oem_fom_labor_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 1e3);

eq_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t)..
Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t) =e= dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*( ( init_overnight_costs_HGEMED(ey,t)*idc(t)*capital_recovery_factor(t)*( existent_installed_capacity_to_be_amortized(ey,l,t) + sum((eys_alias)$((ord(eys_alias) le ord(ey)) and (ord(eys_alias) gt (ord(ey)-power_plant_time_life(t)))),PINS_HGEMED(eys_alias,l,t)) )/1e3) )/P_PF_CAPITAL_HGEMED(ey);

eq_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)..
Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t) =e= ( ( init_oem_vom_HGEMED(ey,t)*Q_S_TECH_HGEMED(ey,l,p,b,t) )$(SAMEAS(gne,"Manufactures"))
                                             + ( sum((f)$(s_f(gne,f) and t_f(t,f)), thermodynamic_efficiency_HGEMED(ey,t,f)*FUEL_PRICE_HGEMED(ey,t,f)*PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b) / 1e6 ) )$((duration(l,p,b)<>0) and (t_s(t,gne)) and ((SAMEAS(gne,"Coal") OR SAMEAS(gne,"Oil-Nuclear") OR SAMEAS(gne,"Gas"))))
                                             + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_equipments_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 1e3 )$ (SAMEAS(gne,"Manufactures")) ) / P_Q_HGEMED(ey,gne);

eq_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t)..
Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t) =e= ( ( init_own_cons_gen_pctg*Q_S_TECH_HGEMED(ey,l,gp,gb,t)*P_S_GEN_HGEMED(ey,l,dp,db) )$((sameas(dp,gp)) and (sameas(db,gb)))
                                                 + ( PPUMPED_HGEMED(ey,l,gp,gb)*duration(l,dp,db)*P_S_GEN_HGEMED(ey,l,dp,db) / 1e6 )$(SAMEAS(t,"Pump") and SAMEAS(dp,gp) and SAMEAS(db,gb)) ) / P_Q_GEN_HGEMED(ey,l,dp,db);

eq_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t)..
Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) =e= 0;

eq_Q_S_TECH_HGEMED(ey,l,p,b,t)..
Q_S_TECH_HGEMED(ey,l,p,b,t) =e= duration(l,p,b)*sum((f)$t_f(t,f), PGEN_HGEMED(ey,t,f,l,p,b) / 1e6 );

eq_Q_S_GEN_HGEMED(ey,l,p,b)..
Q_S_GEN_HGEMED(ey,l,p,b) =e= sum((t), Q_S_TECH_HGEMED(ey,l,p,b,t));

eq_P_S_GEN_HGEMED(ey,l,p,b)..
P_S_GEN_HGEMED(ey,l,p,b) =e= - ( LAMBDA_DEM_HGEMED(ey,l,p,b)*1e6 ) / duration(l,p,b);

eq_Q_Q_GEN_HGEMED(ey,l,p,b)..
Q_Q_GEN_HGEMED(ey,l,p,b) =e= Q_S_GEN_HGEMED(ey,l,p,b) + q_m_GEN_HGEMED(ey,l,p,b) - q_ex_GEN_HGEMED(ey,l,p,b);

eq_P_Q_GEN_HGEMED(ey,l,p,b)..
P_Q_GEN_HGEMED(ey,l,p,b)*Q_Q_GEN_HGEMED(ey,l,p,b)
*- RENEWABLE_PREMIUM_TAX_RATE_HGEMED(ey,"Electricity")*P_Q_GEN_HGEMED(ey,l,p,b)*Q_Q_GEN_HGEMED(ey,l,p,b)
+ (LUMP_SUM_ENV_SUBSIDY_HGEMED(ey))*P_Q_GEN_HGEMED(ey,l,p,b)*Q_Q_GEN_HGEMED(ey,l,p,b)
                                                 =e=   - (1+tx_rate(ey,"Exports","Product_Tax"))*p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b)
*                                                       + sum((t), sum(gne, tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) )
*                                                       + sum((t), tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t))
                                                       + sum((t), sum(gne, (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) )
                                                       + sum((t), (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t))
                                                       + sum((t),sum((dp,db), (1+tx_rate_tech(ey,l,p,b,t,"Product_tax"))*P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)))
                                                       + sum((t), Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)*((1+tx_rate_sc_tech(ey,"Labor",l,p,b,t))*(1-SC_ENV_SUBSIDY_RATE_HGEMED(ey)))*P_PF_LABOR_HGEMED(ey) )
                                                       + sum((t), P_PF_CAPITAL_HGEMED(ey)*Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t))
*                                                       + sum((t),( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) )
                                                       + sum((t,f,pollut)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b)*pollut_content_HGEMED(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity"))
                                                       + production_tax_GEN(ey,l,p,b)
                                                       + p_m_GEN_HGEMED(ey,l,p,b)*q_m_GEN_HGEMED(ey,l,p,b)
                                                       - sum(t, emissions_allowance(ey,l,p,b,t))
                                                       + mkt_surplus_HGEMED(ey,l,p,b);



$ontext

P_Q_GEN_HGEMED(ey,l,p,b)*Q_Q_GEN_HGEMED(ey,l,p,b) =e= P_S_GEN_HGEMED(ey,l,p,b)*Q_S_GEN_HGEMED(ey,l,p,b) + p_m_GEN_HGEMED(ey,l,p,b)*q_m_GEN_HGEMED(ey,l,p,b) - p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b) + mkt_surplus_HGEMED(ey,l,p,b)
                                                      - sum((t), emissions_allowance(ey,l,p,b,t))
                                                      + sum((t),( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) )
                                                      + sum((t),( tx_rate_tech(ey,l,p,b,t,"Product_Tax")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) ) ) )
*                                                      + sum((t),( tx_rate_GEN(ey,l,p,b,"Production_taxes")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) + P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t) +  P_PF_CAPITAL_HGEMED(ey)*Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t) + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) + ( tx_rate(ey,"Electricity","Product_tax")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) - emissions_allowance(ey,l,p,b,t) ) ) ) ) )
                                                       + production_tax_GEN(ey,l,p,b)
*                                                      + sum((t,f)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*co2e_content_HGEMED(f,t)/1e6*co2_price(ey)*duration(l,p,b))
                                                      + (sum((t,f,pollut)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b)*pollut_content_HGEMED(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity")))
                                                      ;

$offtext

eq_FUEL_PRICE_HGEMED(ey,t,f)..
         FUEL_PRICE_HGEMED(ey,t,f) =e= fuel_price(ey,t,f)*(sum((gne)$(s_f(gne,f)), P_Q_HGEMED(ey,gne)/initial_P_Q_HGEMED(ey,gne)));


eq_dL_dPGEN_HGEMED(eys,t,f,l,p,b)..
         (
           exec_fc*( thermodynamic_efficiency_HGEMED(eys,t,f)*FUEL_PRICE_HGEMED(eys,t,f)/1e6 *duration(l,p,b) )$thermal_t(t,f)
*         + exec_co2*( co2e_content_HGEMED(f,t)/1e6*co2_price(eys)*duration(l,p,b) )$emitting_t(t,f)
         + sum((pollut),( pollut_content_HGEMED(eys,t,f,pollut)/1e6*pollutant_price(eys,pollut,"Electricity")*duration(l,p,b) ) )$emitting_t(t,f)

         + exec_vom*( init_oem_vom_HGEMED(eys,t)/1e6*duration(l,p,b) )$t_f(t,f)
         - exec_renew_prem*( duration(l,p,b)*renewable_premium(eys,t)/1e6 )$renewable_premium_t(t,f)
         )
         - LAMBDA_DEM_HGEMED(eys,l,p,b)*
         (
         - 1
         + init_own_cons_gen_pctg
         + tdeo_losses_pctg_HGEMED(l,p,b)
         )$t_f(t,f)
         +  ( - LAMBDA_RES_HGEMED(eys,l,p)*
         (
         duration(l,p,b)
         )
         )$((sameas(t,"Hyd_Res")) and (sameas (f,"na")))
         - ( LAMBDA_PUMP_EFF_HGEMED(eys,l,p)*
         (
         duration(l,p,b)
         )
         )$((sameas(t,"Pump")) and (sameas (f,"na")))
         + ( - LAMBDA_PUMP_MAX_HGEMED(eys,l,p)*
         (
         duration(l,p,b)
         )
         )$((sameas(t,"Pump")) and (sameas (f,"na")))
         + ( - LAMBDA_RoR_HGEMED(eys,l,p,b)*
         (
         1
         )
         )$((sameas(t,"Hyd_RoR")) and (sameas (f,"na")))

$ontext
         + ( - LAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b)*
         (
         1-pctg_fueloil_use_on_fg(eys,l)
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Fuel-oil")))
         + ( - LAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b)*
         (
         pctg_fueloil_use_on_fg(eys,l)
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Natural_Gas")))
$offtext
         + ( - LAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b)*
         (
         1-pctg_fueloil_use_on_fg(eys,l)
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Fuel-oil")))
         + ( - LAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b)*
         (
         -(1-pctg_fueloil_use_on_fg(eys,l))
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Fuel-oil")))

         + ( - LAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b)*
         (
         -pctg_fueloil_use_on_fg(eys,l)
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Natural_Gas")))
         + ( - LAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b)*
         (
         pctg_fueloil_use_on_fg(eys,l)
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Natural_Gas")))
$ontext
         + ( - LAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b)*
         (
         1-pctg_fueloil_use_on_fg(eys,l)
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Fuel-oil")))
         + ( - LAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b)*
         (
         -(1-pctg_fueloil_use_on_fg(eys,l))
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Natural_Gas")))
         + ( - LAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b)*
         (
         -pctg_fueloil_use_on_fg(eys,l)
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Fuel-oil")))
         + ( - LAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b)*
         (
         1-(1-pctg_fueloil_use_on_fg(eys,l))
         )
         )$((sameas(t,"F-G")) and (sameas(f,"Natural_Gas")))
$offtext
         + ( - LAMBDA_WIND_HGEMED(eys,l,p,b)*
         (
         1
         )
         )$((sameas(t,"Wind")) and (sameas (f,"na")))
         + ( - LAMBDA_ORSR_HGEMED(eys,l,p,b)*
         (
         1
         )
         )$((sameas(t,"ORSR")) and (sameas (f,"na")))
         - LAMBDA_PINS_AVAILABILITY_HGEMED(eys,t,f,l,p,b)*
         (
         1
         )
         =e= 0;

eq_dL_dPPUMPED_HGEMED(eys,l,p,b)..
         - LAMBDA_DEM_HGEMED(eys,l,p,b)*
         (
         1
         - tdeo_losses_pctg_HGEMED(l,p,b)
         )
         - LAMBDA_PUMP_EFF_HGEMED(eys,l,p)*
         (
         - duration(l,p,b)*pump_efficiency
         )
         =e= 0;


eq_dL_RES_HGEMED(eys,l,p)..
         - LAMBDA_RES_HGEMED(eys,l,p)*
         (
         - 1
         )
         -
         (
         LAMBDA_RES_HGEMED(eys,l,p-1)*
         (
         1
         )
         )$(ORD(p) lt card(p)-1)
         =e= 0;


eq_dL_PINS_HGEMED(eys,l,t)..
         sum((eys_alias)$((ord(eys_alias) ge ord(eys)) and (ord(eys_alias) lt (ord(eys)+power_plant_time_life(t)))),
         + exec_capac*( init_overnight_costs_HGEMED(eys_alias,t) * IDC(t) * capital_recovery_factor(t)/1e3  )
         )
         + sum((eys_alias)$((ord(eys_alias) ge ord(eys)) and (ord(eys_alias) lt (ord(eys)+power_plant_time_life(t)))),
         - LAMBDA_PINS_CAPACITY_HGEMED(eys_alias,l,t)*
         (
         - 1
         )
         )
         =e= 0;

eq_dL_dINSTALLED_CAPACITY_HGEMED(eys,l,t)..
         (
         + exec_oem_labor*( init_oem_fom_labor_HGEMED(eys,l,t) / 1e3 )
         + exec_oem_sc*( init_oem_fom_social_contribution_HGEMED(eys,l,t) / 1e3 )
         + exec_oem_equip*( init_oem_fom_equipments_HGEMED(eys,l,t) / 1e3 )
         )
         + ( - LAMBDA_DISPATCHABLE_RESERVES_HGEMED(eys,l)*
         (
         - 1
         )
         )$t_not_intermittent(t)
         - sum((p,b), ( LAMBDA_WIND_HGEMED(eys,l,p,b)*
         (
         - pgenerated("2005",l,p,b,"Wind") / existent_installed_capacity("2005",l,"Wind")
         )
         ) )$(sameas(t,"Wind"))
         - sum((p,b), ( LAMBDA_ORSR_HGEMED(eys,l,p,b)*
         (
         - pgenerated("2005",l,p,b,"ORSR") / existent_installed_capacity("2005",l,"ORSR")
         )
         ) )$(sameas(t,"ORSR"))
         - LAMBDA_PINS_CAPACITY_HGEMED(eys,l,t)*
         (
         1
         )
         - sum((f,p,b)$t_f(t,f), ( LAMBDA_PINS_AVAILABILITY_HGEMED(eys,t,f,l,p,b)*
         (
         - availability_factor(eys,l,t)*stochastic_adjusted_availability(eys,l,p,b,t)
         ) ) )
         =e= 0;

eq_dL_dLAMBDA_DEM_HGEMED(eys,l,p,b)..
$ontext
         ( Q_H_D_GEN_HGEMED("2005",l,p,b)*duration(l,p,b) *((1 + demand_growth)**(eys.val - 2005)))
         + sum(sne, Q_II_GEN_SNE_HGEMED("2005",l,p,b,sne)*duration(l,p,b)*((1 + demand_growth)**(eys.val - 2005)))
         + ( q_ex_GEN_HGEMED("2005",l,p,b)*duration(l,p,b) *((1 + demand_growth)**(eys.val - 2005)))
$offtext

*$ontext
         demand(eys,"households",l,p,b) + sum(sne, demand(eys,sne,l,p,b)) + (q_ex_GEN_HGEMED(eys,l,p,b)*1e6/duration(l,p,b))
*$offtext
         - sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b)) - (q_m_GEN_HGEMED(eys,l,p,b)*1e6/duration(l,p,b)) + PPUMPED_HGEMED(eys,l,p,b)
         + init_own_cons_gen_pctg*sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b))
         + tdeo_losses_pctg_HGEMED(l,p,b)*( sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b)) + (q_m_GEN_HGEMED(eys,l,p,b)*1e6/duration(l,p,b)) - PPUMPED_HGEMED(eys,l,p,b) + (q_ex_GEN_HGEMED(eys,l,p,b)*1e6/duration(l,p,b))  )
         =e= 0;

$ontext
         demand(eys,"households",l,p,b) + sum(sne, demand(eys,sne,l,p,b)) + demand(eys,"Exports",l,p,b)
         - sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b)) - pimported(eys,l,p,b) + PPUMPED_HGEMED(eys,l,p,b)
         + init_own_cons_gen_pctg*sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b))
         + tdeo_losses_pctg_HGEMED(l,p,b)*( sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b)) + pimported(eys,l,p,b) - PPUMPED_HGEMED(eys,l,p,b) + demand(eys,"Exports",l,p,b)  )
         =e= 0;
$offtext

eq_dL_dLAMBDA_RES_HGEMED(eys,l,p)..
         sum((b),PGEN_HGEMED(eys,"Hyd_Res","na",l,p,b)*duration(l,p,b)) - RES_HGEMED(eys,l,p) + RES_HGEMED(eys,l,p+1)$(ORD(p) lt card(p)) + res_init(eys+1,l,"Hyd_Res")$(ORD(p) EQ card(p)) - hydro_inflows(eys,l,p,"Hyd_Res")
         =L= 0;

eq_dL_dLAMBDA_PUMP_EFF_HGEMED(eys,l,p)..
         sum((b), duration(l,p,b)*(PGEN_HGEMED(eys,"Pump","na",l,p,b))) -  sum((b), duration(l,p,b)*PPUMPED_HGEMED(eys,l,p,b)*pump_efficiency)
         =L= 0;

eq_dL_dLAMBDA_PUMP_MAX_HGEMED(eys,l,p)..
         sum((b), PGEN_HGEMED(eys,"Pump","na",l,p,b)*duration(l,p,b)) - res_max(eys,l,"Pump")
         =L= 0;

eq_dL_dLAMBDA_DISPATCHABLE_RESERVES_HGEMED(eys,l)..
         not_internittent_coverage_rate * smax((p,b), sum(sam,demand(eys,sam,l,p,b)) ) - sum((t,f)$((t_not_intermittent(t))and (t_f(t,f))), INSTALLED_CAPACITY_HGEMED(eys,l,t))
         =L= 0;

eq_dL_dLAMBDA_RoR_HGEMED(eys,l,p,b)..
         PGEN_HGEMED(eys,"Hyd_RoR","na",l,p,b) - hydro_inflows(eys,l,p,"Hyd_RoR")/sum((b_alias),duration(l,p,b_alias))
         =e= 0;

eq_dL_dLAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b)..
         PGEN_HGEMED(eys,"F-G","Fuel-oil",l,p,b)-pctg_fueloil_use_on_fg(eys,l)*sum((f),PGEN_HGEMED(eys,"F-G",f,l,p,b))
         =e= 0;

eq_dL_dLAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b)..
         PGEN_HGEMED(eys,"F-G","Natural_Gas",l,p,b)-(1-pctg_fueloil_use_on_fg(eys,l))*sum((f),PGEN_HGEMED(eys,"F-G",f,l,p,b))
         =e= 0;

eq_dL_dLAMBDA_WIND_HGEMED(eys,l,p,b)..
         PGEN_HGEMED(eys,"Wind","na",l,p,b) - pgenerated("2005",l,p,b,"Wind") / existent_installed_capacity("2005",l,"Wind") * INSTALLED_CAPACITY_HGEMED(eys,l,"Wind")
         =e= 0;

eq_dL_dLAMBDA_ORSR_HGEMED(eys,l,p,b)..
         PGEN_HGEMED(eys,"ORSR","na",l,p,b) - pgenerated("2005",l,p,b,"ORSR") / existent_installed_capacity("2005",l,"ORSR") * INSTALLED_CAPACITY_HGEMED(eys,l,"ORSR")
         =e= 0;

eq_dL_dLAMBDA_PINS_CAPACITY_HGEMED(eys,l,t)..
         INSTALLED_CAPACITY_HGEMED(eys,l,t) - ( existent_installed_capacity(eys,l,t)  + sum((eys_alias)$((ord(eys_alias) le ord(eys)) and (ord(eys_alias) gt (ord(eys)-power_plant_time_life(t)))),PINS_HGEMED(eys_alias,l,t)) )
         =E= 0;

eq_dL_dLAMBDA_PINS_AVAILABILITY_HGEMED(eys,t,f,l,p,b)..
         PGEN_HGEMED(eys,t,f,l,p,b) - INSTALLED_CAPACITY_HGEMED(eys,l,t)*availability_factor(eys,l,t)*stochastic_adjusted_availability(eys,l,p,b,t)
         =L=  0;



******** GOVERNMENT *************************************
eq_7_3_44(ey)..
Y_G_HGEMED(ey)=e=q_i_pf(ey,"Government","Labor")*P_PF_LABOR_HGEMED(ey) + q_i_pf(ey,"Government","Capital")*P_PF_CAPITAL_HGEMED(ey)+transf_ext_g(ey)+Y_TAX_HGEMED(ey);

eq_7_3_45(ey)..
E_G_HGEMED(ey)=e=sum(gne,(1+tx_rate(ey,"Government","Product_Tax"))*P_Q_HGEMED(ey,gne)*q_gov_initial(ey,gne))
                 + (1+tx_rate(ey,"Government","Product_Tax"))*P_Q_TDeO_HGEMED(ey)*q_gov_TDeO_initial(ey)
                 + sum((l,p,b),(1+tx_rate(ey,"Government","Product_Tax"))*P_Q_GEN_HGEMED(ey,l,p,b)*q_gov_GEN_initial(ey,l,p,b))
                 + transf_g_h(ey)
                 + psc_h(ey)*(
                             sum((sne),(tx_rate_sc(ey,"Labor",sne)-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc(ey,"Labor",sne)*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)*Q_PF_SNE_LABOR_HGEMED(ey,sne))
                             + (tx_rate_sc_TDeO(ey,"Labor")-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc_TDeO(ey,"Labor")*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_TDeO_HGEMED(ey)
                             + sum((l,p,b,t),(tx_rate_sc_tech(ey,"Labor",l,p,b,t)-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc_tech(ey,"Labor",l,p,b,t)*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*( P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)  ))
                             )
                 + sum(sne, sum(i,e_transf_i_s(ey,i,sne)))
                 + sum((l,p,b,t), emissions_allowance(ey,l,p,b,t));

eq_7_3_46(ey)..
S_TOTAL_G_HGEMED(ey)=e=Y_G_HGEMED(ey)-E_G_HGEMED(ey);

eq_7_3_47(ey)..
Y_TAX_HGEMED(ey)=e=
* Social Contributions
         sum((sne),(tx_rate_sc(ey,"Labor",sne)-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc(ey,"Labor",sne)*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)*Q_PF_SNE_LABOR_HGEMED(ey,sne))
         + (tx_rate_sc_TDeO(ey,"Labor")-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc_TDeO(ey,"Labor")*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_TDeO_HGEMED(ey)
         + sum((l,p,b,t), (tx_rate_sc_tech(ey,"Labor",l,p,b,t)-SC_ENV_SUBSIDY_RATE_HGEMED(ey)-tx_rate_sc_tech(ey,"Labor",l,p,b,t)*SC_ENV_SUBSIDY_RATE_HGEMED(ey))*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t))

*          + sum((l,p,b,t),( (1-SC_ENV_SUBSIDY_RATE_HGEMED(ey))*dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ))
*sum((l,p,b,t),(tx_rate_sc_tech(ey,"Labor",l,p,b,t))*P_PF_LABOR_GEMED(ey)*Q_PF_LABOR_GEN_tech_GEMED(ey,l,p,b,t))+
* Product Tax
         + sum(sne, sum(gne, tx_rate(ey,sne,"Product_tax")*P_Q_HGEMED(ey,gne)*Q_II_HGEMED(ey,gne,sne)))
         + sum(sne, tx_rate(ey,sne,"Product_tax")*P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_SNE_HGEMED(ey,sne))
         + sum(sne, sum((l,p,b), tx_rate(ey,sne,"Product_tax")*P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne)))

         + sum(gne, tx_rate_TDeO(ey,"Product_tax")*P_Q_HGEMED(ey,gne)*Q_II_GNE_TDeO_HGEMED(ey,gne))
         + tx_rate_TDeO(ey,"Product_tax")*P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_TDeO_HGEMED(ey)
         + sum((l,p,b), tx_rate_TDeO(ey,"Product_tax")*P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_TDeO_HGEMED(ey,l,p,b))

         + sum((l,p,b,t), sum(gne, tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) )
         + sum((l,p,b,t), tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t))
         + sum((l,p,b,t), sum((dp,db), tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_GEN_HGEMED(ey,l,dp,db)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) )

         + sum(gne,tx_rate(ey,"Exports","Product_Tax")*p_ex_initial(ey,gne)*Q_EX_HGEMED(ey,gne))
         + sum((l,p,b),tx_rate(ey,"Exports","Product_Tax")*p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b))
         + sum(gne, tx_rate(ey,"Households","Product_Tax")*P_Q_HGEMED(ey,gne)*Q_H_D_HGEMED(ey,gne))
         + sum((l,p,b), tx_rate(ey,"Households","Product_Tax")*P_Q_GEN_HGEMED(ey,l,p,b)*Q_H_D_GEN_HGEMED(ey,l,p,b))
         + tx_rate(ey,"Households","Product_Tax")*P_Q_TDeO_HGEMED(ey)*Q_H_D_TDeO_HGEMED(ey)
         + sum(gne,tx_rate(ey,"Government","Product_Tax")*P_Q_HGEMED(ey,gne)*q_gov_initial(ey,gne))
         + sum((l,p,b),tx_rate(ey,"Government","Product_Tax")*P_Q_GEN_HGEMED(ey,l,p,b)*q_gov_GEN_initial(ey,l,p,b))
         + tx_rate(ey,"Government","Product_Tax")*P_Q_TDeO_HGEMED(ey)*q_gov_TDeO_initial(ey)
         + sum(gne,tx_rate(ey,"Saves-Investments","Product_Tax")*P_Q_HGEMED(ey,gne)*Q_I_D_HGEMED(ey,gne))

*         + sum(gne, RENEWABLE_PREMIUM_TAX_RATE_HGEMED(ey,gne)*Q_Q_HGEMED(ey,gne)*P_Q_HGEMED(ey,gne))
*         + sum((l,p,b), RENEWABLE_PREMIUM_TAX_RATE_HGEMED(ey,"Electricity")*P_Q_GEN_HGEMED(ey,l,p,b)*Q_Q_GEN_HGEMED(ey,l,p,b))

         - sum(gne, (LUMP_SUM_ENV_SUBSIDY_HGEMED(ey))*Q_Q_HGEMED(ey,gne)*P_Q_HGEMED(ey,gne))
         - (LUMP_SUM_ENV_SUBSIDY_HGEMED(ey))*P_Q_TDeO_HGEMED(ey)*Q_Q_TDeO_HGEMED(ey)
         - sum((l,p,b), (LUMP_SUM_ENV_SUBSIDY_HGEMED(ey))*P_Q_GEN_HGEMED(ey,l,p,b)*Q_Q_GEN_HGEMED(ey,l,p,b))

* Production Tax
         + sum(sne, e_tx_sam(ey,"Production_Taxes",sne))
         + production_tax_TDeO(ey)
         + sum((l,p,b), production_tax_GEN(ey,l,p,b))

*         + sum(sne,tx_rate(ey,sne,"Production_taxes")*P_S_HGEMED(ey,sne)*Q_S_HGEMED(ey,sne))
*         + tx_rate_TDeO(ey,"Production_taxes")*P_S_TDeO_HGEMED(ey)*Q_S_TDeO_HGEMED(ey)
*         + sum((l,p,b,t), ( tx_rate(ey,"Electricity","Production_Taxes")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) + P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t) +  P_PF_CAPITAL_HGEMED(ey)*Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t) + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3 ) + ( tx_rate(ey,"Electricity","Product_tax")*( sum(gne, P_Q_HGEMED(ey,gne)*Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED(ey)*Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t) - emissions_allowance(ey,l,p,b,t) ) ) ) ) )

*old***sum((l,p,b),tx_rate_GEN(ey,l,p,b,"Production_taxes")*P_S_GEN_GEMED(ey,l,p,b)*Q_S_GEN_GEMED(ey,l,p,b)) +

* Emission taxes
*         + sum(sne$ets_sne(sne), emission_rate(ey,sne)*Q_S_HGEMED(ey,sne)*co2_price(ey))
*        + sum((l,p,b), sum((t,f)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*co2e_content_HGEMED(f,t)/1e6*co2_price(ey)*duration(l,p,b)) )
         + sum((l,p,b), (sum((t,f,pollut)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b)*pollut_content_HGEMED(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity"))))
         + sum((sne,pollut), top_down_pollutant_content(ey,pollut,sne)*(initial_P_S_HGEMED(ey,sne)/(initial_Q_S_HGEMED(ey,sne)*initial_P_S_HGEMED(ey,sne)))*Q_S_HGEMED(ey,sne)*pollutant_price(ey,pollut,sne) )
*         + sum(pollut, top_down_pollutant_content(ey,pollut,"Households")*( sum(gne, (initial_P_Q_HGEMED(ey,gne)/(initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)))*Q_H_D_HGEMED(ey,gne)) + (initial_P_Q_TDeO_HGEMED(ey)/(initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey)))*Q_H_D_TDeO_HGEMED(ey) + sum((l,p,b), (initial_P_Q_GEN_HGEMED(ey,l,p,b)/(initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b)))*Q_H_D_GEN_HGEMED(ey,l,p,b)) )*pollutant_price(ey,pollut,"Households"))
         + sum(pollut, top_down_pollutant_content(ey,pollut,"Households")*( (Y_H_HGEMED(ey)/initial_Y_H_HGEMED(ey)) )*pollutant_price(ey,pollut,"Households"))
;


******** SAVES - INVESTMENTS *************************************

eq_7_3_48(ey)..
S_TOTAL_HGEMED(ey)=e=S_TOTAL_H_HGEMED(ey)+S_TOTAL_G_HGEMED(ey)+S_TOTAL_EXT_HGEMED(ey)+transf_ext_k(ey);

eq_7_3_49(ey)..
S_TOTAL_EXT_HGEMED(ey)=e=sum(gne,p_m_initial(ey,gne)*Q_M_HGEMED(ey,gne))+sum((l,p,b),p_m_GEN_HGEMED(ey,l,p,b)*q_m_GEN_HGEMED(ey,l,p,b))-sum(gne,(1+tx_rate(ey,"Exports","Product_tax"))*p_ex_initial(ey,gne)*Q_EX_HGEMED(ey,gne)) -sum((l,p,b),(1+tx_rate(ey,"Exports","Product_tax"))*p_ex_GEN_HGEMED(ey,l,p,b)*q_ex_GEN_HGEMED(ey,l,p,b))-transf_ext_g(ey)-transf_ext_h(ey)-transf_ext_k(ey);

eq_7_3_50(ey,gne)..
Theta(ey,gne)*I_TOTAL_HGEMED(ey)=e=Q_I_D_HGEMED(ey,gne)*((1+tx_rate(ey,"Saves-Investments","Product_Tax"))*P_Q_HGEMED(ey,gne));

******** MARKET CLEARING *************************************

eq_7_3_51_a(ey)..
sum(sne, Q_PF_SNE_LABOR_HGEMED(ey,sne)) + sum((l,p,b,t), Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t)) + Q_PF_LABOR_TDeO_HGEMED(ey) =e=sum(i,q_i_pf(ey,i,"Labor"));

eq_7_3_51_b(ey)..
sum(sne, Q_PF_SNE_CAPITAL_HGEMED(ey,sne)) + sum((l,p,b,t), Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t)) + Q_PF_CAPITAL_TDeO_HGEMED(ey)+ sum((l,p,b),mkt_surplus_HGEMED(ey,l,p,b)/P_PF_CAPITAL_HGEMED(ey)) =e=sum(i,q_i_pf(ey,i,"Capital"));
*sum(sne, Q_PF_SNE_CAPITAL_HGEMED(ey,sne)) + sum((l,p,b,t), Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t)) + Q_PF_CAPITAL_TDeO_HGEMED(ey) =e=sum(i,q_i_pf(ey,i,"Capital"));

eq_7_3_52(ey,gne)..
Q_Q_HGEMED(ey,gne)=e=Q_H_D_HGEMED(ey,gne)+q_gov_initial(ey,gne)+sum(sne,Q_II_HGEMED(ey,gne,sne))+sum((l,p,b,t),Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t))+ Q_II_GNE_TDeO_HGEMED(ey,gne) +Q_I_D_HGEMED(ey,gne);


eq_7_3_53(ey,l,p,b)..
Q_Q_GEN_HGEMED(ey,l,p,b)=e=Q_H_D_GEN_HGEMED(ey,l,p,b)+q_gov_GEN_initial(ey,l,p,b)+sum(sne,Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne))+sum((gp,gb,t),Q_II_GEN_GEN_tech_HGEMED(ey,l,p,b,gp,gb,t))+ Q_II_GEN_TDeO_HGEMED(ey,l,p,b);
*initial_Q_S_GEN_HGEMED(ey,l,p,b) + q_m_GEN_HGEMED(ey,l,p,b) - q_ex_GEN_HGEMED(ey,l,p,b)



eq_7_3_54(ey)..
Q_Q_TDeO_HGEMED(ey)=e=Q_H_D_TDeO_HGEMED(ey)+q_gov_TDeO_initial(ey)+sum(sne,Q_II_TDeO_SNE_HGEMED(ey,sne))+sum((l,p,b,t),Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t))+Q_II_TDeO_TDeO_HGEMED(ey);

eq_7_3_55(ey)..
I_TOTAL_HGEMED(ey)=e=S_TOTAL_HGEMED(ey) + WALRAS_HGEMED(ey);

*---------Consumer price Index-------------------------
eq_CPI(ey)..
CPI_HGEMED(ey) =e= sum(gne, P_Q_HGEMED(ey,gne)*mu_cpi(ey,gne)) + sum((l,p,b), P_Q_GEN_HGEMED(ey,l,p,b)*mu_cpi_GEN(ey,l,p,b)) + P_Q_TDeO_HGEMED(ey)*mu_cpi_TDeO(ey);

*-------Objective function for NLP resolution----------
eq_object_function_HGEMED..
DUMMY_HGEMED =e= 1;




*---------GAD Case Study-------------------------
eq_dL_dLAMBDA_DR_DEM_HGEMED(eys,l,p,b)..
         sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b)) + (q_m_GEN_HGEMED(eys,l,p,b)*1e6/duration(l,p,b)) - PPUMPED_HGEMED(eys,l,p,b)
         - init_own_cons_gen_pctg*sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b))
         - tdeo_losses_pctg_HGEMED(l,p,b)*( sum((t,f)$t_f(t,f),PGEN_HGEMED(eys,t,f,l,p,b)) + (q_m_GEN_HGEMED(eys,l,p,b)*1e6/duration(l,p,b)) - PPUMPED_HGEMED(eys,l,p,b) + (q_ex_GEN_HGEMED(eys,l,p,b)*1e6/duration(l,p,b))  )
         =e= demand(eys,"households",l,p,b) + sum(sne, demand(eys,sne,l,p,b)) + (q_ex_GEN_HGEMED(eys,l,p,b)*1e6/duration(l,p,b))
         + ( INCREASED_DR_LOAD_HGEMED(eys,l,p,b) - DECREASED_DR_LOAD_HGEMED(eys,l,p,b) )$(exec_DR_displac) - ( CONSERVED_DR_LOAD_HGEMED(eys,l,p,b) )$(exec_DR_reduc);

eq_dL_dINCREASED_DR_LOAD_HGEMED(eys,l,p,b)..
         + ( - LAMBDA_DEM_HGEMED(eys,l,p,b)*
         (
         1
         ) )$(exec_DR_displac)
         + ( - LAMBDA_DISPL_BAL_HGEMED(eys,l,p)*
         (
         duration(l,p,b)
         ) )$(exec_DR_displac)
         + ( - LAMBDA_REQ_SAVINGS_HGEMED(eys,l,p)*
         (
         -GAD_energy_only_price(eys,l,p,b)*duration(l,p,b)
         ) )$(exec_DR_displac)
         =e= 0;

eq_dL_dDECREASED_DR_LOAD_HGEMED(eys,l,p,b)..
         + ( - LAMBDA_DEM_HGEMED(eys,l,p,b)*
         (
         - 1
         ) )$(exec_DR_displac)
         + ( - LAMBDA_MAX_DISPL_HGEMED(eys,l,p,b)*
         (
         1
         ) )$(exec_DR_displac)
         + ( - LAMBDA_DISPL_BAL_HGEMED(eys,l,p)*
         (
         - duration(l,p,b)
         ) )$(exec_DR_displac)
         + ( - LAMBDA_REQ_SAVINGS_HGEMED(eys,l,p)*
         (
         GAD_energy_only_price(eys,l,p,b)*duration(l,p,b)
         ) )$(exec_DR_displac)
         =e= 0;

eq_dL_dCONSERVED_DR_LOAD_HGEMED(eys,l,p,b)..
         + ( - LAMBDA_DEM_HGEMED(eys,l,p,b)*
         (
         - 1
         ) )$(exec_DR_reduc)
         + ( - LAMBDA_CONSERV_LIMIT_HGEMED(eys,l,p,b)*
         (
         1
         ) )$(exec_DR_reduc)
         =e= 0;

eq_dL_dLAMBDA_MAX_DISPL_HGEMED(eys,l,p,b)..
         DECREASED_DR_LOAD_HGEMED(eys,l,p,b) - displaceable_load(eys,l,p,b)
         =L=  0;

eq_dL_dLAMBDA_DISPL_BAL_HGEMED(eys,l,p)..
         sum(b, DECREASED_DR_LOAD_HGEMED(eys,l,p,b)*duration(l,p,b)) - sum(b, INCREASED_DR_LOAD_HGEMED(eys,l,p,b)*duration(l,p,b) )
         =e=  0;

eq_dL_dLAMBDA_CONSERV_LIMIT_HGEMED(eys,l,p,b)..
         CONSERVED_DR_LOAD_HGEMED(eys,l,p,b) - conservable_load(eys,l,p,b)
         =L=  0;

eq_dL_dLAMBDA_REQ_SAVINGS_HGEMED(eys,l,p)..
         sum(b, ( DECREASED_DR_LOAD_HGEMED(eys,l,p,b) )*GAD_energy_only_price(eys,l,p,b)*duration(l,p,b))-sum(b, ( INCREASED_DR_LOAD_HGEMED(eys,l,p,b) )*GAD_energy_only_price(eys,l,p,b)*duration(l,p,b)) - (1-minimum_required_DR_savings(eys))*sum(b, ( displaceable_load(eys,l,p,b) )*GAD_energy_only_price(eys,l,p,b)*duration(l,p,b))
         =L=  0;


*eq_7_3_42_case_study(ey,l,p,b)..
****IT HAS TO CHANGE TO REMOVE QD!!!!!!!!!!!**Q_Q_GEN_HGEMED(ey,l,p,b) =e= Q_D_GEN_HGEMED(ey,l,p,b) - q_ex_GEN(ey,l,p,b) + ( INCREASED_DR_LOAD_HGEMED(ey,l,p,b)*duration(l,p,b) - DECREASED_DR_LOAD_HGEMED(ey,l,p,b)*duration(l,p,b) )$(exec_DR_displac) - ( CONSERVED_DR_LOAD_HGEMED(ey,l,p,b)*duration(l,p,b) )$(exec_DR_reduc);


*-------Case Study Environmental Tax Reform----------
eq_extra_1_HGEMED(ey,pollut)..
Y_ENV_TAX_HGEMED(ey,pollut) =e=
          top_down_pollutant_content(ey,pollut,"Households")*
          ( (Y_H_HGEMED(ey)/initial_Y_H_HGEMED(ey)) )*pollutant_price(ey,pollut,"Households")
*         top_down_pollutant_content(ey,pollut,"Households")*
*         (       sum(gne, (initial_P_Q_HGEMED(ey,gne)/(initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)))*Q_H_D_HGEMED(ey,gne))
*                 + (initial_P_Q_TDeO_HGEMED(ey)/(initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey)))*Q_H_D_TDeO_HGEMED(ey)
*                 + sum((l,p,b), (initial_P_Q_GEN_HGEMED(ey,l,p,b)/(initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b)))*Q_H_D_GEN_HGEMED(ey,l,p,b))
*         )*pollutant_price(ey,pollut,"Households")
         + sum(sne$( not ( sameas(pollut,"CO2e_ETS") and ETS_s(sne) ) ),top_down_pollutant_content(ey,pollut,sne)*(initial_P_S_HGEMED(ey,sne)/(initial_Q_S_HGEMED(ey,sne)*initial_P_S_HGEMED(ey,sne)))*Q_S_HGEMED(ey,sne)*pollutant_price(ey,pollut,sne))
         + ( sum((l,p,b), sum((t,f)$emitting_t(t,f), PGEN_HGEMED(ey,t,f,l,p,b)*duration(l,p,b)*pollut_content_HGEMED(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity"))) )$(not (sameas(pollut,"CO2e_ETS")))
;


eq_extra_2_HGEMED(ey)..
SC_ENV_SUBSIDY_RATE_HGEMED(ey) =e= ( ( sum(pollut, Y_ENV_TAX_HGEMED(ey,pollut))
*+ Y_FUEL_TAX_HGEMED(ey)
                                 )
                                 /(      sum((sne),(1+tx_rate_sc(ey,"Labor",sne))*P_PF_LABOR_HGEMED(ey)*Q_PF_SNE_LABOR_HGEMED(ey,sne))
                                         + (1+tx_rate_sc_TDeO(ey,"Labor"))*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_TDeO_HGEMED(ey)
                                         + sum((l,p,b,t), (tx_rate_sc_tech(ey,"Labor",l,p,b,t))*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t))
                                 )
                             )$(exec_social_contributions_enviromental_tax_reform);

$ontext

                                 )
                                 /(      sum(sne_alias,( (1+tx_rate_sc(ey,"Labor",sne_alias))*P_PF_LABOR_HGEMED(ey)*Q_PF_SNE_LABOR_HGEMED(ey,sne_alias) ) )
                                         + tx_rate_sc_TDeO(ey,"Labor")*P_PF_LABOR_HGEMED(ey)*Q_PF_LABOR_TDeO_HGEMED(ey)
                                         + sum((l,p,b,t),dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED(ey,l,t) / 10**3)
                                 )
                             )$(exec_social_contributions_enviromental_tax_reform);
$offtext

*SC_ENV_SUBSIDY_RATE(ey) =e= ( ( sum(pollut, Y_ENV_TAX(ey,pollut)) + Y_FUEL_TAX(ey) )
*/
*sum(s_alias,( (1+tx_rate_sc(ey,"Labor",s_alias))*Q_PF_LABOR_CGE(ey,s_alias)*P_PF_LABOR_CGE(ey) ) ) )$(exec_social_contributions_enviromental_tax_reform);



eq_extra_3_HGEMED(ey)..
LUMP_SUM_ENV_SUBSIDY_HGEMED(ey) =e= ( ( sum(pollut, Y_ENV_TAX_HGEMED(ey,pollut))
* + Y_FUEL_TAX_HGEMED(ey)
                                 )
                                 /(      sum(sne_alias, Q_Q_HGEMED(ey,sne_alias)*P_Q_HGEMED(ey,sne_alias) )
                                         + Q_Q_TDeO_HGEMED(ey)*P_Q_TDeO_HGEMED(ey)
                                         + sum((l,p,b),Q_Q_GEN_HGEMED(ey,l,p,b)*P_Q_GEN_HGEMED(ey,l,p,b))
                                 ))$(exec_lump_sum_enviromental_tax_reform);


eq_extra_4_HGEMED(ey,s)..
RENEWABLE_PREMIUM_TAX_RATE_HGEMED(ey,s) =e= ( renewable_premium_payments(ey)
                                         /(
                                                 sum(gne_alias$renewable_premium_tax_sectors(gne_alias),
                                                         (Q_Q_HGEMED(ey,gne_alias)*P_Q_HGEMED(ey,gne_alias))
                                                 )
                                                 + (sum((l,p,b),Q_Q_GEN_HGEMED(ey,l,p,b)*P_Q_GEN_HGEMED(ey,l,p,b)))

                                         ))$(exec_renew_premium_tax_reform and renewable_premium_tax_sectors(s));

$ontext
eq_extra_5_HGEMED(ey)..
*Did not included fuel tax payments on generation and t&D sectors!!!!
Y_FUEL_TAX_HGEMED(ey) =e=
* fuel tax rate payments by the sne sectors
           sum(sne, sum(gne, Q_II_HGEMED(ey,gne,sne)*(1+tx_rate(ey,sne,"Product_tax"))*(fuel_tx_rate(ey,sne,gne))*P_Q_HGEMED(ey,gne) ) )
           + sum(sne, sum((l,p,b), Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne)*(1+tx_rate(ey,sne,"Product_tax"))*(fuel_tx_rate(ey,sne,"Electricity"))*P_Q_GEN_HGEMED(ey,l,p,b)) )
* fuel tax rate payments by the households
           +  sum(gne, Q_H_D_HGEMED(ey,gne)*(1+tx_rate(ey,"Households","Product_Tax"))*(fuel_tx_rate(ey,"Households",gne))*P_Q_HGEMED(ey,gne) )
           +  sum((l,p,b), Q_H_D_GEN_HGEMED(ey,l,p,b)*(1+tx_rate(ey,"Households","Product_Tax"))*(fuel_tx_rate(ey,"Households","Electricity"))*P_Q_GEN_HGEMED(ey,l,p,b) )
;
$offtext



*-------------------------------------------------------------------------------
*-------------------------------- Defining CGE Model ---------------------------
*-------------------------------------------------------------------------------
* initializing variables ---------------------------------------------
Q_H_D_HGEMED.l(ey,gne)=initial_Q_H_D_HGEMED(ey,gne);
Q_H_D_GEN_HGEMED.l(ey,l,p,b)=initial_Q_H_D_GEN_HGEMED(ey,l,p,b);
Q_H_D_TDeO_HGEMED.l(ey)=initial_Q_H_D_TDeO_HGEMED(ey);
P_PF_LABOR_HGEMED.l(ey)=initial_P_PF_LABOR_HGEMED(ey);
P_PF_CAPITAL_HGEMED.l(ey)=initial_P_PF_CAPITAL_HGEMED(ey);
Y_H_HGEMED.l(ey)=initial_Y_H_HGEMED(ey);
Q_PF_SNE_LABOR_HGEMED.l(ey,sne)=initial_Q_PF_SNE_LABOR_HGEMED(ey,sne);
Q_PF_SNE_CAPITAL_HGEMED.l(ey,sne)=initial_Q_PF_SNE_CAPITAL_HGEMED(ey,sne);
Q_VA_HGEMED.l(ey,sne)=initial_Q_VA_HGEMED(ey,sne);
P_VA_HGEMED.l(ey,sne)=initial_P_VA_HGEMED(ey,sne);
Q_II_HGEMED.l(ey,gne,sne)=initial_Q_II_HGEMED(ey,gne,sne);
Q_II_GEN_SNE_HGEMED.l(ey,l,p,b,sne)=initial_Q_II_GEN_SNE_HGEMED(ey,l,p,b,sne);
Q_II_TDeO_SNE_HGEMED.l(ey,sne)=initial_Q_II_TDeO_SNE_HGEMED(ey,sne);
Q_S_HGEMED.l(ey,sne)=initial_Q_S_HGEMED(ey,sne);
P_S_HGEMED.l(ey,gne)=initial_P_S_HGEMED(ey,gne);
Q_M_HGEMED.l(ey,gne)=initial_Q_M_HGEMED(ey,gne);
Q_D_HGEMED.l(ey,gne)=initial_Q_D_HGEMED(ey,gne);
P_D_HGEMED.l(ey,gne)=initial_P_D_HGEMED(ey,gne);
Q_EX_HGEMED.l(ey,gne)=initial_Q_EX_HGEMED(ey,gne);
Q_Q_HGEMED.l(ey,gne)=initial_Q_Q_HGEMED(ey,gne);
P_Q_HGEMED.l(ey,gne)=initial_P_Q_HGEMED(ey,gne);
Q_PF_LABOR_TDeO_HGEMED.l(ey)=initial_Q_PF_LABOR_TDeO_HGEMED(ey);
Q_PF_CAPITAL_TDeO_HGEMED.l(ey)=initial_Q_PF_CAPITAL_TDeO_HGEMED(ey);
Q_VA_TDeO_HGEMED.l(ey)=initial_Q_VA_TDeO_HGEMED(ey);
P_VA_TDeO_HGEMED.l(ey)=initial_P_VA_TDeO_HGEMED(ey);
Q_II_GNE_TDeO_HGEMED.l(ey,gne)=initial_Q_II_GNE_TDeO_HGEMED(ey,gne);
Q_II_GEN_TDeO_HGEMED.l(ey,l,dp,db)=initial_Q_II_GEN_TDeO_HGEMED(ey,l,dp,db);
Q_II_TDeO_TDeO_HGEMED.l(ey)=initial_Q_II_TDeO_TDeO_HGEMED(ey);
Q_S_TDeO_HGEMED.l(ey)=initial_Q_S_TDeO_HGEMED(ey);
P_S_TDeO_HGEMED.l(ey)=initial_P_S_TDeO_HGEMED(ey);
Q_D_TDeO_HGEMED.l(ey)=initial_Q_D_TDeO_HGEMED(ey);
P_D_TDeO_HGEMED.l(ey)=initial_P_D_TDeO_HGEMED(ey);
Q_Q_TDeO_HGEMED.l(ey)=initial_Q_Q_TDeO_HGEMED(ey);
P_Q_TDeO_HGEMED.l(ey)=initial_P_Q_TDeO_HGEMED(ey);
Q_PF_LABOR_GEN_tech_HGEMED.l(ey,l,p,b,t)=initial_Q_PF_LABOR_GEN_tech_HGEMED(ey,l,p,b,t);
Q_PF_CAPITAL_GEN_tech_HGEMED.l(ey,l,p,b,t)=initial_Q_PF_CAPITAL_GEN_tech_HGEMED(ey,l,p,b,t);
Q_II_GNE_GEN_tech_HGEMED.l(ey,gne,l,p,b,t)=initial_Q_II_GNE_GEN_tech_HGEMED(ey,gne,l,p,b,t);
Q_II_GEN_GEN_tech_HGEMED.l(ey,l,dp,db,gp,gb,t)=initial_Q_II_GEN_GEN_tech_HGEMED(ey,l,dp,db,gp,gb,t);
Q_II_TDeO_GEN_tech_HGEMED.l(ey,l,p,b,t)=initial_Q_II_TDeO_GEN_tech_HGEMED(ey,l,p,b,t);
Q_S_TECH_HGEMED.l(ey,l,p,b,t)=initial_Q_S_TECH_HGEMED(ey,l,p,b,t);
Q_S_GEN_HGEMED.l(ey,l,p,b)=initial_Q_S_GEN_HGEMED(ey,l,p,b);
P_S_GEN_HGEMED.l(ey,l,p,b)=initial_P_S_GEN_HGEMED(ey,l,p,b);
Q_Q_GEN_HGEMED.l(ey,l,p,b)=initial_Q_Q_GEN_HGEMED(ey,l,p,b);
P_Q_GEN_HGEMED.l(ey,l,p,b)=initial_P_Q_GEN_HGEMED(ey,l,p,b);
Y_G_HGEMED.l(ey)=initial_Y_G_HGEMED(ey);
E_G_HGEMED.l(ey)=initial_E_G_HGEMED(ey);
Y_TAX_HGEMED.l(ey)=initial_Y_TAX_HGEMED(ey);
S_TOTAL_HGEMED.l(ey)=initial_S_TOTAL_HGEMED(ey);
S_TOTAL_H_HGEMED.l(ey)=initial_S_TOTAL_H_HGEMED(ey);
S_TOTAL_G_HGEMED.l(ey)=initial_S_TOTAL_G_HGEMED(ey);
S_TOTAL_EXT_HGEMED.l(ey)=initial_S_TOTAL_EXT_HGEMED(ey);
I_TOTAL_HGEMED.l(ey)=initial_I_TOTAL_HGEMED(ey);
Q_I_D_HGEMED.l(ey,gne)=initial_Q_I_D_HGEMED(ey,gne);
CPI_HGEMED.l(ey)=initial_CPI_HGEMED(ey);
DUMMY_HGEMED.l=1;
WALRAS_HGEMED.l(ey)=initial_WALRAS_HGEMED(ey);
PGEN_HGEMED.l(eys,t,f,l,p,b)=initial_PGEN_HGEMED(eys,t,f,l,p,b);
PPUMPED_HGEMED.l(eys,l,p,b)=initial_PPUMPED_HGEMED(eys,l,p,b);
RES_HGEMED.l(eys,l,p)=initial_RES_HGEMED(eys,l,p);
PINS_HGEMED.l(eys,l,t)=initial_PINS_HGEMED(eys,l,t);
INSTALLED_CAPACITY_HGEMED.l(eys,l,t)=initial_INSTALLED_CAPACITY_HGEMED(eys,l,t);
INCREASED_DR_LOAD_HGEMED.l(eys,l,p,b)=initial_INCREASED_DR_LOAD_HGEMED(eys,l,p,b);
DECREASED_DR_LOAD_HGEMED.l(eys,l,p,b)=initial_DECREASED_DR_LOAD_HGEMED(eys,l,p,b);
CONSERVED_DR_LOAD_HGEMED.l(eys,l,p,b)=initial_CONSERVED_DR_LOAD_HGEMED(eys,l,p,b);
FUEL_PRICE_HGEMED.l(eys,t,f)=initial_FUEL_PRICE_HGEMED(eys,t,f);
LAMBDA_DEM_HGEMED.l(eys,l,p,b)=initial_LAMBDA_DEM_HGEMED(eys,l,p,b);
LAMBDA_RES_HGEMED.l(eys,l,p)=initial_LAMBDA_RES_HGEMED(eys,l,p);
LAMBDA_PUMP_EFF_HGEMED.l(eys,l,p)=initial_LAMBDA_PUMP_EFF_HGEMED(eys,l,p);
LAMBDA_PUMP_MAX_HGEMED.l(eys,l,p)=initial_LAMBDA_PUMP_MAX_HGEMED(eys,l,p);
LAMBDA_DISPATCHABLE_RESERVES_HGEMED.l(eys,l)=initial_LAMBDA_DISPATCHABLE_RESERVES_HGEMED(eys,l);
LAMBDA_RoR_HGEMED.l(eys,l,p,b)=initial_LAMBDA_RoR_HGEMED(eys,l,p,b);
LAMBDA_FG_FUEL_OIL_USE_HGEMED.l(eys,l,p,b)=initial_LAMBDA_FG_FUEL_OIL_USE_HGEMED(eys,l,p,b);
LAMBDA_FG_NATURAL_GAS_USE_HGEMED.l(eys,l,p,b)=initial_LAMBDA_FG_NATURAL_GAS_USE_HGEMED(eys,l,p,b);
LAMBDA_WIND_HGEMED.l(eys,l,p,b)=initial_LAMBDA_WIND_HGEMED(eys,l,p,b);
LAMBDA_ORSR_HGEMED.l(eys,l,p,b)=initial_LAMBDA_ORSR_HGEMED(eys,l,p,b);
LAMBDA_PINS_CAPACITY_HGEMED.l(eys,l,t)=initial_LAMBDA_PINS_CAPACITY_HGEMED(eys,l,t);
LAMBDA_PINS_AVAILABILITY_HGEMED.l(eys,t,f,l,p,b)=initial_LAMBDA_PINS_AVAILABILITY_HGEMED(eys,t,f,l,p,b);

mkt_surplus_HGEMED.l(ey,l,p,b)=initial_mkt_surplus_HGEMED(ey,l,p,b);

*LAMBDA_MAX_DISPL_HGEMED.l(eys,l,p,b)=initial_LAMBDA_MAX_DISPL_HGEMED(eys,l,p,b);
*LAMBDA_DISPL_BAL_HGEMED.l(eys,l,p)=initial_LAMBDA_DISPL_BAL_HGEMED(eys,l,p);
*LAMBDA_CONSERV_LIMIT_HGEMED.l(eys,l,p,b)=initial_LAMBDA_CONSERV_LIMIT_HGEMED(eys,l,p,b);
*LAMBDA_REQ_SAVINGS_HGEMED.l(eys,l,p)=initial_LAMBDA_REQ_SAVINGS_HGEMED(eys,l,p);

*$ontext
* Setting lower bounds to avoid vcPower: GRAD SINGULAR: x**c, x=0, 0<c<1 ---------
parameter lower_bound /1e-15/;
Q_H_D_HGEMED.lo(ey,gne)=lower_bound;
Q_H_D_GEN_HGEMED.lo(ey,l,p,b)=lower_bound;
Q_H_D_TDeO_HGEMED.lo(ey)=lower_bound;
P_PF_LABOR_HGEMED.lo(ey)=lower_bound;
P_PF_CAPITAL_HGEMED.lo(ey)=lower_bound;
Y_H_HGEMED.lo(ey)=lower_bound;
Q_PF_SNE_LABOR_HGEMED.lo(ey,sne)=lower_bound;
Q_PF_SNE_CAPITAL_HGEMED.lo(ey,sne)=lower_bound;
Q_VA_HGEMED.lo(ey,sne)=lower_bound;
P_VA_HGEMED.lo(ey,sne)=lower_bound;
Q_II_HGEMED.lo(ey,gne,sne)=lower_bound;
Q_II_GEN_SNE_HGEMED.lo(ey,l,p,b,sne)=lower_bound;
Q_II_TDeO_SNE_HGEMED.lo(ey,sne)=lower_bound;
Q_S_HGEMED.lo(ey,sne)=lower_bound;
P_S_HGEMED.lo(ey,gne)=lower_bound;
Q_M_HGEMED.lo(ey,gne)=lower_bound;
Q_D_HGEMED.lo(ey,gne)=lower_bound;
P_D_HGEMED.lo(ey,gne)=lower_bound;
Q_EX_HGEMED.lo(ey,gne)=lower_bound;
Q_Q_HGEMED.lo(ey,gne)=lower_bound;
P_Q_HGEMED.lo(ey,gne)=lower_bound;
Q_PF_LABOR_TDeO_HGEMED.lo(ey)=lower_bound;
Q_PF_CAPITAL_TDeO_HGEMED.lo(ey)=lower_bound;
Q_VA_TDeO_HGEMED.lo(ey)=lower_bound;
P_VA_TDeO_HGEMED.lo(ey)=lower_bound;
Q_II_GNE_TDeO_HGEMED.lo(ey,gne)=lower_bound;
Q_II_GEN_TDeO_HGEMED.lo(ey,l,dp,db)=lower_bound;
Q_II_TDeO_TDeO_HGEMED.lo(ey)=lower_bound;
Q_S_TDeO_HGEMED.lo(ey)=lower_bound;
P_S_TDeO_HGEMED.lo(ey)=lower_bound;
Q_D_TDeO_HGEMED.lo(ey)=lower_bound;
P_D_TDeO_HGEMED.lo(ey)=lower_bound;
Q_Q_TDeO_HGEMED.lo(ey)=lower_bound;
P_Q_TDeO_HGEMED.lo(ey)=lower_bound;
Q_PF_LABOR_GEN_tech_HGEMED.lo(ey,l,p,b,t)=lower_bound;
Q_PF_CAPITAL_GEN_tech_HGEMED.lo(ey,l,p,b,t)=lower_bound;
Q_II_GNE_GEN_tech_HGEMED.lo(ey,gne,l,p,b,t)=lower_bound;
Q_II_GEN_GEN_tech_HGEMED.lo(ey,l,dp,db,gp,gb,t)=lower_bound;
Q_II_TDeO_GEN_tech_HGEMED.lo(ey,l,p,b,t)=lower_bound;
Q_S_TECH_HGEMED.lo(ey,l,p,b,t)=lower_bound;
Q_S_GEN_HGEMED.lo(ey,l,p,b)=lower_bound;
P_S_GEN_HGEMED.lo(ey,l,p,b)=lower_bound;
Q_Q_GEN_HGEMED.lo(ey,l,p,b)=lower_bound;
P_Q_GEN_HGEMED.lo(ey,l,p,b)=lower_bound;
Y_G_HGEMED.lo(ey)=lower_bound;
E_G_HGEMED.lo(ey)=lower_bound;
Y_TAX_HGEMED.lo(ey)=lower_bound;
S_TOTAL_HGEMED.lo(ey)=lower_bound;
S_TOTAL_H_HGEMED.lo(ey)=lower_bound;
S_TOTAL_G_HGEMED.lo(ey)=lower_bound;
S_TOTAL_EXT_HGEMED.lo(ey)=lower_bound;
I_TOTAL_HGEMED.lo(ey)=lower_bound;
Q_I_D_HGEMED.lo(ey,gne)=lower_bound;
*CPI_HGEMED.lo(ey)=lower_bound;
DUMMY_HGEMED.lo=lower_bound;
WALRAS_HGEMED.lo(ey)=lower_bound;
PGEN_HGEMED.lo(ey,t,f,l,p,b)=lower_bound;
PPUMPED_HGEMED.lo(ey,l,p,b)=lower_bound;
RES_HGEMED.lo(ey,l,p)=lower_bound;
PINS_HGEMED.lo(ey,l,t)=lower_bound;
INSTALLED_CAPACITY_HGEMED.lo(ey,l,t)=lower_bound;
INCREASED_DR_LOAD_HGEMED.lo(ey,l,p,b)=lower_bound;
DECREASED_DR_LOAD_HGEMED.lo(ey,l,p,b)=lower_bound;
CONSERVED_DR_LOAD_HGEMED.lo(ey,l,p,b)=lower_bound;
FUEL_PRICE_HGEMED.lo(ey,t,f)=lower_bound;
*$offtext

$ontext
*---------Fixing non used load blocks--------------------
loop((l,p,b)$(not duration(l,p,b)),
Q_H_D_GEN_HGEMED.fx(ey,l,p,b)=lower_bound;
Q_II_GEN_SNE_HGEMED.fx(ey,l,p,b,sne)=lower_bound;
Q_II_GEN_TDeO_HGEMED.fx(ey,l,dp,db)=lower_bound;
Q_PF_LABOR_GEN_tech_HGEMED.fx(ey,l,p,b,t)=lower_bound;
Q_PF_CAPITAL_GEN_tech_HGEMED.fx(ey,l,p,b,t)=lower_bound;
*Q_VA_GEN_tech_HGEMED.fx(ey,l,p,b,t)=lower_bound;
*P_VA_GEN_tech_HGEMED.fx(ey,l,p,b,t)=lower_bound;
Q_II_GNE_GEN_tech_HGEMED.fx(ey,gne,l,p,b,t)=lower_bound;
Q_II_GEN_GEN_tech_HGEMED.fx(ey,l,dp,db,gp,gb,t)=lower_bound;
Q_II_TDeO_GEN_tech_HGEMED.fx(ey,l,p,b,t)=lower_bound;
Q_S_TECH_HGEMED.fx(ey,l,p,b,t)=lower_bound;
*P_S_TECH_HGEMED.fx(ey,l,p,b,t)=lower_bound;
Q_S_GEN_HGEMED.fx(ey,l,p,b)=lower_bound;
P_S_GEN_HGEMED.fx(ey,l,p,b)=lower_bound;
*Q_D_GEN_HGEMED.fx(ey,l,p,b)=lower_bound;
*P_D_GEN_HGEMED.fx(ey,l,p,b)=lower_bound;
Q_Q_GEN_HGEMED.fx(ey,l,p,b)=lower_bound;
P_Q_GEN_HGEMED.fx(ey,l,p,b)=lower_bound;
);
$offtext


*---------Fixing non used load blocks--------------------
*---------Fixing non used load blocks--------------------
loop((l,p,b)$(not duration(l,p,b)),
PGEN_LEGEN.fx(eys,t,f,l,p,b)=0;
PPUMPED_LEGEN.fx(eys,l,p,b)=0;
VOM_LEGEN.fx(eys,t,f,l,p,b)=0;
FUEL_COST_LEGEN.fx(eys,t,f,l,p,b)=0;
*CO2_PAYMENTS_LEGEN.fx(eys,t,f,l,p,b)=0;
);
loop ((t,f)$(not t_f(t,f)),
PGEN_LEGEN.fx(eys,t,f,l,p,b)=0;
FUEL_COST_LEGEN.fx(eys,t,f,l,p,b)=0;
*CO2_PAYMENTS_LEGEN.fx(eys,t,f,l,p,b)=0;
VOM_LEGEN.fx(eys,t,f,l,p,b)=0;
);
*fixing PINS to years where even that we choose to construct today the power plant, the construction time make it impossible to them to be available
*I should include exogenously the new capacity installed for these years (between 2010 and 2010+construction time) (take from REE) because these decisions were made before the initial execution year of the model
*I should fix this only after 2010 = substitute ey.val+1 por 2010+1
loop ((ey,eys,t)$((eys.val ge ey.val) and (eys.val le ey.val+construction_time(t))), PINS_LEGEN.fx(eys,l,t)=0; );

*avoiding unecessary displacemnts by setting that displacement only ocur from the bigger demanding hours to the lower demanding hours, avoiding displacements between hours of medium demand
loop(eys, loop((l,p,b)$(not(Increase_DR_Load_Blocks(l,p,b))), INCREASED_DR_LOAD.fx(eys,l,p,b)=0; ); );
*loop(eys, loop((l,p,b)$(not(Decrease_DR_Load_Blocks(l,p,b))), DECREASED_DR_LOAD.fx(eys,l,p,b)=0; ); );

*---------Initialising DR variables
INCREASED_DR_LOAD.l(eys,l,p,b)=0;
DECREASED_DR_LOAD.l(eys,l,p,b)=0;
CONSERVED_DR_LOAD.l(eys,l,p,b)=0;


* numeraire ---------------------------------------------
CPI_HGEMED.fx(ey)=initial_CPI_HGEMED(ey);


* NLP Model -------------------------------------------------
Model HGEMED_NLP /
                 eq_7_3_1, eq_7_3_2, eq_7_3_3, eq_7_3_4, eq_7_3_5, eq_7_3_6,
                 eq_7_3_7, eq_7_3_8, eq_7_3_9, eq_7_3_10, eq_7_3_11, eq_7_3_12,
                 eq_7_3_13, eq_7_3_14, eq_7_3_15, eq_7_3_16, eq_7_3_17, eq_7_3_18,
                 eq_7_3_19, eq_7_3_20_a, eq_7_3_20_b, eq_7_3_21, eq_7_3_22,
                 eq_7_3_23, eq_7_3_24, eq_7_3_25, eq_7_3_26, eq_7_3_27, eq_7_3_28,
                 eq_7_3_29, eq_7_3_30

                 eq_Q_PF_LABOR_GEN_tech_HGEMED,eq_Q_PF_CAPITAL_GEN_tech_HGEMED,eq_Q_II_GNE_GEN_tech_HGEMED
                 eq_Q_II_GEN_GEN_tech_HGEMED,eq_Q_II_TDeO_GEN_tech_HGEMED,eq_Q_S_TECH_HGEMED,eq_Q_S_GEN_HGEMED
                 eq_P_S_GEN_HGEMED,eq_Q_Q_GEN_HGEMED,eq_P_Q_GEN_HGEMED,eq_FUEL_PRICE_HGEMED,eq_dL_dPGEN_HGEMED
                 eq_dL_dPPUMPED_HGEMED,eq_dL_RES_HGEMED,eq_dL_PINS_HGEMED,eq_dL_dINSTALLED_CAPACITY_HGEMED
                 eq_dL_dLAMBDA_DEM_HGEMED,eq_dL_dLAMBDA_RES_HGEMED,eq_dL_dLAMBDA_PUMP_EFF_HGEMED
                 eq_dL_dLAMBDA_PUMP_MAX_HGEMED,eq_dL_dLAMBDA_DISPATCHABLE_RESERVES_HGEMED,eq_dL_dLAMBDA_RoR_HGEMED
                 eq_dL_dLAMBDA_FG_FUEL_OIL_USE_HGEMED,eq_dL_dLAMBDA_FG_NATURAL_GAS_USE_HGEMED,eq_dL_dLAMBDA_WIND_HGEMED,eq_dL_dLAMBDA_ORSR_HGEMED
                 eq_dL_dLAMBDA_PINS_CAPACITY_HGEMED,eq_dL_dLAMBDA_PINS_AVAILABILITY_HGEMED

                 eq_7_3_44,
                 eq_7_3_45, eq_7_3_46, eq_7_3_47, eq_7_3_48, eq_7_3_49, eq_7_3_50,
                 eq_7_3_51_a, eq_7_3_51_b, eq_7_3_52, eq_7_3_53, eq_7_3_54, eq_7_3_55,

                 eq_CPI,eq_object_function_HGEMED

                /;

* MCP Model -------------------------------------------------
Model HGEMED_MCP /
                 eq_7_3_1.Q_H_D_HGEMED, eq_7_3_2.Q_H_D_GEN_HGEMED, eq_7_3_3.Q_H_D_TDeO_HGEMED,
                 eq_7_3_4.Y_H_HGEMED, eq_7_3_5.S_TOTAL_H_HGEMED, eq_7_3_6.Q_PF_SNE_LABOR_HGEMED,
                 eq_7_3_7.Q_PF_SNE_CAPITAL_HGEMED, eq_7_3_8.Q_VA_HGEMED, eq_7_3_9.Q_II_HGEMED,
                 eq_7_3_10.Q_II_GEN_SNE_HGEMED, eq_7_3_11.Q_II_TDeO_SNE_HGEMED, eq_7_3_12.P_VA_HGEMED,
                 eq_7_3_13.Q_S_HGEMED, eq_7_3_14.Q_M_HGEMED, eq_7_3_15.P_S_HGEMED,
                 eq_7_3_16.Q_D_HGEMED, eq_7_3_17.Q_EX_HGEMED, eq_7_3_18.P_D_HGEMED,
                 eq_7_3_19.Q_Q_HGEMED, eq_7_3_20_a.Q_PF_LABOR_TDeO_HGEMED, eq_7_3_20_b.Q_PF_CAPITAL_TDeO_HGEMED,
                 eq_7_3_21.Q_VA_TDeO_HGEMED, eq_7_3_22.Q_II_GNE_TDeO_HGEMED, eq_7_3_23.Q_II_GEN_TDeO_HGEMED,
                 eq_7_3_24.Q_II_TDeO_TDeO_HGEMED, eq_7_3_25.P_VA_TDeO_HGEMED, eq_7_3_26.Q_S_TDeO_HGEMED,
                 eq_7_3_27.P_S_TDeO_HGEMED, eq_7_3_28.Q_D_TDeO_HGEMED, eq_7_3_29.P_D_TDeO_HGEMED,
                 eq_7_3_30.Q_Q_TDeO_HGEMED,

                 eq_Q_PF_LABOR_GEN_tech_HGEMED.Q_PF_LABOR_GEN_tech_HGEMED,
                 eq_Q_PF_CAPITAL_GEN_tech_HGEMED.Q_PF_CAPITAL_GEN_tech_HGEMED,
                 eq_Q_II_GNE_GEN_tech_HGEMED.Q_II_GNE_GEN_tech_HGEMED,
                 eq_Q_II_GEN_GEN_tech_HGEMED.Q_II_GEN_GEN_tech_HGEMED,
                 eq_Q_II_TDeO_GEN_tech_HGEMED.Q_II_TDeO_GEN_tech_HGEMED,
                 eq_Q_S_TECH_HGEMED.Q_S_TECH_HGEMED,
                 eq_Q_S_GEN_HGEMED.Q_S_GEN_HGEMED,
                 eq_P_S_GEN_HGEMED.P_S_GEN_HGEMED,


                 eq_Q_Q_GEN_HGEMED.Q_Q_GEN_HGEMED,
                 eq_P_Q_GEN_HGEMED.mkt_surplus_HGEMED,

                 eq_FUEL_PRICE_HGEMED.FUEL_PRICE_HGEMED,

                 eq_dL_dPGEN_HGEMED.PGEN_HGEMED,
                 eq_dL_dPPUMPED_HGEMED.PPUMPED_HGEMED,
                 eq_dL_RES_HGEMED.RES_HGEMED,
                 eq_dL_PINS_HGEMED.PINS_HGEMED,
                 eq_dL_dINSTALLED_CAPACITY_HGEMED.INSTALLED_CAPACITY_HGEMED,
                 eq_dL_dLAMBDA_DEM_HGEMED.LAMBDA_DEM_HGEMED,
                 eq_dL_dLAMBDA_RES_HGEMED.LAMBDA_RES_HGEMED,
                 eq_dL_dLAMBDA_PUMP_EFF_HGEMED.LAMBDA_PUMP_EFF_HGEMED,
                 eq_dL_dLAMBDA_PUMP_MAX_HGEMED.LAMBDA_PUMP_MAX_HGEMED,
                 eq_dL_dLAMBDA_DISPATCHABLE_RESERVES_HGEMED.LAMBDA_DISPATCHABLE_RESERVES_HGEMED,
                 eq_dL_dLAMBDA_RoR_HGEMED.LAMBDA_RoR_HGEMED,
                 eq_dL_dLAMBDA_FG_FUEL_OIL_USE_HGEMED.LAMBDA_FG_FUEL_OIL_USE_HGEMED,
                 eq_dL_dLAMBDA_FG_NATURAL_GAS_USE_HGEMED.LAMBDA_FG_NATURAL_GAS_USE_HGEMED,
                 eq_dL_dLAMBDA_WIND_HGEMED.LAMBDA_WIND_HGEMED,
                 eq_dL_dLAMBDA_ORSR_HGEMED.LAMBDA_ORSR_HGEMED,
                 eq_dL_dLAMBDA_PINS_CAPACITY_HGEMED.LAMBDA_PINS_CAPACITY_HGEMED,
                 eq_dL_dLAMBDA_PINS_AVAILABILITY_HGEMED.LAMBDA_PINS_AVAILABILITY_HGEMED,
                 eq_7_3_44.Y_G_HGEMED,
                 eq_7_3_45.E_G_HGEMED, eq_7_3_46.S_TOTAL_G_HGEMED, eq_7_3_47.Y_TAX_HGEMED,
                 eq_7_3_48.S_TOTAL_HGEMED, eq_7_3_49.S_TOTAL_EXT_HGEMED, eq_7_3_50.Q_I_D_HGEMED,
                 eq_7_3_51_a.P_PF_LABOR_HGEMED, eq_7_3_51_b.P_PF_CAPITAL_HGEMED, eq_7_3_52.P_Q_HGEMED,
                 eq_7_3_53.P_Q_GEN_HGEMED, eq_7_3_54.P_Q_TDeO_HGEMED, eq_7_3_55.I_TOTAL_HGEMED, eq_CPI.CPI_HGEMED

                 eq_extra_1_HGEMED.Y_ENV_TAX_HGEMED,
                 eq_extra_2_HGEMED.SC_ENV_SUBSIDY_RATE_HGEMED,
                 eq_extra_3_HGEMED.LUMP_SUM_ENV_SUBSIDY_HGEMED,
*                 eq_extra_4_HGEMED.RENEWABLE_PREMIUM_TAX_RATE_HGEMED,
*                 eq_extra_5_HGEMED.Y_FUEL_TAX_HGEMED

                /;



* MCP Model -------------------------------------------------
Model HGEMED_MCP_GAD /
                 eq_7_3_1.Q_H_D_HGEMED, eq_7_3_2.Q_H_D_GEN_HGEMED, eq_7_3_3.Q_H_D_TDeO_HGEMED,
                 eq_7_3_4.Y_H_HGEMED, eq_7_3_5.S_TOTAL_H_HGEMED, eq_7_3_6.Q_PF_SNE_LABOR_HGEMED,
                 eq_7_3_7.Q_PF_SNE_CAPITAL_HGEMED, eq_7_3_8.Q_VA_HGEMED, eq_7_3_9.Q_II_HGEMED,
                 eq_7_3_10.Q_II_GEN_SNE_HGEMED, eq_7_3_11.Q_II_TDeO_SNE_HGEMED, eq_7_3_12.P_VA_HGEMED,
                 eq_7_3_13.Q_S_HGEMED, eq_7_3_14.Q_M_HGEMED, eq_7_3_15.P_S_HGEMED,
                 eq_7_3_16.Q_D_HGEMED, eq_7_3_17.Q_EX_HGEMED, eq_7_3_18.P_D_HGEMED,
                 eq_7_3_19.Q_Q_HGEMED, eq_7_3_20_a.Q_PF_LABOR_TDeO_HGEMED, eq_7_3_20_b.Q_PF_CAPITAL_TDeO_HGEMED,
                 eq_7_3_21.Q_VA_TDeO_HGEMED, eq_7_3_22.Q_II_GNE_TDeO_HGEMED, eq_7_3_23.Q_II_GEN_TDeO_HGEMED,
                 eq_7_3_24.Q_II_TDeO_TDeO_HGEMED, eq_7_3_25.P_VA_TDeO_HGEMED, eq_7_3_26.Q_S_TDeO_HGEMED,
                 eq_7_3_27.P_S_TDeO_HGEMED, eq_7_3_28.Q_D_TDeO_HGEMED, eq_7_3_29.P_D_TDeO_HGEMED,
                 eq_7_3_30.Q_Q_TDeO_HGEMED,
$ontext
                 eq_7_3_31_a.Q_PF_LABOR_GEN_tech_HGEMED,
                 eq_7_3_31_b.Q_PF_CAPITAL_GEN_tech_HGEMED, eq_7_3_32.Q_VA_GEN_tech_HGEMED,
                 eq_7_3_33.Q_II_GNE_GEN_tech_HGEMED, eq_7_3_34.Q_II_GEN_GEN_tech_HGEMED,
                 eq_7_3_35.Q_II_TDeO_GEN_tech_HGEMED, eq_7_3_36.P_VA_GEN_tech_HGEMED,
                 eq_7_3_37.Q_S_TECH_HGEMED, eq_7_3_38.P_S_TECH_HGEMED, eq_7_3_39.Q_S_GEN_HGEMED,
                 eq_7_3_40.P_S_GEN_HGEMED, eq_7_3_41.Q_D_GEN_HGEMED,
*                 eq_7_3_42.P_D_GEN_HGEMED,
                 eq_7_3_43.Q_Q_GEN_HGEMED,
$offtext
                 eq_7_3_44.Y_G_HGEMED,
                 eq_7_3_45.E_G_HGEMED, eq_7_3_46.S_TOTAL_G_HGEMED, eq_7_3_47.Y_TAX_HGEMED,
                 eq_7_3_48.S_TOTAL_HGEMED, eq_7_3_49.S_TOTAL_EXT_HGEMED, eq_7_3_50.Q_I_D_HGEMED,
                 eq_7_3_51_a.P_PF_LABOR_HGEMED, eq_7_3_51_b.P_PF_CAPITAL_HGEMED, eq_7_3_52.P_Q_HGEMED,
                 eq_7_3_53.P_Q_GEN_HGEMED, eq_7_3_54.P_Q_TDeO_HGEMED, eq_7_3_55.I_TOTAL_HGEMED, eq_CPI.CPI_HGEMED

****IT HAS TO CHANGE TO REMOVE QD*********                 eq_7_3_42_case_study.P_D_GEN_HGEMED,

                 eq_dL_dPPUMPED.PPUMPED_HGEMED
                 eq_dL_RES_HGEMED.RES_HGEMED
                 eq_dL_PINS.PINS_HGEMED
                 eq_dL_dLAMBDA_DR_DEM.LAMBDA_DEM_HGEMED
                 eq_dL_dLAMBDA_RES.LAMBDA_RES_HGEMED
                 eq_dL_dLAMBDA_PUMP_EFF_HGEMED.LAMBDA_PUMP_EFF_HGEMED
                 eq_dL_dLAMBDA_PUMP_MAX_HGEMED.LAMBDA_PUMP_MAX_HGEMED
                 eq_dL_dLAMBDA_DISPATCHABLE_RESERVES_HGEMED.LAMBDA_DISPATCHABLE_RESERVES_HGEMED
                 eq_dL_dLAMBDA_RoR_HGEMED.LAMBDA_RoR_HGEMED
                 eq_dL_dLAMBDA_FG_FUEL_OIL_USE_HGEMED.LAMBDA_FG_FUEL_OIL_USE_HGEMED
                 eq_dL_dLAMBDA_FG_NATURAL_GAS_USE_HGEMED.LAMBDA_FG_NATURAL_GAS_USE_HGEMED
                 eq_dL_dLAMBDA_WIND_HGEMED.LAMBDA_WIND_HGEMED
                 eq_dL_dLAMBDA_ORSR_HGEMED.LAMBDA_ORSR_HGEMED
                 eq_dL_dLAMBDA_PINS_CAPACITY_HGEMED.LAMBDA_PINS_CAPACITY_HGEMED
                 eq_dL_dLAMBDA_PINS_AVAILABILITY_HGEMED.LAMBDA_PINS_AVAILABILITY_HGEMED
                 eq_dL_dINSTALLED_CAPACITY_HGEMED.INSTALLED_CAPACITY_HGEMED
                 eq_dL_dINCREASED_DR_LOAD_HGEMED.INCREASED_DR_LOAD_HGEMED
                 eq_dL_dDECREASED_DR_LOAD_HGEMED.DECREASED_DR_LOAD_HGEMED
                 eq_dL_dCONSERVED_DR_LOAD_HGEMED.CONSERVED_DR_LOAD_HGEMED
                 eq_dL_dLAMBDA_MAX_DISPL_HGEMED.LAMBDA_MAX_DISPL_HGEMED
                 eq_dL_dLAMBDA_DISPL_BAL_HGEMED.LAMBDA_DISPL_BAL_HGEMED
                 eq_dL_dLAMBDA_CONSERV_LIMIT_HGEMED.LAMBDA_CONSERV_LIMIT_HGEMED
                 eq_dL_dLAMBDA_REQ_SAVINGS_HGEMED.LAMBDA_REQ_SAVINGS_HGEMED

*                 eq_dL_dINCREASED_DR_LOAD_HGEMED.INCREASED_DR_LOAD_HGEMED,
*                 eq_dL_dDECREASED_DR_LOAD_HGEMED.DECREASED_DR_LOAD_HGEMED,
*                 eq_dL_dCONSERVED_DR_LOAD_HGEMED.CONSERVED_DR_LOAD_HGEMED,
*                 eq_maximum_displacement_case_study.LAMBDA_DR_MAX_DISPLACEMENT,
*                 eq_displacement_balance_case_study.LAMBDA_DR_BALANCE,
*                 eq_potency_conservation_limit_case_study.LAMBDA_DR_MAX_CONSERVATION,
*                 eq_minimal_savings_requirement_case_study.LAMBDA_DR_MIN_SAVINGS

*                 eq_extra_1_HGEMED.Y_ENV_TAX_HGEMED,
*                 eq_extra_2_HGEMED.SC_ENV_SUBSIDY_RATE_HGEMED,
*                 eq_extra_3_HGEMED.LUMP_SUM_ENV_SUBSIDY_HGEMED,
*                 eq_extra_4_HGEMED.RENEWABLE_PREMIUM_TAX_RATE_HGEMED,
*                 eq_extra_5_HGEMED.Y_FUEL_TAX_HGEMED
                /;


*-------------------------------------------------------------------------------

HGEMED_NLP.tolinfeas = 1e-7;
WALRAS_HGEMED.fx(ey)=0;
HGEMED_NLP.HOLDFIXED= 1;
HGEMED_MCP.HOLDFIXED= 1;
HGEMED_MCP_GAD.HOLDFIXED= 1;
*OPTION ITERLIM = 0;
option limcol = 1000;
option limrow = 1000;
option nlp=conopt;
option mcp=path;

*PPUMPED_HGEMED.fx(eys,l,p,b)=0;

display availability_factor;


